$(function () {
	$.t = {
		UIDelete : "删除",
		UISubmit : "确定",
		UISearch : "搜索",
		UISearchLoading : "搜索中..",
		UIComplete : "完成",
		UIClear : "清除",
		UICancel : "取消",
		UIDay : "日",
		UIWeek : "周",
		UIYear : "年",
		UIMonth : "月",
		UIHour : "时",
		UIMinute : "分",
		UINumber : ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十"]
	};
	$.html5Draw = {
		color : {
			red : "rgb(255,0,0)",
			green : "rgb(0,255,0)",
			blue : "rgb(0,0,255)",
			black : "rgb(0,0,0)"
		},
		context : {
			width : {},
			height : {},
			cvs : {},
			ctx : {},
			type : {},
			rect : {
				x : {},
				y : {},
				width : {},
				height : {}

			},
			line : {
				x1 : {},
				y1 : {},
				x2 : {},
				y2 : {}

			},
			bz2 : {
				startX : {},
				stratY : {},
				cpX : {},
				cpY : {},
				endX : {},
				endY : {}

			},
			bz3 : {
				startX : {},
				stratY : {},
				cpX : {},
				cpY : {},
				cp2X : {},
				cp2Y : {},
				endX : {},
				endY : {}

			},
			sharps : {},
			fill : function (effect) {
				this.ctx.save();
				if (effect != null) {
					if (effect.color != null) {
						this.ctx.fillStyle = effect.color;
					}
					if (effect.shadow != null) {
						this.ctx.shadowBlur = effect.shadow.blur;
						this.ctx.shadowColor = effect.shadow.color;
						this.ctx.shadowOffsetX = effect.shadow.offsetX;
						this.ctx.shadowOffsetY = effect.shadow.offsetY;
					}
				}
				if (this.type === "rect") {
					this.ctx.fillRect(this.rect.x, this.rect.y, this.rect.width, this.rect.height);
					this.ctx.restore();
				}
				if ((this.type === "circle") || (this.type === "sector")) {
					this.ctx.fill();
					this.ctx.restore();
				}
				return this;
			},
			stroke : function (effect) {
				this.ctx.lineWidth = 1;
				if (effect != null) {
					if (effect.color != null) {
						this.ctx.strokeStyle = effect.color;
					}
					if (effect.lineWidth != null) {
						this.ctx.lineWidth = effect.lineWidth;
					}
					if (effect.shadow != null) {
						this.ctx.shadowBlur = effect.shadow.blur;
						this.ctx.shadowColor = effect.shadow.color;
						this.ctx.shadowOffsetX = effect.shadow.offsetX;
						this.ctx.shadowOffsetY = effect.shadow.offsetY;
					}
				}
				if (this.type === "rect") {
					this.ctx.strokeRect(this.rect.x, this.rect.y, this.rect.width, this.rect.height);
					this.ctx.restore();
				}
				if ((this.type === "circle") || (this.type === "sector")) {
					this.ctx.stroke();
					this.ctx.restore();
				}
				if (this.type === "line") {
					this.ctx.beginPath();
					this.ctx.moveTo(this.line.x1, this.line.y1);
					this.ctx.lineTo(this.line.x2, this.line.y2);
					this.ctx.closePath();
					this.ctx.stroke();
					this.ctx.restore();
				}
				if (this.type === "bz2") {
					this.ctx.beginPath();
					this.ctx.moveTo(this.bz2.startX, this.bz2.startY);
					this.ctx.quadraticCurveTo(this.bz2.cpX, this.bz2.cpY, this.bz2.endX, this.bz2.endY);
					this.ctx.stroke();
					this.ctx.restore();
				}
				if (this.type === "bz3") {
					this.ctx.beginPath();
					this.ctx.moveTo(this.bz3.startX, this.bz3.startY);
					this.ctx.bezierCurveTo(this.bz3.cpX, this.bz3.cpY, this.bz3.cp2X, this.bz3.cp2Y, this.bz3.endX, this.bz3.endY);
					this.ctx.stroke();
					this.ctx.restore();
				}
				return this;
			},
			drawRect : function (x, y, width, height) {
				this.rect.x = x;
				this.rect.y = y;
				this.rect.width = width;
				this.rect.height = height;
				this.type = "rect";
				return this;
			},
			drawLine : function (x1, y1, x2, y2) {
				this.line.x1 = x1;
				this.line.y1 = y1;
				this.line.x2 = x2;
				this.line.y2 = y2;
				this.type = "line";
				return this;
			},
			drawCircle : function (x, y, radius) {
				this.ctx.beginPath();
				this.ctx.lineWidth = 1;
				this.ctx.arc(arguments[0], arguments[1], arguments[2], 0, Math.PI * 2, false);
				this.ctx.closePath();
				this.type = "circle";
				return this;
			},
			drawSector : function (x, y, radius, startAngle, endAngle, anticlockwise) {
				this.ctx.beginPath();
				this.ctx.moveTo(arguments[0], arguments[1]);
				this.ctx.arc(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4], arguments[5]);
				this.ctx.closePath();
				this.type = "sector";
				return this;
			},
			drawBz2 : function (startX, startY, cpX, cpY, endX, endY) {
				this.bz2.startX = startX;
				this.bz2.startY = startY;
				this.bz2.cpX = cpX;
				this.bz2.cpY = cpY;
				this.bz2.endX = endX;
				this.bz2.endY = endY;
				this.type = "bz2";
				return this;
			},
			drawBz3 : function (startX, startY, cpX, cpY, cp2X, cp2Y, endX, endY) {
				this.bz3.startX = startX;
				this.bz3.startY = startY;
				this.bz3.cpX = cpX;
				this.bz3.cpY = cpY;
				this.bz3.cp2X = cp2X;
				this.bz3.cp2Y = cp2Y;
				this.bz3.endX = endX;
				this.bz3.endY = endY;
				this.type = "bz3";
				return this;
			},
			drawText : function (drawArgs) {
				if (drawArgs.textBaseLine != null) {
					this.ctx.textBaseline = drawArgs.textBaseLine;
				}
				if (drawArgs.textAlign != null) {
					this.ctx.textAlign = drawArgs.textAlign;
				}
				if (drawArgs.font != null) {
					var f = "";
					if (drawArgs.font.fontWeight != null) {
						f = drawArgs.font.fontWeight + " ";
					}
					if (drawArgs.font.fontStyle != null) {
						f += drawArgs.font.fontStyle + " ";
					}
					if (drawArgs.font.fontSize != null) {
						f += drawArgs.font.fontSize + "px ";
					}
					if (drawArgs.font.fontFace == null) {
						drawArgs.font.fontFace = "serif";
					}
					if (drawArgs.font.fontFace != null) {
						f += drawArgs.font.fontFace;
					}
					this.ctx.font = f;
				}
				if (drawArgs.type != null) {
					if (drawArgs.type === "fill") {
						this.ctx.fillStyle = drawArgs.color != null ? drawArgs.color : "rgb(0,0,0)";
						this.ctx.fillText(drawArgs.message, drawArgs.xPos, drawArgs.yPos);
					}
					if (drawArgs.type === "stroke") {
						this.ctx.strokeStyle = drawArgs.color != null ? drawArgs.color : "rgb(0,0,0)";
						this.ctx.strokeText(drawArgs.message, drawArgs.xPos, drawArgs.yPos);
					}
					if (drawArgs.type === "both") {
						this.ctx.fillStyle(drawArgs.color != null ? drawArgs.color : "rgb(0,0,0)");
						this.ctx.fillText(drawArgs.message, drawArgs.xPos, drawArgs.yPos);
						this.ctx.strokeStyle(drawArgs.color != null ? drawArgs.color : "rgb(0,0,0)");
						this.ctx.strokeText(drawArgs.message, drawArgs.xPos, drawArgs.yPos);
					}
				}
			},
			clear : function (x, y, width, height) {
				if (arguments.length == 0) {
					this.ctx.clearRect(0, 0, this.cvs.width(), this.cvs.height());
				} else if (arguments.length == 4) {
					this.ctx.clearRect(arguments[0], arguments[1], arguments[2], arguments[3]);
				}
			}
		},
		draw2d : function (canvasId) {
			var canvas = $(canvasId);
			var context = canvas[0].getContext("2d");
			$.html5Draw.context.ctx = context;
			$.html5Draw.context.cvs = canvas;
			$.html5Draw.context.width = canvas.width;
			$.html5Draw.context.height = canvas.height;
			return $.html5Draw.context;
		},
		draw2dRadius : function (degrees) {
			return degrees * (Math.PI / 180);
		}
	};
	$.jsUrl = "../js/global/";
	$.cssUrl = "../css/";
	$.jsCssLoader = function (options, callback) {
		var settings = {
			"links" : [],
			"scripts" : []
		};
		$.extend(settings, options);
		var self = this;
		var count_links = settings.links.length;
		var count_scripts = settings.scripts.length;
		var count_links_complete = 0;
		var count_scripts_complete = 0;
		function hasurl(url) {
			if ($("link[href='" + url + "'],script[src='" + url + "']").size() > 0) {
				return true;
			} else {
				return false;
			}
		}
		$.each(settings.links, function (i) {
			if (hasurl(settings.links[i]) == false) {
				var tag = document.createElement("link");
				tag.href = settings.links[i];
				tag.rel = "stylesheet";
				tag.type = "text/css";
				tag.setAttribute("tag_complete", "no");
				document.getElementsByTagName("head")[0].appendChild(tag);
				if (tag.readyState) {
					tag.onreadystatechange = function () {
						if (this.readyState == "loaded" || this.readyState == "complete") {
							this.onreadystatechange = null;
							tag.setAttribute("tag_complete", "yes");
						}
					};
				} else {
					if (tag.onload) {
						tag.onload = function () {
							tag.setAttribute("tag_complete", "yes");
						};
					} else {
						tag.setAttribute("tag_complete", "yes");
					}
				}
			} else {
				if ($("link[href='" + settings.links[i] + "']:not([tag_complete])").size() > 0) {
					count_links--;
				}
			}
		});
		$.each(settings.scripts, function (i) {
			if (hasurl(settings.scripts[i]) == false) {
				var tag = document.createElement("script");
				tag.src = settings.scripts[i];
				tag.type = "text/javascript";
				tag.setAttribute("tag_complete", "no");
				document.getElementsByTagName("head")[0].appendChild(tag);
				if (tag.readyState) {
					tag.onreadystatechange = function () {
						if (this.readyState == "loaded" || this.readyState == "complete") {
							this.onreadystatechange = null;
							tag.setAttribute("tag_complete", "yes");
						}
					};
				} else {
					tag.onload = function () {
						tag.setAttribute("tag_complete", "yes");
					};
				}
			} else {
				if ($("script[src='" + settings.scripts[i] + "']:not([tag_complete])").size() > 0) {
					count_scripts--;
				}
			}
		});
		var timer = setInterval(function () {
				$.each(settings.links, function (i) {
					if ($("link[href='" + settings.links[i] + "'][tag_complete]").attr("tag_complete") == "yes")
						count_links_complete++;
				});
				$.each(settings.scripts, function (i) {
					if ($("script[src='" + settings.scripts[i] + "'][tag_complete]").attr("tag_complete") == "yes")
						count_scripts_complete++;
				});
				if (count_links_complete >= count_links && count_scripts_complete >= count_scripts) {
					clearInterval(timer);
					callback && callback.call(self);
				}
			}, 1000);
	};
	$.getRandom = function () {
		var d = new Date();
		return d.getTime() + parseInt(Math.random() * 100, 10);
	};
	$.trimDeep = function (str) {
		str = str + "";
		if (str != "") {
			str = $.trim(str.replace(/  */g, ""));
		};
		return str
	};
	$.UILoading = function () {
		var args = arguments;
		var selector = {
			self : "[m-role='UILoading']"
		};
		var _private = {
			_init : function () {
				_private._events();
			},
			_events : function () {
				setTimeout(function () {
					$(selector.self).bind("scrollstart", function () {
						return false
					})
				}, 300);
			},
			_html : function () {
				return ["<div m-role=\"UILoading\">", "<div class=\"UILoadingContent\">", " <div class='UILoadingIco'>","<div class=\"rect1\"></div><div class=\"rect2\"></div><div class=\"rect3\"></div><div class=\"rect4\"></div><div class=\"rect5\"></div>","</div>", " <div class=\"UILoadingContentText\"></div>", "</div>", "</div>"].join("")
			},
			_fn : {
				_html : function () {
					if ($(selector.self).size() == 0) {
						$("body").append(_private._html());
					}
				}
			}
		};
		_private._init();
		var public = {
			show : function () {
				var args = arguments[0];
				_private._fn._html();
				$(selector.self).find(".UILoadingContentText").html(args[1] || "");
				$(selector.self).removeClass("UILoadingMin");
				$(selector.self).addClass('on');
			},
			showMin : function () {
				var args = arguments[0];
				_private._fn._html();
				$(selector.self).addClass("UILoadingMin");
				$(selector.self).find(".UILoadingContentText").html(args[1] || "");
				$(selector.self).addClass('on');
			},
			hide : function () {
				var args = arguments[0];
				var this_self = this;
				$(selector.self).removeClass('on');

				setTimeout(function () {
					$(selector.self).remove();
					clearInterval(window.LoadingCanvas)
				}, 300);
				args[1] && args[1].call(this_self);
			}
		}
		public[args[0]](args);
	};
	$.UIPullDown = function (callback) {
		var self = this;
		$(document).bind("scroll.UIDragDown ", function () {
			var scrolltop = $(document).scrollTop();
			var s = $(document).height() - $(window).height();
			if (scrolltop == s) {
				callback && callback.call(self);
			}
		});
	};
	$.UIPullUp = function (callback) {
		var self = this;
		$(document).bind("scroll.UIPullUp ", function () {
			var scrolltop = $(this).scrollTop();
			if (scrolltop - 5 <= 0) {
				callback && callback.call(self);
			}
		});
	};
	$.UIPopupTimer = 1000;
	$.UIPopup = function (options, callback) {
		var self = this;
		var settings = {
			"html" : "",
			"timer" : $.UIPopupTimer
		}
		if (typeof(options) == "string" || $.isArray(options)) {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		$("body").append("<div m-role=\"UIPopup\">" + settings.html + "</div>");
		var p = $("[m-role='UIPopup']");
		var l = -p.outerWidth() / 2;
		var t = -p.outerHeight() / 2;
		p.css({
			"margin-left" : l,
			"margin-top" : t,
			"top" : "50%",
			"left" : "50%"
		})
		p.animate({
			"opacity" : 1
		}, 200).delay(settings.timer).animate({
			"opacity" : 0
		}, 200, function () {
			$(this).remove();
			callback && callback.call(self);
		})
	};
	$.UIConfirm = function (options, callback) {
		$.UIComfirm(options, callback)
	};
	$.UIComfirm = function (options, callback) {
		var self = this;
		if ($("[m-role='UIComfirm']").size() > 0)
			return;
		var settings = {
			"html" : "",
			"submitText" : $.t.UISubmit,
			"submitStyle" : "confirm",
			"cancelText" : $.t.UICancel,
			"cancelStyle" : "confirm"
		}
		if (typeof(options) == "string") {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		var layout = ["<div m-role=\"UIComfirm\">", "<div class=\"UIComfirmContent\">", "<div m-role=\"cell\" m-mode=\"y\">", "<div m-role=\"cell\" class=\"UIComfirmContentHtml\">", settings.html, "</div>", "<div m-role=\"cell\" m-mode=\"x-equal\" class=\"UIConfirmBtns\">", "<div m-role=\"cell\" m-layout=\"fit\">", "<div m-role=\"UIButton\" m-style=\"" + settings.submitStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIComfirmSubmit\">" + settings.submitText + "</div>", "</div>", "<div m-role=\"cell\" m-layout=\"fit\">", "<div m-role=\"UIButton\" m-style=\"" + settings.cancelStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIComfirmCancel\">" + settings.cancelText + "</div>", "</div>", "</div>", "</div>", "</div>", "</div>"].join("")
		$("body").append(layout);
		var c = $("[m-role='UIComfirm']")
			var p = $(".UIComfirmContent");
		var l = -p.outerWidth() / 2;
		var t = -p.outerHeight() / 2;
		p.css({
			"margin-left" : l,
			"margin-top" : t,
			"top" : "50%",
			"left" : "50%"
		});
		setTimeout(function () {
			p.bind("scrollstart", function () {
				return false
			})
		}, 300);
		$(".UIComfirmSubmit").bind("tap", function () {
			callback && callback.call(self, "yes");
			c_hide();
			return false;
		});
		$(".UIComfirmCancel").bind("tap", function () {
			callback && callback.call(self, "no");
			c_hide();
			return false;
		});
		function c_hide() {
			c.hide();
			setTimeout(function () {
				c.remove()
			}, 200)
		}
	};
	$.UIAlert = function (options, callback) {
		var self = this;
		if ($("[m-role='UIAlert']").size() > 0)
			return;
		var settings = {
			"html" : "",
			"buttonText" : $.t.UISubmit,
			"buttonStyle" : "alert"
		}
		if (typeof(options) == "string") {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		var layout = ["<div m-role=\"UIAlert\">", "<div class=\"UIAlertContent\">", "<div m-role=\"cell\" m-mode=\"y\">", "<div m-role=\"cell\" class=\"UIAlertContentHtml\">", settings.html, "</div>", "<div m-role=\"cell\">", "<div m-role=\"UIButton\" m-style=\"" + settings.buttonStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIAlertSubmit\">" + settings.buttonText + "</div>", "</div>", "</div>", "</div>", "</div>"].join("");
		$("body").append(layout);
		var c = $("[m-role='UIAlert']")
			var p = $(".UIAlertContent");
		setTimeout(function () {
			p.bind("scrollstart", function () {
				return false
			})
		}, 300);
		$(".UIAlertSubmit").bind("tap", function () {
			callback && callback.call(self, "yes");
			c_hide();
			return false;
		});
		function c_hide() {
			c.hide();
			setTimeout(function () {
				c.remove()
			}, 200)
		}
	};

	$.UIAlertEx = function (options, callback) {
		var self = this;
		if ($("[m-role='UIAlert']").size() > 0)
			return;
		var settings = {
			"html" : "",
			"buttonText" : $.t.UISubmit,
			"buttonStyle" : "alert"
		}
		if (typeof(options) == "string") {
			settings.html = options
		} else {
			$.extend(settings, options);
		};
		var layout = ["<div m-role=\"UIAlert\">", "<div class=\"UIAlertContent\">", "<div m-role=\"cell\" m-mode=\"y\">", "<div m-role=\"cell\" class=\"UIAlertContentHtml\">", settings.html, "</div>", "<div m-role=\"cell\">", "<div m-role=\"UIButton\" m-style=\"" + settings.buttonStyle + "\" m-size=\"min\" m-layout=\"fit\" class=\"UIAlertSubmit\">" + settings.buttonText + "</div>", "</div>", "</div>", "</div>", "</div>"].join("");
		$("body").append(layout);
		var c = $("[m-role='UIAlert']")
		var p = $(".UIAlertContent");
		setTimeout(function () {
			p.bind("scrollstart", function () {
				return false
			})
		}, 300);
		$(".UIAlertSubmit").bind("tap", function () {
			callback && callback.call(self, "yes");
			c_hide()
			return false;
		});
		function c_hide() {
			c.hide();
			setTimeout(function () {
				c.remove()
			}, 200)
		}
	};
	$.UIWindow = function () {
		var args = arguments;
		var settings = {
			"width" : 400,
			"height" : 300,
			"html" : "",
			"aftershow" : function () {},
			"afterhide" : function () {}

		}
		var selector = {
			self : "[m-role='UIWindow']"
		};
		var _private = {
			_init : function () {
				_private._events();
			},
			_events : function () {
				setTimeout(function () {
					$(selector.self).bind("scrollstart", function () {
						return false
					})
				}, 300);
			},
			_html : function () {
				return ["<div m-role=\"UIWindow\">", "<div class=\"UIWindowContent\"></div>", "</div>"].join("")
			},
			_fn : {
				_html : function () {
					if ($(selector.self).size() == 0) {
						$("body").append(_private._html());
					}
				}
			}
		};
		_private._init();
		var public = {
			show : function () {
				var args = arguments[0];
				$.extend(settings, args[1]);
				var this_self = this;
				_private._fn._html();
				var p = $(".UIWindowContent");
				var l = -settings.width / 2;
				var t = -settings.height / 2;
				p.css({
					"width" : settings.width,
					"height" : settings.height,
					"margin-left" : l,
					"margin-top" : t,
					"top" : "50%",
					"left" : "50%"
				});
				$(selector.self).animate({
					"opacity" : 1
				}, 200, function () {
					$(selector.self).find(".UIWindowContent").html(settings.html || "");
					$(selector.self).show();
					settings.aftershow && settings.aftershow.call(this_self);
				})
			},
			hide : function () {
				var this_self = this;
				$(selector.self).animate({
					"opacity" : 0
				}, 200, function () {
					$(selector.self).hide();
					setTimeout(function () {
						$(selector.self).remove()
					}, 200)
					settings.afterhide && settings.afterhide.call(this_self);
				})
			}
		}
		public[args[0]](args);
	};
	$.UIBubble = function () {
		var args = arguments;
		var selector = {
			self : "[m-role='UIBubble']"
		};
		var settings = {
			"etarget" : $("body"),
			"width" : 100,
			"height" : 200,
			"html" : "",
			"beforeshow" : function () {},
			"aftershow" : function () {},
			"afterhide" : function () {}

		}
		var _private = {
			_init : function () {
				_private._events();
			},
			_events : function () {
				$(window).bind("resize", function () {
					_private._fn._set_pos();
				})
			},
			_html : function (html) {
				return ["<div m-role=\"UIBubble\" >", "<div class=\"UIBubbleContent\">" + html + "</div>", "<div m-icon=\"arrowbubble\"></div>", "</div>"].join("")
			},
			_fn : {
				_html : function (html) {
					if ($(selector.self).size() == 0) {
						$("body").append(_private._html(html));
					}
				},
				_set_pos : function () {
					settings.width = parseInt(settings.width, 10)
						settings.height = parseInt(settings.height, 10)
						var offset = settings.etarget.offset();
					var arrow = $(selector.self).find(">[m-icon='arrowbubble']");
					var w = settings.etarget.outerWidth();
					var h = settings.etarget.outerHeight();
					var arrow_h = arrow.outerHeight();
					var l = offset.left + (w - settings.width) / 2;
					var t = offset.top + arrow_h + h;
					var arrow_l = settings.width / 2;
					var win_w = $(window).width();
					var win_h = $(window).height();
					if (offset.top - $(document).scrollTop() > win_h / 2) {
						$(selector.self).addClass("UIBubbleDown")
					} else {
						$(selector.self).removeClass("UIBubbleDown")
					}
					if (l <= 0) {
						l = 5;
						arrow_l = w / 2 + offset.left
					}
					if (l + settings.width > win_w) {
						l = win_w - settings.width - 5;
						arrow_l = offset.left + w / 2 - l
					}
					if ($(selector.self).hasClass("UIBubbleDown")) {
						t = t - h - 2 * arrow_h - settings.height;
					}
					$(selector.self).css({
						"left" : l,
						"top" : t
					});
					arrow.css({
						"left" : arrow_l
					});
				}
			}
		};
		_private._init();
		var public = {
			show : function () {
				var args = arguments[0];
				$.extend(settings, args[1]);
				if ($("[m-role='UIBubble']").size() > 0) {
					return;
				}
				_private._fn._html(settings.html);
				$(selector.self).css({
					"width" : settings.width,
					"height" : settings.height
				});
				_private._fn._set_pos();
				settings.beforeshow && settings.beforeshow.call(this);
				$(selector.self).animate({
					"opacity" : 1
				}, 100, function () {
					$(selector.self).show();
					settings.aftershow && settings.aftershow.call(this);
				});
				setTimeout(function () {
					$(document).one("vmousedown.UIBubble", function () {
						$.UIBubble("hide", function () {
							settings.afterhide && settings.afterhide.call(this);
						});
					});
				}, 500)
				$(selector.self).bind("vmousedown.UIBubble", function () {
					return false
				});
				var UISelectionStyleSelector = ["[m-role='UIButton']:not([m-selectionstyle='no'])", "[m-role='UITableView'] dd:not([m-selectionstyle='no'])", ".UIKeyboardKey>li:not([m-selectionstyle='no'])", ".UIKeyboardKeySubmit", ".UIKeyboardKeyCancel", ".UIKeyboardKeyClear", ".UIKeyboardKeyBackspace", ".UISelectMenuView ul li"].join(",")
				$(selector.self).UISelectionStyle({
					"selector" : UISelectionStyleSelector
				});
			},
			hide : function () {
				var args = arguments[0];
				var this_self = this;
				$(selector.self).attr("m-show", "no");
				$(selector.self).animate({
					"opacity" : 0
				}, 100, function () {
					$(selector.self).hide();
					setTimeout(function () {
						$(selector.self).remove()
					}, 200);
					args[1] && args[1].call(this_self);
				})
				$(document).unbind("vmousedown.UIBubble")
			}
		}
		public[args[0]](args);
	};
	$.fn.UICountdown = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UICountdown") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"time" : 5,
							"afterStop" : function () {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).html(main.settings.time)
								main._private._fn._settings_time = main.settings.time;
								main._private._events();
							},
							_events : function () {},
							_html : {},
							_fn : {
								_cd : function () {
									main._private._fn._cd_timer = setTimeout(function () {
											$(self).text(--main._private._fn._settings_time);
											if (main._private._fn._settings_time <= 0) {
												main.settings.afterStop && main.settings.afterStop.call(self);
												return;
											}
											main._private._fn._cd();
										}, 1000)
								}
							}
						},
						public : {
							start : function () {
								main._private._fn._cd();
							},
							pause : function () {},
							stop : function () {},
							clear : function () {
								clearTimeout(main._private._fn._cd_timer)
							},
							destroy : function () {
								$(self).removeData("UICountdown");
							},
							reset : function () {
								$(self).html(main.settings.time);
								main._private._fn._settings_time = main.settings.time;
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UICountdown", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UICountdown");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIGrid = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIGrid") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).find("table").width("100%").wrap("<div class=\"UIGridBody\"></div>");
								var gbody = $(self).find(".UIGridBody");
								var arr = $(self).attr("m-col").split(",");
								var scroll_x = 0;
								gbody.find("tr:first-child th").each(function (i) {
									var w = parseInt(arr[i]);
									var align = "left";
									var valign = "middle";
									var fixclass = "";
									if (arr[i].indexOf("right") > 0)
										align = "right";
									if (arr[i].indexOf("center") > 0)
										align = "center";
									if (arr[i].indexOf("top") > 0)
										valign = "top";
									if (arr[i].indexOf("bottom") > 0)
										valign = "bottom";
									if (arr[i].indexOf("fix-start") > 0)
										fixclass = "UIGridFixedStart";
									if (arr[i].indexOf("fix-end") > 0)
										fixclass = "UIGridFixedEnd";
									$(this).width(w);
									gbody.find("tbody tr :nth-child(" + (i + 1) + ")").css({
										"text-align" : align,
										"vertical-align" : valign
									}).addClass(fixclass);
									gbody.find("thead tr :nth-child(" + (i + 1) + ")").addClass(fixclass);
									scroll_x = scroll_x + w + parseInt($(this).css("padding-left")) + parseInt($(this).css("padding-right"));
								});
								gbody.find("td,th").each(function () {
									$(this).width($(this).width());
									$(this).height($(this).height());
								});
								$(self).attr("m-scrollbar", "no");
								main._private._fn._scroll_x = scroll_x;
								var fix_model = gbody.clone();
								fix_model.find("table").width("auto")
								gbody.find("tbody tr").prepend("<td>&nbsp;</td>");
								gbody.find("tbody tr").append("<td>&nbsp;</td>");
								gbody.find("thead tr").prepend("<th >&nbsp;</th>");
								gbody.find("thead tr").append("<th >&nbsp;</th>");
								main._private._fn._layout();
								$(self).attr("m-scrollx", scroll_x)
								$(self).UIScrollView();
								gbody.find(".UIGridFixedStart,.UIGridFixedEnd").html("")
								gbody.clone().removeClass("UIGridBody").addClass("UIGridHead").appendTo($(self));
								$(self).find(".UIGridHead tbody").remove();
								var ghead = $(self).find(".UIGridHead");
								var th_height = ghead.outerHeight();
								main._private._fn._th_height = th_height;
								fix_model.clone().removeClass("UIGridBody").addClass("UIGridFixStartBody").appendTo($(self));
								var fix_start_body = $(self).find(".UIGridFixStartBody");
								fix_start_body.find("tr :not(.UIGridFixedStart)").remove();
								fix_start_body.clone().removeClass("UIGridFixStartBody").addClass("UIGridFixStartHead").appendTo($(self));
								var fix_start_head = $(self).find(".UIGridFixStartHead");
								fix_start_head.find("tbody").remove();
								fix_start_body.css("top", th_height);
								fix_start_body.find("table").css("margin-top", -th_height)
								fix_model.clone().removeClass("UIGridBody").addClass("UIGridFixEndBody").appendTo($(self));
								var fix_end_body = $(self).find(".UIGridFixEndBody");
								fix_end_body.find("tr :not(.UIGridFixedEnd)").remove();
								fix_end_body.clone().removeClass("UIGridFixEndBody").addClass("UIGridFixEndHead").appendTo($(self));
								var fix_end_head = $(self).find(".UIGridFixEndHead");
								fix_end_head.find("tbody").remove();
								fix_end_body.css("top", th_height);
								fix_end_body.find("table").css("margin-top", -th_height)
								if ($(self).attr("m-placeholder")) {
									setTimeout(function () {
										$(self).append(main._private._html._holder());
									}, 1000)
								}
								var pd = gbody.height() - parseInt($(self).attr("m-height"));
								if (pd <= 0) {
									$(self).find("table tr:last-child td").css("padding-bottom", "+=" + (Math.abs(pd) + 1))
								};
								main._private._events();
							},
							_events : function () {
								var gbody = $(self).find(".UIGridBody").parent(".UIScrollViewScroller");
								var start_body = $(self).find(".UIGridFixStartBody");
								var end_body = $(self).find(".UIGridFixEndBody");
								var ghead = $(self).find(".UIGridHead");
								var th_height = main._private._fn._th_height;
								$(self).UIScrollView("scrollMove", setPos);
								$(self).UIScrollView("scrollEnd", setPos);
								function setPos() {
									ghead.css({
										"left" : this.x
									});
									start_body.css({
										"top" : this.y + th_height
									});
									end_body.css({
										"top" : this.y + th_height
									});
								}
								$(window).bind("resize", function () {
									$(self).css("width", "auto")
									setTimeout(function () {
										main._private._fn._layout();
									}, 200);
								})
							},
							_html : {
								_holder : function () {
									return "<div class=\"UIGridPlaceholder\">" + $(self).attr("m-placeholder") + "</div>"
								}
							},
							_fn : {
								_th_height : 0,
								_scroll_x : 0,
								_layout : function () {
									var scroll_x = main._private._fn._scroll_x;
									var self_w = parseInt($(self).attr("m-width")) || $(self).width();
									$(self).css({
										"width" : self_w,
										"height" : $(self).attr("m-height")
									});
									var gbody = $(self).find(".UIGridBody");
									var ghead = $(self).find(".UIGridHead");
									var s_w = scroll_x + self_w * 2;
									gbody.width(s_w);
									ghead.width(s_w);
									gbody.find("thead tr th:first-child,thead tr th:last-child").css({
										"width" : self_w,
										"padding-left" : 0,
										"padding-right" : 0
									});
									ghead.find("thead tr th:first-child,thead tr th:last-child").css({
										"width" : self_w,
										"padding-left" : 0,
										"padding-right" : 0
									});
									gbody.css("margin-left", -self_w);
									ghead.css("margin-left", -self_w);
								}
							}
						},
						public : {
							destroy : function () {
								$(self).removeData("UIGrid");
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIGrid", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIGrid");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIKeyboard = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIKeyboard") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"leftButton" : "",
							"rightButton" : "",
							"type" : "number"
						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).append(main._private._html._text());
								$(self).find(".UIKeyboardText").html($(self).attr("m-value"));
								main._private._fn._set_val($(self).attr("m-value"));
								main._private._events();
							},
							_events : function () {
								$(self).bind("tap.UIKeyboard", function () {
									$(self).addClass("UIKeyboardOn");
									$.UIBubble("show", {
										"etarget" : $(this),
										"width" : 304,
										"height" : 168,
										"html" : main._private._html._keyboard(),
										"beforeshow" : function () {
											if (window.screen.width <= 1080) {
												$("[m-role='UIBubble']").addClass("UIKeyboardBubblePhone")
											};
										},
										"afterhide" : function () {
											main._private._fn._hide();
										}
									});
									$(".UIKeyboardView>.UIKeyboardKey>li:not([m-selectionstyle='no'])").unbind().bind("tap.UIKeyboard", function () {
										var key = $(this).text();
										var val = $(self).attr("m-value") || "";
										val = main._private._fn._check(key, val);
										main._private._fn._set_val(val);
										return false
									});
									$(".UIKeyboardKeySubmit,.UIKeyboardKeyCancel").unbind().bind("tap.UIKeyboard", function () {
										main._private._fn._hide();
										return false
									});
									$(".UIKeyboardKeyClear").unbind().bind("tap.UIKeyboard", function () {
										main._private._fn._set_val("");
										return false
									});
									$(".UIKeyboardKeyBackspace").unbind().bind("tap.UIKeyboard", function () {
										var val = $(self).attr("m-value") || "";
										if (val == "")
											return;
										val = val.substring(0, val.length - 1);
										main._private._fn._set_val(val);
										return false
									});
									return false;
								});
							},
							_html : {
								_text : function () {
									return "<span class=\"UIKeyboardText\"></span>"
								},
								_keyboard : function () {
									var leftStyle = "";
									var rightStyle = "";
									var s = "m-selectionstyle=\"no\"";
									if (main.settings.leftButton == "") {
										leftStyle = s
									};
									if (main.settings.rightButton == "") {
										rightStyle = s
									};
									main.settings
									return ["<div class=\"UIKeyboardView\"  >", "<ul class=\"UIKeyboardKey\">", "<li>1</li>", "<li>2</li>", "<li>3</li>", "<li>4</li>", "<li>5</li>", "<li>6</li>", "<li>7</li>", "<li>8</li>", "<li>9</li>", "<li " + leftStyle + ">" + main.settings.leftButton + "</li>", "<li>0</li>", "<li " + rightStyle + ">" + main.settings.rightButton + "</li>", "</ul>", "<div class=\"UIKeyboardKeySubmit\" >" + $.t.UIComplete + "</div>", "<div class=\"UIKeyboardKeyCell\" ></div>", "<div class=\"UIKeyboardKeyClear\" >" + $.t.UIClear + "</div>", "<div class=\"UIKeyboardKeyBackspace\" ><div></div></div>", "</div>"].join("")
								}
							},
							_fn : {
								_hide : function () {
									$(self).removeClass("UIKeyboardOn");
									$.UIBubble("hide", function () {
										var val = $(self).attr("m-value") || "";
										if (val == "")
											return;
										if ($(self).attr("m-tofixed")) {
											val = parseFloat(val).toFixed($(self).attr("m-tofixed") || 0)
										};
										main._private._fn._set_val(val);
									});
									main.public.set_callback && main.public.set_callback.call(self)
								},
								_check : function (key, val) {
									if (main.settings.type == "money") {
										if (key == "." && (val.indexOf(".") != -1 || val == "")) {
											key = "";
										}
										if (val.indexOf(".") != -1 && val.split(".")[1].length >= $(self).attr("m-tofixed")) {
											key = "";
										}
										if (val.indexOf(".") != -1 && (val.split(".")[1].length == $(self).attr("m-tofixed") - 1) && key == "00") {
											key = "0";
										}
										if (val == "0" && key != ".") {
											val = ""
										};
										if (val == "" && key == "00") {
											key = "0"
										};
									}
									val = val + key + ""
										var maxvalue = parseFloat($(self).attr("m-maxvalue"));
									var maxlength = parseFloat($(self).attr("m-maxlength"));
									var a = val;
									if (val != "") {
										a = parseFloat(a);
										if (a > maxvalue)
											val = maxvalue;
										var vl = val.length;
										if (vl > maxlength) {
											val = val.substring(0, maxlength);
										}
									}
									return val
								},
								_set_val : function (val) {
									$(self).find("input").val(val);
									var format_val = main.settings.type == "money" ? fstring(val) : val;
									function fstring(input, offset, insert, from) {
										if (!insert) {
											insert = ',';
										}
										if (!offset) {
											offset = 3;
										}
										input = '' + input;
										var rstring = '(\\d{1,' + offset + '})(?=(\\d{' + offset + '})+(?:$|\\.))';
										if (from) {
											rstring = '((\\d{' + offset + '})+?)';
										}
										var regex = new RegExp(rstring, 'g');
										var result = input.replace(regex, "$1" + insert);
										return result;
									}
									$(self).attr({
										"m-value" : val,
										"value" : val
									});
									var ktxt = $(self).find(".UIKeyboardText");
									ktxt.html(format_val);
									if (main.settings.type == "password") {
										ktxt.css({
											"font-size" : "20px",
											"line-height" : "38px"
										})
										main._private._fn._val2psw(ktxt);
									}
									var ipt = $(self).find("input");
									if (val != "") {
										ipt.hide();
									} else {
										ipt.show();
									};
									main.public.change_callback && main.public.change_callback.call(self, val)
								},
								_val2psw : function (obj) {
									var l = obj.text().replace(/./g, '*');
									obj.text(l)
								}
							}
						},
						public : {
							destroy : function () {
								$(self).removeData("UIKeyboard");
							},
							set : function () {
								var args = arguments[0];
								main.public.set_callback = args[1];
							},
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIKeyboard", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIKeyboard");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIGallery = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIGallery") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								var li = $(self).find(">ul>li");
								var w = $(self).attr("m-item-width");
								var h = $(self).attr("m-item-height");
								var imgw = $(self).attr("m-image-width");
								var imgh = $(self).attr("m-image-height");
								li.find("img").wrap(main._private._html._img_wrap())
								li.width(w);
								li.height(h);
								$(self).find(".UIGalleryImgWrap").css({
									"width" : imgw,
									"height" : imgh,
									"background-size" : imgw + "px " + imgh + "px"
								})
								setTimeout(function () {
									li.each(function () {
										var img = $(this).find("img");
										var img_url = img.attr("src");
										$(this).find(".UIGalleryImgWrap").css("background-image", "url(" + img_url + ")");
									})
								}, 500)
								main._private._events();
							},
							_events : function () {},
							_html : {
								_img_wrap : function () {
									return "<div class=\"UIGalleryImgWrap\"></div>"
								}
							},
							_fn : {}

						},
						public : {
							destroy : function () {
								$(self).removeData("UIGallery");
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIGallery", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIGallery");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UISelectMenu = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UISelectMenu") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								if ($(self).find("li[m-selected='yes']").size() == 0) {
									$(self).find("li").first().attr("m-selected", "yes");
								}
								var slc = $(self).find("[m-selected='yes']");
								var text = slc.text();
								$(self).attr("m-value", slc.attr("m-value"))
								$(self).html(main._private._html._self_html(text, $(self).html()));
								main._private._events();
							},
							_events : function () {
								var UISelectMenuContent = $(self).find(".UISelectMenuContent");
								$(self).bind("tap.UISelectMenu", function () {
									$.UIBubble("show", {
										"etarget" : $(self),
										"width" : $(self).attr("m-menu-width"),
										"height" : $(self).attr("m-menu-height"),
										"html" : main._private._html._menu(UISelectMenuContent.html())
									});
									$(".UISelectMenuView").UIScrollView();
									$(".UISelectMenuView ul li").bind("tap.UISelectMenu", function () {
										var this_self = this;
										var old_val = (UISelectMenuContent.find("[m-selected='yes']").attr("m-value"));
										$(this_self).parent().find("li").removeAttr("m-selected");
										$(this_self).attr("m-selected", "yes");
										var lis = $(".UISelectMenuView ul").html();
										$.UIBubble("hide", function () {
											$(self).find(".UISelectMenuText").html($(this_self).text());
											UISelectMenuContent.find("ul").html(lis);
											var new_value = $(this_self).attr("m-value");
											$(self).attr("m-value", new_value)
											if (old_val != new_value) {
												main.public.change_callback && main.public.change_callback.call(this_self, new_value)
											}
										})
										return false;
									})
								});
							},
							_html : {
								_menu : function (html, id) {
									return ["<div class=\"UISelectMenuView\" m-scrollbar=\"yes\" >", html, "</div>"].join("")
								},
								_self_html : function (text, html) {
									return ["<div class=\"UISelectMenuText\">" + text + "</div>", "<div class=\"UISelectMenuContent\">" + html + "</div>", "<div m-icon=\"arrowdown\"></div>"].join("")
								}
							},
							_fn : {}

						},
						public : {
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							destroy : function () {
								$(self).removeData("UISelectMenu");
							},
							value : function () {
								var args = arguments[0];
								var args_length = args.length;
								if (args_length == 1) {
									main.public.get_value = $(self).attr("m-value")
								}
								if (args_length == 2) {}

							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UISelectMenu", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UISelectMenu");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIScrollView = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIScrollView") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								var ran = $.getRandom();
								$(self).css("max-width", $(window).width())
								var wrapper_id = "c" + ran + "Wrapper";
								var scroller_id = "c" + ran + "Scroller";
								$(self).attr("id", wrapper_id);
								$(self).wrapInner("<div class=\"UIScrollViewScroller\"  id=\"" + scroller_id + "\"></div>");
								var scroll_dom = $(self).find(".UIScrollViewScroller");
								scroll_dom.width($(self).attr("m-scrollx"));
								var jscssurl = {
									"scripts" : [$.jsUrl + "iscroll5-min.js"]
								};
								$.jsCssLoader(jscssurl, function () {
									var free_scroll = false;
									if ($(self).attr("m-freescroll") == "yes") {
										free_scroll = true;
									}
									var myScroll = new IScroll("#" + wrapper_id, {
											preventDefault : false,
											scrollX : true,
											scrollY : true,
											scrollbars : "custom",
											probeType : 3,
											mouseWheel : true,
											interactiveScrollbars : true,
											freeScroll : free_scroll
										});
									main.myScroll = myScroll;
									myScroll.on('scroll', function () {
										main.public.scrollMove_callback && main.public.scrollMove_callback.call(this)
									});
									myScroll.on('scrollEnd', function () {
										main.public.scrollEnd_callback && main.public.scrollEnd_callback.call(this)
									});
									var bar = $(self).find(".iScrollVerticalScrollbar,.iScrollHorizontalScrollbar");
									bar.css({
										opacity : 1
									});
									if ($(self).attr("m-scrollbar") != "yes") {
										bar.css({
											opacity : 0
										});
									}
									main._private._events();
								})
							},
							_events : function () {
								$(self).bind("touchmove", function (event) {
									event.preventDefault();
								});
							},
							_html : {},
							_fn : {}

						},
						myScroll : "",
						public : {
							scrollMove : function () {
								var args = arguments[0];
								main.public.scrollMove_callback = args[1];
							},
							scrollEnd : function () {
								var args = arguments[0];
								main.public.scrollEnd_callback = args[1];
							},
							refresh : function () {},
							destroy : function () {
								$(self).removeData("UIScrollView");
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIScrollView", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIScrollView");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIPageControl = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIPageControl") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UIPageControl");
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								if ($(self).attr("m-indicator") != "none") {
									$(self).append(main._private._html._indicator());
								}
								setTimeout(function () {
									$(self).css("max-width", $(window).width())
									main._private._events();
								}, 200)
							},
							_events : function () {
								var self_w = $(self).width();
								var list_dom = $(self).find(">ul");
								var item_dom = $(self).find(">ul>li");
								var indi_dom = $(self).find(".UIPageControlIndicator dd");
								var item_w = $(self).attr("m-item-width") || self_w;
								var item_n = item_dom.size();
								item_dom.width(item_w);
								main._private._fn._current_index = $(self).attr("m-index") || 0;
								indi_dom.eq(main._private._fn._current_index).addClass("UIPageControlIndicatorOn");
								var first_left = (self_w - item_w) / 2;
								var pos = [];
								item_dom.each(function (i) {
									pos.push(first_left - i * item_w)
								})
								main._private._fn._pos = pos;
								list_dom.css("left", pos[main._private._fn._current_index])
								if ($(self).attr("m-autoplay") == "yes") {
									main._private._fn._autoplay();
								}
								$(self).bind("vmousedown.UIPageControl", function (event) {
									if ($(self).attr("m-autoplay") == "yes") {
										clearTimeout(main._private._fn._autoplay_timer)
										clearTimeout(main._private._fn._autoplay_timer_begin)
									}
									var point = {
										start : function (event) {
											var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
											return {
												coords : [data.pageX, data.pageY],
												origin : $(event.target)
											};
										},
										stop : function (event) {
											var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
											return {
												coords : [data.pageX, data.pageY]
											};
										}
									}
									var list_left = parseInt(list_dom.css("left"), 10);
									var start = point.start(event);
									var scrolling = false;
									var begin = false;
									$(document).bind("vmousemove.UIPageControl", function (event) {
										var stop = point.stop(event);
										if (Math.abs(start.coords[1] - stop.coords[1]) > 10 && begin == false) {
											scrolling = true
										}
										if (Math.abs(start.coords[0] - stop.coords[0]) > 5 && scrolling == false) {
											begin = true;
											var n = 0.8;
											var this_list_left = list_dom.position().left;
											var move_d = (stop.coords[0] - start.coords[0]) * n;
											list_dom.css("left", list_left + move_d);
											event.preventDefault();
										}
									});
									$(document).one("vmouseup.UIPageControl", function (event) {
										$(document).unbind("vmousemove.UIPageControl");
										if ($(self).attr("m-autoplay") == "yes") {
											clearTimeout(main._private._fn._autoplay_timer);
											clearTimeout(main._private._fn._autoplay_timer_begin);
											main._private._fn._autoplay_timer_begin = setTimeout(function () {
													main._private._fn._autoplay()
												}, 1000);
										}
										var m = 80;
										var this_left = list_dom.position().left;
										if (this_left >= pos[0]) {
											main._private._fn._flex(0)
											return
										}
										if (this_left <= pos[item_n - 1]) {
											main._private._fn._flex(item_n - 1)
											return
										}
										var this_index = main._private._fn._current_index;
										var m_d = start.coords[0] - point.stop(event).coords[0];
										if (m_d > m) {
											this_index = parseInt(main._private._fn._current_index) + 1;
										}
										if (m_d < -m) {
											this_index = parseInt(main._private._fn._current_index) - 1;
										}
										main._private._fn._flex(this_index, item_w - Math.abs(m_d))
									})
								})
							},
							_html : {
								_indicator : function () {
									var html = ""
										$(self).find("ul>li").each(function (i) {
											if ($(self).attr("m-indicator") == "number") {
												i = i + 1
													html = html + 　 "<dd>" + i + "</dd>"
											} else if ($(self).attr("m-indicator") == "text") {
												html = html + 　 "<dd>" + $(this).attr("m-indicator-text") + "</dd>"
											} else {
												html = html + 　 "<dd></dd>"
											}
										})
										return "<dl class=\"UIPageControlIndicator\">" + html + "</dl>";
								}
							},
							_fn : {
								_current_index : 0,
								_pos : [],
								_autoplay_d : 1,
								_flex : function (index, time) {
									time = time || 250;
									var list_dom = $(self).find(">ul");
									var indi_dom = $(self).find(".UIPageControlIndicator dd");
									var old_index = main._private._fn._current_index;
									main._private._fn._current_index = index;
									list_dom.stop().animate({
										"left" : main._private._fn._pos[index]
									}, time, function () {
										indi_dom.removeClass("UIPageControlIndicatorOn");
										indi_dom.eq(index).addClass("UIPageControlIndicatorOn");
										if (old_index != index) {
											main.public.change_callback && main.public.change_callback.call(this, index)
										}
									})
								},
								_autoplay : function () {
									var timer = $(self).attr("m-timer") || 2000;
									var index = parseInt(main._private._fn._current_index);
									set_d();
									main._private._fn._autoplay_timer = setInterval(function () {
											if (main._private._fn._autoplay_d == 1) {
												index++
											}
											if (main._private._fn._autoplay_d == 0) {
												index--
											}
											set_d();
											main._private._fn._flex(index)
										}, parseInt(timer, 10));
									function set_d() {
										if (index == 0) {
											main._private._fn._autoplay_d = 1
										}
										if (index == main._private._fn._pos.length - 1) {
											main._private._fn._autoplay_d = 0
										}
									}
								},
								_prev_page : function () {
									var current_index = parseInt(main._private._fn._current_index);
									if ((current_index - 1) < 0)
										return;
									main._private._fn._flex(current_index - 1)
								},
								_next_page : function () {
									var current_index = parseInt(main._private._fn._current_index);
									if ((current_index + 1) > main._private._fn._pos.length - 1)
										return;
									main._private._fn._flex(current_index + 1);
								}
							}
						},
						public : {
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							prevPage : function () {
								main._private._fn._prev_page();
							},
							nextPage : function () {
								main._private._fn._next_page();
							},
							destroy : function () {
								$(self).removeData("UIPageControl");
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIPageControl", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIPageControl");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIPercentBar = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIPercentBar") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UIPercentBar");
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).html(main._private._html._percent());
								main._private._events();
							},
							_events : function () {
								$(self).bind("click", function () {
									main.public.demo_callback && main.public.demo_callback.call(this);
								})
							},
							_html : {
								_percent : function () {
									return "<div class=\"UIPercentBarCon\"><span>0%</span></div><span>0%</span>"
								}
							},
							_fn : {
								_set_num : function (b) {
									var a = parseFloat($(self).find("span").html());
									var u = "";
									if ((b + "").indexOf("%") != -1) {
										u = "%"
									}
									b = parseFloat(b);
									$(self).find("span").html(b + u)
									function change_num_r() {
										setTimeout(function () {
											$(self).find("span").html(--a + u);
											if (a <= b) {
												$(self).find("span").html(b + u);
												return
											}
											change_num_r();
										}, 10)
									}
									function change_num_a() {
										setTimeout(function () {
											$(self).find("span").html(++a + u);
											if (a >= b) {
												$(self).find("span").html(b + u);
												return
											}
											change_num_a();
										}, 10)
									}
								}
							}
						},
						public : {
							value : function () {
								var args = arguments[0];
								$(self).find(".UIPercentBarCon").stop().animate({
									"width" : args[1]
								}, 400);
								main._private._fn._set_num(args[1]);
							},
							destroy : function () {
								$(self).removeData("UIPercentBar");
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIPercentBar", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIPercentBar");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UICheckBox = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UICheckBox") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("m-name");
					var selector = {
						checkboxes : "[m-name='" + rel + "']"
					};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								main._private._events();
							},
							_events : function () {
								$(self).bind("tap.UICheckBox", function () {
									if ($(this).attr("m-checked") == "yes") {
										$(this).removeAttr("m-checked")
									} else {
										$(this).attr("m-checked", "yes")
									}
								})
							},
							_html : {},
							_fn : {}

						},
						public : {
							destroy : function () {
								$(self).removeData("UICheckBox");
							},
							value : function () {
								var arr = [];
								$(selector.checkboxes + "[m-checked='yes']").each(function () {
									arr.push($(this).attr("m-value"));
								})
								main.public.get_value = arr;
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UICheckBox", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UICheckBox");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIRadio = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIRadio") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("m-name");
					var selector = {
						radios : "[m-name='" + rel + "']"
					};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								main._private._events();
							},
							_events : function () {
								$(self).bind("tap.UIRadio", function () {
									var $this = $(this);
									var old_state = $this.attr("m-checked");
									$(selector.radios).removeAttr("m-checked");
									$this.attr("m-checked", "yes");
									if (old_state != "yes") {
										main.public.tapEvent && main.public.tapEvent.call(this, {value: $this.attr("m-value"), key:$this.html()});
									}
								})
							},
							_html : {},
							_fn : {}

						},
						public : {
							destroy : function () {
								$(self).removeData("UIRadio");
							},
							value : function () {
								main.public.get_value = $(selector.radios + "[m-checked='yes']").attr("m-value");
							},
							key : function() {
								main.public.get_value = $(selector.radios + "[m-checked='yes']").html();
							},
							change : function() {
								main.public.tapEvent = arguments[0][1];
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIRadio", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIRadio");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UICalendarField = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UICalendarField") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UICalendarField");
					var selector = {};
					var main = {
						settings : {
							theme : 'android-ics light',
							accent : ' ',
							dateFormat : "yy-mm-dd",
							lang : 'zh',
							display : 'bubble',
							animate : ' ',
							controls : ['calendar'],
							marked : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).append(main._private._html._input());
								var value = $(self).attr("m-value") || $(self).attr("value");
								if (value == undefined) {
									value = ""
								}
								$(self).attr({
									"m-value" : value,
									"value" : value
								});
								$(self).find("input").val(value);
								if ($(self).attr("m-display")) {
									main.settings.display = $(self).attr("m-display");
								}
								if ($(self).attr("m-marked")) {
									var date = $(self).attr("m-marked").split(",");
									var date_arr = [];
									$.each(date, function (i, v) {
										v = v.split("-")
											var d = new Date(v[0], v[1] - 1, v[2]);
										date_arr.push(d)
									})
									main.settings.marked = {
										"dates" : date_arr
									};
								}
								var jscssurl = {
									"links" : [$.cssUrl + "mobiscroll.custom-2.5.0.min.css"],
									"scripts" : [$.jsUrl + "mobiscroll.calendarmarked-2.5.0.js"]
								};
								$.jsCssLoader(jscssurl, function () {
									$(self).mobiscroll().calendar(main.settings);
									var today = $(self).attr("m-today")
										$("[data-full='" + today + "']").addClass("UICalendarFieldToday")
										main._private._events();
								})
							},
							_events : function () {
								$(self).on("input change keyup", "input", function () {
									main._private._fn._change();
								});
								$(document).on("tap.UICalendarField", ".dw-calendar .dw-cal-day:has(.dw-cal-day-m)", function () {
									main.public.markTap_callback && main.public.markTap_callback.call(this, $(self).attr("m-value"))
								})
							},
							_html : {
								_input : function () {
									return ["<input type=\"text\" value=\"" + ($(self).attr("m-value") || "") + "\" />", "<div class=\"UICalendarFieldHandler\"></div>", "<div m-icon=\"calendar\"></div>"].join("");
								}
							},
							_fn : {
								_change : function () {
									var v = $(self).find("input").val();
									main.public.change_callback && main.public.change_callback.call(this, v)
									$(self).attr({
										"m-value" : v,
										"value" : v
									});
								}
							}
						},
						public : {
							destroy : function () {
								$(self).removeData("UICalendarField");
							},
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							clear : function () {
								$(self).find("input").val("");
								$(self).attr({
									"m-value" : "",
									"value" : ""
								});
							},
							markTap : function () {
								var args = arguments[0];
								main.public.markTap_callback = args[1];
							},
							value : function () {
								var args = arguments[0];
								var args_length = args.length;
								if (args_length == 1) {
									main.public.get_value = $(self).find("input").val();
								}
								if (args_length == 2) {
									$(self).find("input").val(args[1]);
									$(self).attr({
										"m-value" : args[1],
										"value" : args[1]
									});
									main._private._fn._change();
								}
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UICalendarField", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UICalendarField");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIDateField = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIDateField") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UIDateField");
					var selector = {};
					var main = {
						settings : {
							dateFormat : "yy-mm-dd",
							dateOrder : "yyMMdd",
							timeWheels : 'HHii',
							timeFormat : 'HH:ii',
							theme : "android-ics light",
							setText : $.t.UIComplete,
							cancelText : $.t.UICancel,
							monthNames : ["1" + $.t.UIMonth, "2" + $.t.UIMonth, "3" + $.t.UIMonth, "4" + $.t.UIMonth, "5" + $.t.UIMonth, "6" + $.t.UIMonth, "7" + $.t.UIMonth, "8" + $.t.UIMonth, "9" + $.t.UIMonth, "10" + $.t.UIMonth, "11" + $.t.UIMonth, "12" + $.t.UIMonth],
							dayNames : [$.t.UIWeek + $.t.UIDay, $.t.UIWeek + $.t.UINumber[0], $.t.UIWeek + $.t.UINumber[1], $.t.UIWeek + $.t.UINumber[2], $.t.UIWeek + $.t.UINumber[3], $.t.UIWeek + $.t.UINumber[4], $.t.UIWeek + $.t.UINumber[5]],
							dayUnit : $.t.UIDay,
							yearUnit : $.t.UIYear,
							mode : "scroller",
							display : "bubble",
							preset : 'date',
							monthText : $.t.UIMonth,
							dayText : $.t.UIDay,
							yearText : $.t.UIYear,
							hourText : $.t.UIHour,
							minuteText : $.t.UIMinute,
							minDate : new Date(new Date().getFullYear() - 5, 0, 0, 0, 0),
							maxDate : new Date(new Date().getFullYear() + 10, 0, 0, 0, 0),
							stepMinute : 1
						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								if ($(window).width() <= 400) {
									main.settings.display = "bottom";
								}
								$(self).append(main._private._html._input());
								var value = $(self).attr("m-value") || $(self).attr("value");
								if (value == undefined) {
									value = ""
								}
								$(self).attr({
									"m-value" : value,
									"value" : value
								});
								$(self).find("input").val(value);
								if ($(self).attr("m-min")) {
									var min_date = $(self).attr("m-min").split("-");
									main.settings.minDate = new Date(min_date[0], min_date[1] - 1, min_date[2], 0, 0)
								}
								if ($(self).attr("m-max")) {
									var max_date = $(self).attr("m-max").split("-");
									main.settings.maxDate = new Date(max_date[0], max_date[1] - 1, max_date[2], 0, 0)
								}
								if ($(self).attr("m-preset")) {
									main.settings.preset = $(self).attr("m-preset");
									if (main.settings.preset == "time") {
										main.settings.maxDate = "";
										main.settings.minDate = ""
									}
								}
								if ($(self).attr("m-stepminute")) {
									main.settings.stepMinute = parseInt($(self).attr("m-stepminute"), 10);
								}
								var jscssurl = {
									"links" : [$.cssUrl + "mobiscroll.custom-2.5.0.min.css"],
									"scripts" : [$.jsUrl + "mobiscroll.datetime-2.5.0.js"]
								};
								$.jsCssLoader(jscssurl, function () {
									$(self).mobiscrollDatatime(main.settings);
									main._private._events();
								})
							},
							_events : function () {
								$(self).on("input change keyup", "input", function () {
									main._private._fn._change();
								});
							},
							_html : {
								_input : function () {
									return ["<input type=\"text\" value=\"" + ($(self).attr("m-value") || "") + "\"  placeholder=\"" + ($(self).attr("m-placeholder") || "") + "\"/>", "<div class=\"UIDateFieldHandler\"></div>", "<div m-icon=\"calendar\"></div>"].join("");
								}
							},
							_fn : {
								_change : function () {
									var v = $(self).find("input").val();
									main.public.change_callback && main.public.change_callback.call(this, v)
									$(self).attr({
										"m-value" : v,
										"value" : v
									});
								}
							}
						},
						public : {
							demo : function () {
								var args = arguments[0];
								main.public.demo_callback = args[1];
							},
							destroy : function () {
								$(self).removeData("UIDateField");
							},
							clear : function () {
								$(self).find("input").val("");
								$(self).attr({
									"m-value" : "",
									"value" : ""
								});
							},
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							value : function () {
								var args = arguments[0];
								var args_length = args.length;
								if (args_length == 1) {
									main.public.get_value = $(self).find("input").val();
								}
								if (args_length == 2) {
									$(self).find("input").val(args[1]);
									$(self).attr({
										"m-value" : args[1],
										"value" : args[1]
									});
									main._private._fn._change();
								}
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UIDateField", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIDateField");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UISelectionStyle = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UISelectionStyle") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UISelectionStyle");
					var selector = {};
					var main = {
						settings : {
							"selector" : "dd:not([UISelectionStyle='no'])",
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								main._private._events();
							},
							_events : function () {
								var click_light;
								var light = "UISelectionStyle";
								$(self).on("vmousedown.UISelectionStyle", main.settings.selector, function (e) {
									var self = $(this)
										if ($(e.target).attr("m-icon") == "arrowbutton") {
											return false
										}
										click_light = setTimeout(function () {
											self.addClass(light)
										}, 30);
								})
								$(self).on("vmousemove.UISelectionStyle vmouseup.UISelectionStyle", main.settings.selector, function () {
									clearTimeout(click_light)
									$(this).removeClass(light);
								});
								$(self).on("tap.UISelectionStyle", main.settings.selector, function () {
									setTimeout(function () {
										$(this).removeClass(light)
									}, 10);
								});
							},
							_html : {},
							_fn : {}

						},
						public : {
							destroy : function () {
								$(self).removeData("UISelectionStyle");
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UISelectionStyle", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UISelectionStyle");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UISwitch = function(options, callback) {
		var args = arguments;
		var $val,
			$return = this.each(function() {
				var self = this;
				if ($(self).data("UISwitch") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("UISwitch");
					var selector = {};
					var main = {
						settings: {
							"data": {}

						},
						_private: {
							_init: function() {
								$.extend(main.settings, options);
								var value = $(self).attr("m-value") || $(self).attr("value");
								var texton = $(self).attr("m-on") || "";
								var textoff = $(self).attr("m-off") || "";
								if (value == undefined) {
									value = 0
								};
								value = parseInt(value, 10);
								$(self).find(".UISwitchHiddenInput").attr("name", $(self).attr("name"));
								$(self).attr({
									"m-value": value,
									"value": value
								});
								$(self).html(main._private._html._layout(texton, textoff));
								$(self).append(main._private._html._hidden_input(value));
								var init_val = 1;
								if (value == 1) {
									init_val = 0
								}
								main._private._fn._set_state(init_val, "init");
								main._private._events();
							},
							_events: function() {
								var has_drag = false;
								var btn = $(self).find(".UISwitchButton");
								var texton = $(self).find(".UISwitchOn");
								var textoff = $(self).find(".UISwitchOff");
								var self_w = $(self).width();
								var btn_w = btn.outerWidth();
								$(self).bind("tap.UISwitch", tap_switch);

								function tap_switch() {
									main._private._fn._set_state($(self).attr("m-value"));
									return false
								}
								$(self).bind("touchstart.UISwitch", function(event) {
									var point = {
										start: function(event) {
											var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
											return {
												coords: [data.pageX, data.pageY],
												origin: $(event.target)
											};
										},
										stop: function(event) {
											var data = event.originalEvent.touches ? event.originalEvent.touches[0] : event;
											return {
												coords: [data.pageX, data.pageY]
											};
										}
									}
									var start = point.start(event);
									var scrolling = false;
									var begin = false;
									var btn_left = parseInt(btn.css("left"), 10);
									var t_on_s_w = texton.width();
									$(self).bind("touchmove.UISwitch", function(event) {
										var stop = point.stop(event);
										if (Math.abs(start.coords[1] - stop.coords[1]) > 5 && begin == false) {
											scrolling = true
										}
										if (Math.abs(start.coords[0] - stop.coords[0]) > 0 && scrolling == false) {
											begin = true;
											has_drag = true;
											$(self).unbind("tap.UISwitch", tap_switch);
											var d = stop.coords[0] - start.coords[0]
											var set_left = btn_left + d;
											if (set_left >= 1 && set_left <= self_w - btn_w - 1) {
												btn.css("left", set_left);
												if (t_on_s_w == 0) {
													texton.width(btn_w + d)
													textoff.width(self_w - d)
												} else {
													texton.width(self_w + d)
													textoff.width(btn_w - d)
												}
											}
											event.preventDefault();
										}
									});
									$(self).one("touchend.UISwitch", function(event) {
										$(self).unbind("touchmove.UISwitch");
										if (has_drag == true) {
											var left = parseInt(btn.css("left"), 10) + btn_w / 2
											if (left >= self_w / 2) {
												main._private._fn._set_state(0);
											} else {
												main._private._fn._set_state(1);
											}
											setTimeout(function() {
												$(self).bind("tap.UISwitch", tap_switch)
											}, 200);
											has_drag = false;
										}
									})
								})
							},
							_html: {
								_layout: function(texton, textoff) {
									return ["<div class=\"UISwitchOn\"><span>" + texton + "</span></div>", "<div class=\"UISwitchOff\"><span>" + textoff + "</span></div>", "<div class=\"UISwitchButton\"></div>"].join("");
								},
								_hidden_input: function(value) {
									return "<input class=\"UISwitchHiddenInput\" type=\"hidden\" value=\"" + value + "\" />"
								}
							},
							_fn: {
								_set_state: function(value, init) {
									var texton = $(self).find(".UISwitchOn");
									var textoff = $(self).find(".UISwitchOff");
									var btn = $(self).find(".UISwitchButton");
									var old_value = $(self).attr("m-value");
									var btn_w = btn.outerWidth();
									var self_w = $(self).width() || parseInt($(self).css("min-width"));
									if (value == 0) {
										$(self).bind("touchstart.UISwitch.a", function() {
											return false
										});
										if (init != "init") {
											texton.stop().animate({
												"width": "100%"
											}, 200);
											textoff.stop().animate({
												"width": 0
											}, 200);
											btn.stop().animate({
												"left": self_w - btn_w - 1
											}, 200, function() {
												if (init != "stopEvent") {
													changeCallback();
												}
												$(self).unbind("touchstart.UISwitch.a");
											})
										} else {
											texton.css({
												"width": "100%"
											});
											textoff.css({
												"width": 0
											});
											btn.css({
												"left": self_w - btn_w - 1
											})
											$(self).unbind("touchstart.UISwitch.a");
										}
										$(self).find(".UISwitchHiddenInput").val(1)
										$(self).attr({
											"m-value": 1,
											"value": 1
										});
									} else {
										$(self).bind("touchstart.UISwitch.a", function() {
											return false
										});
										texton.stop().animate({
											"width": btn_w
										}, 200, function() {
											$(this).width(0)
										});
										textoff.stop().animate({
											"width": "100%"
										}, 200);
										$(self).find(".UISwitchHiddenInput").val(0)
										$(self).attr({
											"m-value": 0,
											"value": 0
										});
										btn.stop().animate({
											"left": 1
										}, 200, function() {
											if (init != "stopEvent") {
												changeCallback();
											}
											$(self).unbind("touchstart.UISwitch.a");
										})
									}
									function changeCallback() {
										if (old_value != $(self).attr("m-value") && init != "init") {
											main.public.change_callback && main.public.change_callback.call(self, $(self).attr("m-value"));
										}
									}
								}
							}
						},
						public: {
							change: function() {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							destroy: function() {
								$(self).removeData("UISwitch");
							},
							state: function() {
								var args = arguments[0];
								if (args[1] == "on") {
									if ($(self).attr("value") == 1) {
										return
									}
									var value = 0
								}
								if (args[1] == "off") {
									if ($(self).attr("value") == 0) {
										return
									}
									var value = 1
								}
								main._private._fn._set_state(value, args[2]);
							},
							value: function() {
								main.public.get_value = ($(self).attr("value") == 1) ? "on" : "off";
							}
						}
					};
					main._private._init();
					delete main.settings.data;
					$(self).data("UISwitch", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UISwitch");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UICollapsible = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UICollapsible") == undefined) {
					if (typeof(options) == "string")
						return;
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).find(">ul>li>[m-role='title']").append(main._private._html._arrow());
								main._private._events();
							},
							_events : function () {
								$(self).on("tap", "[m-role='title']", function () {
									if ($(this).next("[m-role='content']:hidden").size() == 0) {
										$(this).parents("li").removeAttr("m-active");
										$(this).find(".UICollapsibleArrow").attr("m-icon", "arrowup");
									} else {
										$(self).find(">ul>li").removeAttr("m-active");
										$(self).find(".UICollapsibleArrow").attr("m-icon", "arrowup");
										$(this).parents("li").attr("m-active", "yes");
										$(this).find(".UICollapsibleArrow").attr("m-icon", "arrowdown");
									}
								});
							},
							_fn : {},
							_html : {
								_arrow : function () {
									return "<div class=\"UICollapsibleArrow\" m-icon=\"arrowup\" m-style=\"style-1\"></div>"
								}
							}
						},
						public : {
							destroy : function () {
								$(self).removeData("UICollapsible");
							},
							refresh : function () {
								$(self).find("li").each(function () {
									if ($(this).find(".UICollapsibleArrow").size() == 0) {
										$(this).find(">[m-role='title']").append(main._private._html._arrow());
									}
								})
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UICollapsible", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UICollapsible");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UISelectField = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UISelectField") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).append(main._private._html._select_icon());
								$(self).append(main._private._html._select_text());
								main._private._events();
							},
							_events : function () {
								$(self).on("change", "select", function () {
									var v = $(self).find("select").val();
									$(self).find(".UISelectFieldText").html($(self).find("select option:selected").text())
									main.public.change_callback && main.public.change_callback.call(this, v)
								});
							},
							_fn : {
								_set_text : function () {
									$(self).find(".UISelectFieldText").html($(self).find("select option:selected").text())
								}
							},
							_html : {
								_select_icon : function () {
									return "<div m-icon=\"arrowdown\"></div>"
								},
								_select_text : function () {
									return "<div m-role=\"cell\"  class=\"UISelectFieldText\">" + $(self).find("select option:selected").text() + "</div>"
								}
							}
						},
						public : {
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							destroy : function () {
								$(self).removeData("UISelectField");
							},
							selectLimit : function () {},
							value : function () {
								var args = arguments[0];
								var args_length = args.length;
								if (args_length == 1) {
									main.public.get_value = $(self).find("select").val() || "";
								}
								if (args_length == 2) {
									//$(self).find("option").removeAttr("selected");
									//$(self).find("option[value='" + args[1] + "']").attr("selected", true);
									//main._private._fn._set_text();
									$(self).find("select").val(args[1]).trigger('change');
								}
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UISelectField", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UISelectField");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UITextField = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UITextField") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).append(main._private._html._input());
								if ($(self).attr("m-type") == "search" || $(self).attr("m-type") == "autocomplete") {
									$(self).append(main._private._html._search_icon());
								};
								var value = $(self).attr("m-value") || $(self).attr("value");
								if (value == undefined) {
									value = ""
								}
								$(self).attr({
									"m-value" : value,
									"value" : value
								});
								$(self).find("input").val(value);
								if ($(self).attr("m-type")) {
									var mTypeArr = $(self).attr("m-type").split(",");
									if (mTypeArr.length > 1) {
										if (mTypeArr[0] == "number") {
											$(self).UIKeyboard({
												"leftButton" : mTypeArr[1] || "",
												"rightButton" : mTypeArr[2] || ""
											});
										};
										if (mTypeArr[0] == "money") {
											$(self).UIKeyboard({
												"leftButton" : mTypeArr[1] || "",
												"rightButton" : mTypeArr[2] || "",
												"type" : "money"
											});
										};
										if (mTypeArr[0] == "password") {
											$(self).UIKeyboard({
												"leftButton" : mTypeArr[1] || "",
												"rightButton" : mTypeArr[2] || "",
												"type" : "password"
											});
										};
										$(self).UIKeyboard("set", function () {
											main.public.blur_callback && main.public.blur_callback.call(self);
										})
										$(self).UIKeyboard("change", function (v) {
											main.public.change_callback && (function(self, v) {
												for (var i in main.public.change_callback) {
													main.public.change_callback[i].call(self, v);
												}})(self, v);
										})
									}
								}
								main._private._fn._check_null();
								$(self).find(".UITextFieldClear").hide();
								main._private._events();
							},
							_events : function () {
								var timer;
								var input = $(self).find("input");
								$(self).on("blur", "input", function () {
									$(self).find(".UITextFieldClear").hide();
								});
								$(self).on("focus", "input", function () {
									main._private._fn._check_null();
								});
								$(self).on("tap", "input", function () {
									main._private._fn._check_null();
								});
								$(self).on("input change keyup", "input", function () {
									main._private._fn._check_null();
									var v = $(self).find("input").val();
									main.public.change_callback && (function(self, v) {
												for (var i in main.public.change_callback) {
													main.public.change_callback[i].call(self, v);
												}})(self, v);
								});
								$(self).on("change", "input", function () {
									if ($(self).attr("m-type") == "autocomplete") {
										setTimeout(function () {
											$(self).find("input").focus();
										}, 200)
									}
								})
								$(self).on("input", "input", function () {
									var v = $(self).find("input").val();
									if ($(self).attr("m-type") == "autocomplete") {
										if (v == "") {
											$.UIBubble("hide");
											return
										}
										var settings = {
											"etarget" : $(self),
											"width" : 300,
											"height" : 300
										};
										settings.html = ["<div m-role=\"UIScrollView\" class=\"UITextFieldAutoComplete\">", "<div class=\"UITextFieldAutoCompleteContent\" >", "<div class=\"UITextFieldAutoCompleteLoading\" >", "<div m-icon=\"loading\"></div>", $.t.UISearchLoading, "</div>", "</div>", "</div>"].join("");
										var loading_html = ["<div class=\"UITextFieldAutoCompleteLoading\" >", "<div m-icon=\"loading\"></div>", $.t.UISearchLoading, "</div>"].join("");
										$.UIBubble("show", settings);
										$(".UITextFieldAutoCompleteContent").html(loading_html);
										$(".UITextFieldAutoComplete").UIScrollView();
										try {
											$(".UITextFieldAutoComplete").UIScrollView("refresh")
										} catch (e) {};
										main.public.search_callback && main.public.search_callback.call(self, v)
									};
								});
								$(self).on("vmousedown", ".UITextFieldClear", function () {
									input.val("");
									$(self).attr({
										"m-value" : "",
										"value" : ""
									});
									$(this).hide()
									input.focus();
									main._private._fn._check_null();
									var v = $(self).find("input").val();
									main.public.change_callback && (function(self, v) {
												for (var i in main.public.change_callback) {
													main.public.change_callback[i].call(self, v);
												}})(self, v);
									$.UIBubble("hide");
								});
								$(self).find("input").bind("focus", function () {
									main.public.focus_callback && main.public.focus_callback.call(self);
									return false
								});
								$(self).find("input").bind("blur", function () {
									main.public.blur_callback && main.public.blur_callback.call(self);
									return false
								});
							},
							_fn : {
								_auto_complete : function (html) {
									$(".UITextFieldAutoCompleteContent").html(html);
									main.public.autoComplete_callback && main.public.autoComplete_callback.call(self);
									$(".UITextFieldAutoComplete").UIScrollView("refresh")
								},
								_check_null : function () {
									var clear_btn = $(self).find(".UITextFieldClear");
									var v = $(self).find("input").val();
									$(self).attr({
										"m-value" : v,
										"value" : v
									});
									$(self).find(".UIKeyboardText").html(v);
									if (v != "") {
										clear_btn.show();
									} else {
										$(self).find("input").show();
										clear_btn.hide();
									}
								},
								_check_maxlength : function () {
									var v = $(self).find("input").val();
									if (v != "") {
										var tmax = $(self).attr("m-maxlength") || 500;
										var vl = v.length;
										if (vl > tmax) {
											v = v.substring(0, tmax);
										}
									}
									$(self).attr({
										"m-value" : v,
										"value" : v
									});
									$(self).find("input").val(v);
								}
							},
							_html : {
								_input : function () {
									return ["<input maxlength=\"" + ($(self).attr("m-maxlength") || "") + "\" type=\"" + ($(self).attr("m-type") == "password" || $(self).attr("m-type") == "number" || $(self).attr("m-type") == "tel" ? $(self).attr("m-type") : "text") + "\" value=\"" + ($(self).attr("m-value") || "") + "\" placeholder=\"" + ($(self).attr("m-placeholder") || "") + "\"/>", "<div class=\"UITextFieldClear\"><div m-icon=\"clear\"></div></div>"].join("");
								},
								_search_icon : function () {
									return "<div m-icon=\"search\"></div>"
								}
							}
						},
						public : {
							clear : function () {
								var $input = $(self).find("input");
								var $self = $(self);
								$input.val("");
								$self.attr("m-value", "");
								$self.find(".UITextFieldClear").hide();
								main._private._fn._check_null();
								$self.find("input[type='text']").show();
								$input.trigger("change");
							},
							change : function () {
								var args = arguments[0];
								if (main.public.change_callback) {
									main.public.change_callback.push(args[1]);
								} else {
									main.public.change_callback = [args[1]];
								}
							},
							destroy : function () {
								$(self).removeData("UITextField");
							},
							search : function () {
								var args = arguments[0];
								main.public.search_callback = args[1];
							},
							autoComplete : function () {
								var args = arguments[0];
								main.public.autoComplete_callback = args[2];
								main._private._fn._auto_complete(args[1]);
								$(".UITextFieldAutoComplete").UIScrollView("refresh");
							},
							value : function () {
								var args = arguments[0];
								var args_length = args.length;
								var $input = $(self).find("input");
								if (args_length == 1) {
									main.public.get_value = $input.val();
								}
								if (args_length == 2) {
									$(self).find("input").val(args[1]);
									$(self).attr({
										"m-value" : args[1],
										"value" : args[1]
									});
									main._private._fn._check_null();
									$(self).find(".UITextFieldClear").hide();
									$input.trigger("change");
								}
							},
							blur : function () {
								var args = arguments[0];
								main.public.blur_callback = args[1];
							},
							focus : function () {
								var args = arguments[0];
								main.public.focus_callback = args[1];
							},
							placeholder : function () {
								var args = arguments[0];
								$(self).find("input").attr("placeholder", args[1]);
								$(self).attr({
									"m-placeholder" : args[1]
								});
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UITextField", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UITextField");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UITextarea = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UITextarea") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								var self_html = $(self).html();
								$(self).html(main._private._html._textarea());
								$(self).find("textarea").val(self_html);
								main._private._fn._check();
								$(self).find(".UITextareaClear,.UITextareaMax").hide();
								main._private._events();
							},
							_events : function () {
								var textarea = $(self).find("textarea");
								$(self).on("blur", "textarea", function () {
									$(self).find(".UITextareaClear,.UITextareaMax").hide();
								});
								$(self).on("focus", "textarea", function () {
									main._private._fn._check();
								});
								$(self).on("input change keyup", "textarea", function () {
									main._private._fn._check();
								});
								$(self).on("vmousedown", ".UITextareaClear", function () {
									textarea.val("");
									$(this).hide();
									textarea.focus();
									main._private._fn._check();
									return false
								});
							},
							_fn : {
								_check : function () {
									var clear_btn = $(self).find(".UITextareaClear");
									var text_max = $(self).find(".UITextareaMax");
									var v = $(self).find("textarea").val();
									main.public.change_callback && main.public.change_callback.call(this, v)
									if (v != "") {
										var tmax = $(self).attr("m-max") || $(self).attr("m-maxlength") || 200;
										var vl = v.length;
										if (vl <= tmax) {
											$(self).find(".UITextareaMax").text(tmax - vl);
										} else {
											$(self).find("textarea").val(v.substring(0, tmax));
										}
										text_max.show();
										clear_btn.show();
									} else {
										text_max.hide();
										clear_btn.hide();
									}
								}
							},
							_html : {
								_textarea : function () {
									return ["<textarea  placeholder=\"" + ($(self).attr("m-placeholder") || "") + "\"></textarea>", "<div class=\"UITextareaClear\" m-icon=\"clear\"></div>", "<div class=\"UITextareaMax\">" + ($(self).attr("m-max") || $(self).attr("m-maxlength") || "") + "</div>"].join("");
								}
							}
						},
						public : {
							clear : function () {
								$(self).find("textarea").val("");
								$(self).find(".UITextareaClear,.UITextareaMax").hide();
								main._private._fn._check();
							},
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							destroy : function () {
								$(self).removeData("UITextarea");
							},
							value : function () {
								var args = arguments[0];
								var args_length = args.length;
								if (args_length == 1) {
									main.public.get_value = $(self).find("textarea").val();
								}
								if (args_length == 2) {
									$(self).find("textarea").val(args[1]);
									main._private._fn._check();
									$(self).find(".UITextareaClear,.UITextareaMax").hide();
								}
							},
							blur : function () {
								$(self).find("textarea").blur();
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UITextarea", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UITextarea");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		}
		return $return;
	};
	$.fn.UIBottomBar = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIBottomBar") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								if($(self).length>0) {
									if($(".bottombar-body").length == 0) $("body").addClass('bottombar-body');
								}else{
									$("body").removeClass('bottombar-body');
								}
								$(self).wrapInner(main._private._html._room());
								var left_n = $(self).find("[m-role='left']").size();
								var right_n = $(self).find("[m-role='right']").size();
								if (left_n > 0 && right_n == 0) {
									$(self).find(".bottombar-inner").append(main._private._html._right())
								};
								if (left_n == 0 && right_n > 0) {
									$(self).find(".bottombar-inner").prepend(main._private._html._left())
								};
								var left = $(self).find("[m-role='left']");
								var right = $(self).find("[m-role='right']");
								var left_w = left.width();
								var right_w = right.width();
								if (left_w > right_w) {
									right.width(left_w)
								} else {
									left.width(right_w)
								}
							},
							_events : function () {},
							_html : {
								_room : function () {
									return "<div class=\"bottombar-inner\"></div>"
								},
								_left : function () {
									return "<div m-role=\"left\"></div>"
								},
								_right : function () {
									return "<div m-role=\"right\"></div>"
								}
							}
						},
						public : {
							destroy : function () {
								$(self).removeData("UIBottomBar");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UIBottomBar", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIBottomBar");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UINavigationBar = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UINavigationBar") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								if($(self).length>0) {
									if($(".navigation-body").length == 0) $("body").addClass('navigation-body');
								}else{
									$("body").removeClass('navigation-body');
								}
								var left_n = $(self).find("[m-role='left']").size();
								var right_n = $(self).find("[m-role='right']").size();
								if (left_n > 0 && right_n == 0) {
									$(self).find(".UINavigationBarRoom").append(main._private._html._right())
								};
								if (left_n == 0 && right_n > 0) {
									$(self).find(".UINavigationBarRoom").prepend(main._private._html._left())
								};
								var left = $(self).find("[m-role='left']");
								var right = $(self).find("[m-role='right']");
								var leftW=left.width();
								var left_w = leftW?leftW<50?50:leftW:50;
								var rightW = right.width();
								var right_w=rightW?rightW<50?50:rightW:50;

								if (left_w > right_w) {
									right.width(left_w)
								} else {
									left.width(right_w)
								}
							},
							_events : function () {},
							_html : {
								_room : function () {
									return "<div class=\"UINavigationBarRoom\"></div>"
								},
								_left : function () {
									return "<div m-role=\"left\"></div>"
								},
								_right : function () {
									return "<div m-role=\"right\"></div>"
								}
							}
						},
						public : {
							destroy : function () {
								$(self).removeData("UINavigationBar");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UINavigationBar", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UINavigationBar");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIToolBar = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIToolBar") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).wrapInner(main._private._html._room())
								if ($(self).attr("m-layout") == "fix") {
									var room = $(self).find(".UIToolBarRoom");
									room.addClass("UIToolBarLayoutFixed");
									room.css("top", parseInt($(self).attr("m-fix"), 10))
								};
							},
							_events : function () {},
							_html : {
								_room : function () {
									return "<div class=\"UIToolBarRoom\"></div>"
								}
							}
						},
						public : {
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							destroy : function () {
								$(self).removeData("UIToolBar");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UIToolBar", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIToolBar");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UISearchBar = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UISearchBar") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = $(self).attr("m-id");
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								var left_dom = $(self).find(">[m-role='left']").clone(true, true);
								var right_dom = $(self).find(">[m-role='right']").clone(true, true);
								$(self).html(main._private._html._layout());
								left_dom.appendTo($(self).find(".UISearchBarLeftRoom"))
								right_dom.appendTo($(self).find(".UISearchBarRightRoom"))
								$(self).find("[m-role='UITextField']").UITextField();
								if ($(self).attr("m-button") == "cancel") {
									$(self).find(".UISearchBarRight").append(main._private._html._cancel_button());
								};
								$("body").append(main._private._html._result());
								$(".UISearchBarResult").css("top", parseInt($(self).attr("m-result-top")))
								if ($(self).attr("m-layout") == "fix") {
									var room = $(self).find(".UISearchBarRoom");
									room.addClass("UISearchBarLayoutFixed");
									room.css("top", parseInt($(self).attr("m-fix"), 10))
								};
								main._private._events();
							},
							_events : function () {
								var right_cell = $(self).find(".UISearchBarRight");
								var clear_btn = $(self).find(".UISearchBarClear");
								var w = right_cell.outerWidth();
								var self_con = $(self).find(".UISearchBarRoom");
								var uitextfield = $(self).find("[m-role='UITextField']");
								right_cell.css({
									"width" : 0
								});
								$(self).on("focus.UISearchBar", "[m-role='UITextField'] input", function () {
									if ($(".UISearchBarMask").size() > 0)
										return;
									self_con.removeClass("UISearchbarLayoutFixed");
									$(document).scrollTop(0);
									$("body").append(main._private._html._mask());
									right_cell.width(w);
									$(self).find(".UISearchBarLeftRoom,.UISearchBarRightRoom").hide();
									$(self).bind("scrollstart", function () {
										return false
									});
								});
								$(document).on("scrollstart", ".UISearchBarMask", function () {
									return false
								});
								$(document).on("vmousedown", ".UISearchBarMask", function () {
									uitextfield.UITextField("blur");
									return false
								});
								$(self).on("vmousedown", ".UISearchBarRight [m-role='UIButton']", function () {
									uitextfield.find("input").blur();
									uitextfield.UITextField("blur");
									uitextfield.UITextField("clear");
									main._private._fn._cancel_search();
									check_("")
									return false
								});
								$(document).on("scrollstart", ".UISearchBarResult", function () {
									uitextfield.UITextField("blur");
								});
								function check_(value) {
									$(".UISearchBarResult").html("");
									var dateList_selector = main.public.dateList_selector;
									if (value != "") {
										main.public.change_callback && main.public.change_callback.call(this, value);
										var result_dom = $(dateList_selector).clone(true, true).removeAttr("id");
										result_dom.find("dd:not([m-filter*='" + value + "']),.UITableViewSectionHeader").remove();
										var result_item = result_dom.find("[m-filter*='" + value + "']");
										if (result_item.size() <= 0) {
											result_dom = ""
										} else {
											result_dom.appendTo($(".UISearchBarResult"))
										}
										$(".UISearchBarResult").show();
									} else {
										$(".UISearchBarResult").hide();
									}
								}
								uitextfield.UITextField("change", function (value) {
									check_(value);
									return false
								});
								$(self).on("blur", "[m-role='UITextField'] input", function () {
									main._private._fn._cancel_search()
								});
							},
							_fn : {
								_cancel_search : function () {
									$(self).find(".UISearchBarRoom").addClass("UISearchbarLayoutFixed");
									$(".UISearchBarMask").remove();
									if ($(self).find("[m-role='UITextField']").UITextField("value") == "") {
										$(self).find(".UISearchBarRight").width(0);
									}
									$(self).unbind("scrollstart");
									$(self).find(".UISearchBarLeftRoom,.UISearchBarRightRoom").show();
								}
							},
							_html : {
								_layout : function () {
									return [, "<div class=\"UISearchBarRoom\">", "<div m-role=\"cell\" class=\"UISearchBarLeftRoom\"> </div>", "<div m-role=\"cell\"  m-mode=\"x\" m-layout=\"fit\">", "<div m-role=\"cell\" m-layout=\"fit\">", "<div  m-role=\"UITextField\" m-type=\"search\" m-layout=\"fit\"  m-placeholder=\"" + ($(self).attr("m-placeholder") || $.t.UISearch) + "\"></div>", "</div>", "<div m-role=\"cell\" class=\"UISearchBarRight\" m-align=\"center\" m-valign=\"middle\"></div>", "</div>", "<div m-role=\"cell\" class=\"UISearchBarRightRoom\"> </div>", "</div>"].join("");
								},
								_result : function () {
									return "<div  class=\"UISearchBarResult\"></div>"
								},
								_cancel_button : function () {
									return "<div m-role=\"UIButton\" m-style=\"style-1\" m-size=\"min\">" + $.t.UICancel + "</div>"
								},
								_mask : function () {
									return "<div class=\"UISearchBarMask\"></div>"
								}
							}
						},
						public : {
							dataList : function () {
								var args = arguments[0];
								main.public.dateList_selector = args[1];
							},
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							destroy : function () {
								$(self).removeData("UISearchBar");
							},
							result : function () {
								var args = arguments[0];
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UISearchBar", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UISearchBar");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UITip = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UITip") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								main._private._events();
								main.public.show_height = $(self).height();
								$(self).hide();
								$(self).height(0);
							},
							_events : function () {
								$(self).bind("swipe", function () {
									main._private._fn._hide();
								})
							},
							_html : {},
							_fn : {
								_hide : function () {
									$(self).stop().animate({
										"height" : 0
									}, 200, function () {
										$(self).hide();
									})
								}
							}
						},
						public : {
							show : function () {
								var args = arguments[0];
								var h = main.public.show_height;
								if (args[1]) {
									$(self).html(args[1])
								};
								$(self).show().stop().animate({
									"height" : h
								}, 200).delay(200).animate({
									"opacity" : 0
								}, 200).animate({
									"opacity" : 1
								}, 200).animate({
									"opacity" : 0
								}, 200).animate({
									"opacity" : 1
								}, 200)
							},
							hide : function () {
								main._private._fn._hide();
							},
							destroy : function () {
								$(self).removeData("UITip");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UITip", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UITip");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UIFontSize = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UIFontSize") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
							},
							_events : function () {},
							_html : {}

						},
						public : {
							up : function () {
								var args = arguments[0];
								var fs = parseInt($(self).css("font-size"), 10);
								var n = parseInt(args[1], 10);
								$(self).css("font-size", fs + n)
								args[2] && args[2].call(this, fs + n);
							},
							down : function () {
								var args = arguments[0];
								var fs = parseInt($(self).css("font-size"), 10);
								var n = parseInt(args[1], 10);
								$(self).css("font-size", fs - n)
								args[2] && args[2].call(this, fs - n);
							},
							destroy : function () {
								$(self).removeData("UIFontSize");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UIFontSize", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UIFontSize");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UITableView = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UITableView") == undefined) {
					if (typeof(options) == "string")
						return;
					var rel = "";
					var selector = {};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).append(main._private._html._init());
								$(self).find("dd[m-type='mark']").append(main._private._html._mark());
								$(self).find("dd[m-marked='yes']").addClass("UITableViewMarked");
								$(self).find("dd[m-type='arrow']").append(main._private._html._arrow());
								$(self).find("dd[m-type='arrowbutton']").append(main._private._html._arrow_button());
								main._private._events._delete_button();
								if ($(self).attr("m-section") == "fix" && $(self).attr("m-style") != "grouped") {
									$(self).append(main._private._html._section_header());
									main._private._events._section_header();
								}
								$(self).find(".UITableViewInitHtml").remove();
							},
							_events : {
								_delete_button : function () {
									$(document, self).on("swipe.UITableView", "dd[m-edit='delete']", function () {
										var this_item = $(this);
										if ($(".UITableViewMask").size() > 0)
											return;
										this_item.append(main._private._html._delete_button());
										this_item.append(main._private._html._mask());
										var close_button = $(self).find(".UITableViewItemDeleteButton");
										var w = close_button.width();
										close_button.width(0);
										var this_mask = this_item.find(".UITableViewMask");
										var this_btn = this_item.find(".UITableViewItemDeleteButton");
										this_mask.bind("scrollstart swipe", function () {
											return false
										})
										$(".UITableViewItemDeleteButton").width(0);
										this_btn.stop().animate({
											"width" : w
										}, 300, function () {
											this_mask.bind("vmousedown.UITableView", function () {
												this_btn.stop().animate({
													"width" : 0
												}, 300, function () {
													this_mask.remove();
													this_btn.remove();
												});
												return false;
											});
										});
									});
									$(self).on("tap", ".UITableViewItemDeleteButton", function () {
										var dd = $(this).parent("dd");
										var item_id = dd.attr("m-id");
										main.public.swipeDelete_callback && main.public.swipeDelete_callback.call(this, item_id);
									});
									$(self).on("tap", ".UITableViewArrowButtonWrap", function () {
										var dd = $(this).parent("dd");
										var item_id = dd.attr("m-id");
										main.public.arrowButtonTap_callback && main.public.arrowButtonTap_callback.call(this, item_id);
									});
									$(self).on("tap", ".UITableViewMarkWrap", function () {
										var dd = $(this).parent("dd");
										var item_id = dd.attr("m-id");
										if (main.public.markLimit_n) {
											if (dd.attr("m-marked") == "yes") {
												dd.removeAttr("m-marked");
												dd.removeClass("UITableViewMarked");
											} else {
												if ($(self).find("[m-marked='yes']").size() == main.public.markLimit_n) {
													main.public.mark_callback && (function(dd, context) {for (var i in main.public.mark_callback) {
														main.public.mark_callback[i].call(dd, context);
													}})(this, item_id);
												} else {
													dd.attr("m-marked", "yes");
													dd.addClass("UITableViewMarked");
													main.public.mark_callback && (function(dd, context) {for (var i in main.public.mark_callback) {
														main.public.mark_callback[i].call(dd, context);
													}})(this, item_id);
												}
											};
										} else {
											$(self).find("dd").removeAttr("m-marked");
											$(self).find("dd").removeClass("UITableViewMarked");
											dd.attr("m-marked", "yes");
											dd.addClass("UITableViewMarked");
											main.public.mark_callback && (function(dd, context) {for (var i in main.public.mark_callback) {
														main.public.mark_callback[i].call(dd, context);
													}})(this, item_id);
										}
										return false;
									})
									$(self).on("tap", ".UITableViewCheckWrap", function () {
										var dd = $(this).parent("dd");
										var item_id = dd.attr("m-id");
										if (dd.attr("m-checked") == "yes") {
											dd.removeClass("UITableViewChecked").removeAttr("m-checked");
										} else {
											dd.addClass("UITableViewChecked").attr("m-checked", "yes");
											main.public.check_callback && main.public.check_callback.call(this, item_id);
										};
										return false;
									});
									if ($(self).find("[m-role='header']").size() == 0 && $(self).attr("m-cache") == "yes") {
										$(self).addClass("UITableViewHideItems")
										$(self).find("dd").slice(0, main._private._cache._q).addClass("m-show");
										main._private._cache._first = $(self).find("dd").index($(self).find("dd.m-show").first()) + 1;
										main._private._cache._last = $(self).find("dd").index($(self).find("dd.m-show").last()) + 1;
										$.UIPullDown(function () {
											main._private._cache._down();
										})
										$.UIPullUp(function () {
											main._private._cache._up();
										})
									}
								},
								_section_header : function () {
									var section_header = $(self).find(".UITableViewSectionHeader");
									var m_fix = parseInt($(self).attr("m-fix"), 10);
									section_header.css("top", m_fix).hide();
									var self_top = $(self).offset().top;
									$(document).bind("vmousemove.UITableViewSectionHeader  scroll.UITableViewSectionHeader", function () {
										if ($(self).is(":visible") == false)
											return;
										var scrolltop = $(this).scrollTop();
										if (scrolltop < self_top - m_fix || scrolltop >= self_top + $(self).outerHeight() - m_fix - section_header.outerHeight()) {
											section_header.hide()
										} else {
											section_header.show()
										}
										$(self).find("[m-role='header']").each(function () {
											var text = $(this).text();
											var dl = $(this).next("dl");
											var height = $(this).outerHeight() + dl.outerHeight();
											var top = $(this).offset().top;
											var lim_top = top - m_fix;
											var lim_bottom = height + top + m_fix;
											if (scrolltop >= lim_top && scrolltop <= lim_bottom) {
												section_header.find(".UITableViewSectionHeaderText").html(text);
												return
											}
										});
									})
								}
							},
							_cache : {
								_first : 0,
								_last : 0,
								_n : 30,
								_q : 60,
								_up : function () {
									var old_size = $(self).find("dd.m-show").size();
									var h = 0;
									var f = main._private._cache._first - main._private._cache._n - 1;
									if (f < 0) {
										f = 0
									}
									var dd_domslice = $(self).find("dd").slice(f, main._private._cache._first - 1);
									if (dd_domslice.size() == 0)
										return;
									$(self).find("dd").slice(f, main._private._cache._first - 1).each(function () {
										h = h + $(this).outerHeight();
										$(this).addClass("m-show");
									})
									var new_size = $(self).find("dd.m-show").size();
									$(self).find("dd").slice(main._private._cache._last - (new_size - old_size), main._private._cache._last).removeClass("m-show");
									$(document).scrollTop($(document).scrollTop() + h);
									main._private._cache._first = $(self).find("dd").index($(self).find("dd.m-show").first()) + 1;
									main._private._cache._last = $(self).find("dd").index($(self).find("dd.m-show").last()) + 1;
								},
								_down : function () {
									var old_size = $(self).find("dd.m-show").size();
									$(self).find("dd").slice(main._private._cache._last, main._private._cache._last + main._private._cache._n).addClass("m-show");
									var new_size = $(self).find("dd.m-show").size();
									var h = 0;
									var dd_show_domslice = $(self).find("dd.m-show").slice(0, new_size - old_size);
									if (dd_show_domslice.size() == 0)
										return;
									dd_show_domslice.each(function () {
										h = h + $(this).outerHeight();
										$(this).removeClass("m-show");
									})
									$(document).scrollTop($(document).scrollTop() - h);
									main._private._cache._first = $(self).find("dd").index($(self).find("dd.m-show").first()) + 1;
									main._private._cache._last = $(self).find("dd").index($(self).find("dd.m-show").last()) + 1;
								}
							},
							_html : {
								_init : function () {
									return "<dl class=\"UITableViewInitHtml\"><dt></dt><dd></dd></dl>";
								},
								_delete_button : function () {
									return "<div class=\"UITableViewItemDeleteButton\"><span  m-role=\"UIButton\" m-style=\"style-2\" m-size=\"min\">" + $.t.UIDelete + "</span></div>"
								},
								_mask : function () {
									return "<div class=\"UITableViewMask\"></div>"
								},
								_section_header : function () {
									return ["<div class=\"UITableViewSectionHeader\">", "<div class=\"UITableViewSectionHeaderText\"></div>", "</div>"].join("");
								},
								_no_data : function (text) {
									return "<div class=\"UITableViewNoData\">" + text + "</div>"
								},
								_check : function () {
									return ["<div class=\"UITableViewCheckWrap\">", "<div class=\"UITableViewCheck\" m-icon=\"checkbox\"></div>", "</div>"].join("");
								},
								_arrow : function () {
									return "<div class=\"UITableViewArrow\" m-icon=\"arrow\"></div>"
								},
								_arrow_button : function () {
									return ["<div class=\"UITableViewArrowButtonWrap\">", "<div class=\"UITableViewArrowButton\" m-icon=\"arrowbutton\"></div>", "</div>"].join("");
								},
								_mark : function () {
									return ["<div class=\"UITableViewMarkWrap\">", "<div class=\"UITableViewMark\" m-icon=\"mark\"></div>", "</div>"].join("");
								}
							}
						},
						public : {
							refresh : function () {
								$(self).find("dd[m-type]").each(function () {
									if ($(this).attr("m-marked") == "yes") {
										$(this).addClass("UITableViewMarked")
									};
									if ($(this).attr("m-type") == "mark" && $(this).find(".UITableViewMarkWrap").size() == 0) {
										$(this).append(main._private._html._mark());
									}
									if ($(this).attr("m-type") == "arrow" && $(this).find(".UITableViewArrow").size() == 0) {
										$(this).append(main._private._html._arrow());
									}
									if ($(this).attr("m-type") == "arrowbutton" && $(this).find(".UITableViewArrowButtonWrap").size() == 0) {
										$(this).append(main._private._html._arrow_button());
									}
								})
							},
							addItem : function () {
								var args = arguments[0];
								$(self).find(">dl:last-child").append(args[1]);
								if ($(self).find("[m-role='header']").size() == 0 && $(self).attr("m-cache") == "yes") {
									main._private._cache._down();
								}
							},
							deleteItem : function () {
								var args = arguments[0];
								main.public.swipeDelete_callback = args[1];
							},
							check : function () {
								var args = arguments[0];
								main.public.check_callback = args[1];
							},
							checked : function () {
								var arr = [];
								$(self).find("[m-checked='yes']").each(function () {
									arr.push($(this).attr("m-id"));
								})
								main.public.get_value = arr;
							},
							mark : function () {
								var args = arguments[0];
								if (main.public.mark_callback) {
									main.public.mark_callback.push(args[1]);
								} else {
									main.public.mark_callback = [args[1]];
								}
							},
							markLimit : function () {
								var args = arguments[0];
								main.public.markLimit_n = args[1];
								main.public.markLimit_callback = args[2];
							},
							marked : function () {
								var arr = [];
								$(self).find("[m-marked='yes']").each(function () {
									arr.push($(this).attr("m-id"));
								})
								main.public.get_value = arr;
							},
							doMark : function() {
								var args = arguments[0];
								$(self).find("dd[m-id='"+args[1]+"']").find(".UITableViewMarkWrap").tap();
							},
							arrowButtonTap : function () {
								var args = arguments[0];
								main.public.arrowButtonTap_callback = args[1];
							},
							noData : function () {
								var args = arguments[0];
								$(self).html(main._private._html._no_data(args[1]))
							},
							checkState : function () {
								var args = arguments[0];
								var args_length = args.length;
								var dd = $(self).find("dd[m-type='check']");
								$(self).find("dd[m-checked='yes']").addClass("UITableViewChecked");
								if (args[1] == "on") {
									if (dd.find(".UITableViewCheckWrap").size() > 0)
										return;
									dd.append(main._private._html._check());
									dd.addClass("UITableViewCheckState")
								}
								if (args[1] == "off") {
									dd.removeClass("UITableViewCheckState");
									var wrap = $(self).find(".UITableViewCheckWrap");
									wrap.hide();
									dd.removeClass("UITableViewChecked").removeAttr("m-checked");
									setTimeout(function () {
										wrap.remove();
									}, 200);
								}
							},
							destroy : function () {
								$(self).removeData("UITableView");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UITableView", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UITableView");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	};
	$.fn.UISegment = function (options, callback) {
		var args = arguments;
		var $val,
		$return = this.each(function () {
				var self = this;
				if ($(self).data("UISegment") == undefined) {
					if (typeof(options) == "string")
						return;
					if ($(self).attr("m-id") == undefined) {
						$(self).attr("m-id", "mid_" + $.getRandom())
					}
					var rel = $(self).attr("m-id");
					var selector = {
						hidden_input : "[m-role='UISegment'][m-id='" + rel + "'] input[type='hidden']",
						tabs_container : "[m-role='UISegment'][m-id='" + rel + "']",
						contents : "[m-for='" + rel + "']",
						tabs : "[m-role='UISegment'][m-id='" + rel + "'] li"
					};
					var main = {
						settings : {
							"data" : {}

						},
						_private : {
							_init : function () {
								$.extend(main.settings, options);
								$(self).append(main._private._html._hidden_input());
								$(selector.hidden_input).attr("name", $(self).attr("name"))
								main._private._active();
								main._private._events();
							},
							_events : function () {
								$(selector.tabs_container).on("tap.UISegment", "[m-id]", function () {
									var old_id = $(selector.tabs_container).find("[m-active='yes']").attr("m-id");
									$(selector.tabs).removeAttr("m-active");
									$(this).attr("m-active", "yes");
									$(selector.hidden_input).val($(this).attr("m-value"));
									main._private._active();
									var new_id = $(selector.tabs_container).find("[m-active='yes']").attr("m-id");
									if (old_id != new_id) {
										main.public.change_callback && main.public.change_callback.call(this, new_id)
									}
									return false
								})
							},
							_active : function () {
								var active_item = $(selector.tabs_container).find("[m-active='yes']");
								if (active_item.size() == 0) {
									var o = $(selector.tabs).eq(0);
									o.attr("m-active", "yes");
									active_item = o;
								}
								var active_val = active_item.attr("m-value");
								$(selector.hidden_input).val(active_val);
								$(self).attr({
									"value" : active_val,
									"m-value" : active_val
								})
								var rel_id = active_item.attr("m-id");
								$(selector.contents).hide();
								$(selector.contents + "[m-id='" + rel_id + "']").show();
							},
							_html : {
								_hidden_input : function () {
									return "<input class=\"UISegmentHiddenInput\" type=\"hidden\" value=\"\" />"
								}
							}
						},
						public : {
							active : function () {
								var args = arguments[0];
								$(selector.tabs).removeAttr("m-active");
								$(self).find("[m-id='" + args[1] + "']").attr("m-active", "yes");
								main._private._active();
							},
							change : function () {
								var args = arguments[0];
								main.public.change_callback = args[1];
							},
							refresh : function () {
								main._private._active();
							},
							destroy : function () {
								$(self).removeData("UISegment");
							},
							value : function() {
								this.get_value = $(self).attr("m-value");
							}
						}
					}
					main._private._init();
					delete main.settings.data;
					$(self).data("UISegment", main);
				} else {
					if (typeof(args[0]) != "string")
						return;
					var main = $(self).data("UISegment");
					main.public[args[0]](args);
					$val = main.public.get_value;
					main = undefined;
				}
			});
		if ($val != undefined) {
			$return = $val
		};
		return $return;
	}
	$.UIPasswordKeyboard = function(method) {
		//定义控件名称
		var pluginName = "UIPasswordKeyboard";
		var self = document.body;
		//默认参数
		var settings = {
			errorMsg: '输入的密码有误，请重新输入！',
			paying: "正在支付，请稍候…",
			pswPlace: 6,
			callback: function() {
				return false;
			},
			inputComplete : function() {}
		};

		//内部方法
		var main = {
			setHtml: function() {
				var opts = $(self).data('opts');
				var pswHtml = '<div class="shade-box"></div><div class="popup-box m-f8-bg"><div class="popup-box-topbar"><div m-role="left" class="close-popup-box"><div class="arrow-left w20 h20 margin-l-10"></div></div><div m-role="title" class="m-color-33">输入交易密码</div><div m-role="right"></div></div><div m-role="cell" class="padding-l-10 padding-t-10 padding-r-10" m-valign="middle"><div m-role="cell">金额：</div><div m-role="cell" class="m-font-20 m-color-red moneyTip"></div></div><div class="popup-box-main" id="pswKeyboard"><div m-role="cell" m-mode="x-equal" class="psw-block">' +
					'    <div class="error-msg">' + opts.errorMsg + '</div>' +
					'    <div class="pay-msg">' +
					'       <div m-role="cell" m-layout="fit"  m-align="center">' +
					'          <div m-role="cell" m-valign="middle" class="margin-r-10">' +
					'             <div class="spinner">' +
					'                <div class="spinner-container container1">' +
					'                   <div class="circle1"></div>' +
					'                   <div class="circle2"></div>' +
					'                   <div class="circle3"></div>' +
					'                   <div class="circle4"></div>' +
					'                </div>' +
					'                <div class="spinner-container container2">' +
					'                   <div class="circle1"></div>' +
					'                   <div class="circle2"></div>' +
					'                   <div class="circle3"></div>' +
					'                   <div class="circle4"></div>' +
					'                </div>' +
					'                <div class="spinner-container container3">' +
					'                   <div class="circle1"></div>' +
					'                   <div class="circle2"></div>' +
					'                   <div class="circle3"></div>' +
					'                   <div class="circle4"></div>' +
					'                </div>' +
					'             </div>' +
					'          </div>' +
					'          <div m-role="cell" m-valign="middle">' + opts.paying + '</div>' +
					'       </div>' +
					'    </div>';

				for (var i = 0; i < opts.pswPlace; i++) {
					var pswDot = '    <div m-role="cell" class="psw-block-item">' +
						'       <div class="psw-dot"></div>' +
						'    </div>';
					pswHtml += pswDot;
				}
				pswHtml += ' </div>';
				var keyboardHtml = '<div m-role="cell" m-mode="y" m-valign="middle" class="keyboard-panel">' +
					'    <div m-role="cell" m-mode="x-equal">' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="1">' +
					'          <div m-role="cell" class="kb-num">1</div>' +
					'          <div m-role="cell" class="kb-letter"></div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="2">' +
					'          <div m-role="cell" class="kb-num">2</div>' +
					'          <div m-role="cell" class="kb-letter">ABC</div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="3">' +
					'          <div m-role="cell" class="kb-num">3</div>' +
					'          <div m-role="cell" class="kb-letter">DEF</div>' +
					'       </div>' +
					'    </div>' +
					'    <div m-role="cell" m-mode="x-equal">' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="4">' +
					'          <div m-role="cell" class="kb-num">4</div>' +
					'          <div m-role="cell" class="kb-letter">GHI</div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="5">' +
					'          <div m-role="cell" class="kb-num">5</div>' +
					'          <div m-role="cell" class="kb-letter">JKL</div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="6">' +
					'          <div m-role="cell" class="kb-num">6</div>' +
					'          <div m-role="cell" class="kb-letter">MNO</div>' +
					'       </div>' +
					'    </div>' +
					'    <div m-role="cell" m-mode="x-equal">' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="7">' +
					'          <div m-role="cell" class="kb-num">7</div>' +
					'          <div m-role="cell" class="kb-letter">PQRS</div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="8">' +
					'          <div m-role="cell" class="kb-num">8</div>' +
					'          <div m-role="cell" class="kb-letter">TUV</div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="9">' +
					'          <div m-role="cell" class="kb-num">9</div>' +
					'          <div m-role="cell" class="kb-letter">WXYZ</div>' +
					'       </div>' +
					'    </div>' +
					'    <div m-role="cell" m-mode="x-equal">' +
					'       <div m-role="cell" m-mode="y" class="kb-btn kb-reset">' +
					'             <div m-role="cell">' +
					'                <div class="kb-ico"></div>' +
					'             </div>' +
					'             <div m-role="cell"></div>' +
					'          </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn" key-value="0">' +
					'          <div m-role="cell" class="kb-num">0</div>' +
					'          <div m-role="cell"></div>' +
					'       </div>' +
					'       <div m-role="cell" m-mode="y" class="kb-btn kb-del">' +
					'          <div m-role="cell">' +
					'             <div class="kb-ico"></div>' +
					'          </div>' +
					'          <div m-role="cell"></div>' +
					'       </div>' +
					'    </div>' +
					' </div></div></div><div id="pressPassword"></div>';

				var html = pswHtml + keyboardHtml;
				var domData = $(self).data('dom');
				if (!domData) $(self).append(html);
				$(self).data('dom', html);
			},
			_event: function() {
				var keyValues = [],
					isReset=0,
					isAjax=0,
					opts = $(self).data('opts');
				$(self).find(".close-popup-box").on('tap', function() {
					var pswBlock = $(self).find(".psw-block");
					$(".shade-box").removeClass('on');
					$('.popup-box').removeClass('on');
					$(document).off("touchmove");
					keyValues = [];
					$(".psw-dot").hide();
			        pswBlock.removeClass('pay-ing');
					return false;
				});
				$(self).find(".kb-btn").on('tap', function() {
					var obj = $(this),
						keyValue = obj.attr('key-value'),
						pswBlock = $(self).find(".psw-block"),
						resetPsw,
						errorMsg = $(self).find('.error-msg');
					obj.addClass('active');
					setTimeout(function() {
						obj.removeClass('active');
					}, 500);
					if (obj.hasClass('kb-del')) {
						keyValues.pop();
						$(self).find(".psw-dot").each(function(idx) {
							if (idx == keyValues.length) $(this).hide();
						});
					} else if (obj.hasClass('kb-reset')) {
						if(keyValues.length!=opts.pswPlace){
							keyValues = [];
							$(".psw-dot").hide();
						}
						pswBlock.removeClass('error');
					} else {
						if (keyValues.length > opts.pswPlace || pswBlock.hasClass('error')) {
							return false;
						} else {
							$(".psw-dot:eq("+keyValues.length+")").show();
							keyValues.push(keyValue);
							if (keyValues.length == opts.pswPlace) {
								var psw = keyValues.join("");
								setTimeout(function() {
									pswBlock.addClass('pay-ing');
									settings.inputComplete(psw, function() {
										$(".shade-box").removeClass('on');
						                $('.popup-box').removeClass('on');
						                $(document).off("touchmove");
						                keyValues = [];
										$(".psw-dot").hide();
						                pswBlock.removeClass('pay-ing');
									}, function(msg) {
										pswBlock.removeClass('pay-ing');
										$(".error-msg").html(msg);
										pswBlock.addClass('error');
										keyValues = [];
										$(".psw-dot").hide();
										resetPsw = setTimeout(function(){
											pswBlock.removeClass('error');
										}, 2000);
									})}
								, 200);
							}
						}
					}
					$(self).data('password', keyValues);
					return false;
				});
			}
		};

		//暴露方法的集合
		var methods = {
			init: function(options) {
				var opts = $.extend({}, settings, options || {});
				settings = opts;
				$(self).data('opts', opts);
					main.setHtml();
					main._event();
					// 初始化完后引用回调函数
					if (typeof opts.callback == 'function') { // 确保类型为函数类型
						opts.callback.call(this); // 执行回调函数
					}

			},
			password: function() {
				return $(self).data('password');
			},
			//销毁控件
			destroy: function() {
				return self.each(function() {
					// Namespacing FTW
					$(window).unbind('.' + pluginName);
					$(self).removeData();
				})
			},
			show : function() {
				$("input").blur();
				$(".shade-box").addClass('on');
				$('.popup-box').addClass('on');
				$(document).on("touchmove",function(e){
                        e.preventDefault();
                        e.stopPropagation();
                });
			},
			money : function() {
				$(".moneyTip").html(arguments[0])
			}
		}

		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
		} else if (typeof method === 'object' || !method) {
			return methods.init.apply(this, arguments);
		} else {
			alert(pluginName + '控件中不存在名为：' + method + ' 的方法或属性！');
		};

	};
	var hsm = {
		init : function () {
			setTimeout(scrollTo, 0, 0, 0);
			$("[m-role='UISearchBar']").UISearchBar();
			$("[m-role='UIToolBar']").UIToolBar();
			$("[m-role='UINavigationBar']").UINavigationBar();
			$("[m-role='UIBottomBar']").UIBottomBar();
			$("[m-role='UISwitch']").UISwitch();
			$("[m-role='UIRadio']").UIRadio();
			$("[m-role='UICheckBox']").UICheckBox();
			$("[m-role='UISelectField']").UISelectField();
			$("[m-role='UITextField']").UITextField();
			$("[m-role='UITextarea']").UITextarea();
			$("[m-role='UIDateField']").UIDateField();
			$("[m-role='UICalendarField']").UICalendarField();
			$("[m-role='UIFontSize']").UIFontSize();
			$("[m-role='UITip']").UITip();
			$("[m-role='UITableView']").UITableView();
			$("[m-role='UICollapsible']").UICollapsible();
			$("[m-role='UISegment']").UISegment();
			$("[m-role='UIPercentBar']").UIPercentBar();
			$("[m-role='UIPageControl']").UIPageControl();
			$("[m-role='UIScrollView']").UIScrollView();
			$("[m-role='UISelectMenu']").UISelectMenu();
			$("[m-role='UIGallery']").UIGallery();
			$("[m-role='UIGrid']").UIGrid();
			var UISelectionStyleSelector = ["[m-role='UIButton']:not([m-selectionstyle='no'])", "[m-role='UITableView']:not([m-style='grouped']) dd:not([m-selectionstyle='no'])", "[m-selectionstyle='yes']", "[m-role='UIGallery'] li .UIGalleryImgWrap", ".UITableViewArrowButton",".nav-link"].join(",")
			$(document).UISelectionStyle({
				"selector" : UISelectionStyleSelector
			});


		}
	}
	hsm.init();
})
