define([$.hsf.platform(),"jsencrypt"], function(platform) {
	var action = {
		constant : {
			oppenaccoTag : $.hsf.hsTools.getParam("oppenaccoTag"),
			applyserial : $.hsf.hsTools.getParam("merOrdId"),
			telephone :  $.hsf.hsTools.getParam("mobile"),
			loginphone : "",
			merorderid : null,
			bankMap : {
				"002" : {
					name : "工商银行",
					serial : "002",
					logo : "bank-icbc"
				},
				"003" : {
					name : "农业银行",
					serial : "003",
					logo : "bank-abc"
				},
				"004" : {
					name : "中国银行",
					serial : "004",
					logo : "bank-boc"
				},
				"005" : {
					name : "建设银行",
					serial : "005",
					logo : "bank-ccb"
				},
				"015" : {
					name : "中信银行",
					serial : "015",
					logo : "bank-ecitic"
				},
				"009" : {
					name : "光大银行",
					serial : "009",
					logo : "bank-ceb"
				},
				"014" : {
					name : "民生银行",
					serial : "014",
					logo : "bank-cmbc"
				},
				"007" : {
					name : "招商银行",
					serial : "007",
					logo : "bank-cmb"
				},
				"011" : {
					name : "兴业银行",
					serial : "011",
					logo : "bank-xy"
				},
				"016" : {
					name : "广发银行",
					serial : "016",
					logo : "bank-cgbc"
				},
				"920" : {
					name : "平安银行",
					serial : "920",
					logo : "bank-pingan"
				},
				"934" : {
					name : "邮储银行",
					serial : "934",
					logo : "bank-youchu"
				}
			}
		},
		init : function() {
			if(action.constant.oppenaccoTag && action.constant.oppenaccoTag == "true"){
				$("#first").hide();
				$("#second").hide();
				$("#third").show();
			}else if(action.constant.oppenaccoTag && action.constant.oppenaccoTag == "false"){
				$.platform.succBack(action.constant.telephone);
			}else{
				$("#first").show();
			}
			$.platform.getCache("userInfo",function(cacheResult) {
				if (cacheResult) {
					action.constant.loginphone = cacheResult.result.mobile;
				} else {
					action.constant.loginphone = action.constant.telephone;
				}
			});
			action.addChinapaySuccListener();
			action.getbankform();
			action.events();
//			action.keyboard = action.passwordKeyboard(".keyboard", action.merOpenAcco);
		},
		initBankList : function() {
			$.doTemplate("banklistTemplate", action.constant.bankMap);
			$("#bankTableView").UITableView("refresh");
		},
		getuserinfo : function(){
			//查询用户信息
			$.hsf.ajax.app("account/account/queryAccoinfo","","checkLoginCode",function(jsonResult){
				if (jsonResult.successful) {
					if (jsonResult.code == "ETS-5BP00000") {
						action.constant.loginphone = jsonResult.result.mobile;
						$.platform.removeCache("userInfo");
						$.platform.putCache("userInfo",jsonResult);
						$.platform.putCache("loginInfo",{custRole:jsonResult.custRole});
					}
				}else{
					$.UIAlert(jsonResult.message, function() {
						$.platform.removeCache("assetlist");
						$.platform.removeCache("userInfo");
						$.platform.closeHSpage();
						return false;
	        		});
				}
			});
		},
		getbankform: function(){
			$.hsf.startLoading();
			$.hsf.ajax.app("account/openacco/bankForm", "", "sendbankauthcodeCallback", function(jsonResult) {
				$.hsf.stopLoading();
				if (jsonResult && jsonResult.successful) {
					$.doTemplate("banklistTemplate", jsonResult.result);
					$("#bankcardList").on("tap", "dd", function() {
						var result = $(this).attr("m-id");
						var bname = $(this).attr("m-name");
						var blogo = $(this).attr("m-logo");
						$(".selectedBankName").html(bname);
						$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-"+blogo);
						$("#bankcardPage").hide();
						$("#first").show();
						action.constant.bankserial = result;
						action.constant.bankname = bname;
						return false;
					});
				}  else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		events: function() {
			$("#bankcardList").on("tap", "dd", function() {
				var result = $(this).attr("m-id");
				$(".selectedBankName").html(action.constant.bankMap[result].name);
				$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo "+action.constant.bankMap[result].logo);
				$("#bankcardPage").hide();
				$("#first").show();
				action.constant.bankserial = result;
				action.constant.bankname = action.constant.bankMap[result].name;
				return false;
			});
			$("#bankcardSelect").bind("tap", function() {
				$("#first").hide();
				$("#bankcardPage").show();
				return false;
			});
			$("#submitBtn").bind("tap", function() {
				action.doSubmit();
				return false;
			});
			$("#secondBtn").bind("tap", function() {
				$("#second").hide();
				$("#first").show();
				return false;
			});
			$("#submitBtn2").bind("tap", function() {
				action.doSubmit();
				return false;
			});
			$("#submitBtn4").bind("tap", function() {
				$.platform.succBack(action.constant.loginphone);
				return false;
			});
			$("#submitBtn5").bind("tap", function() {
				var newCode = $(".new-code").UITextField("value");
				var repeatCode = $(".repeat-code").UITextField("value");
				var passwordReg = /[A-Za-z].*[0-9]|[0-9].*[A-Za-z]/;
				if(newCode.length != 8 || repeatCode.length != 8){
	                   $.UIPopup("密码长度应该是8位！");
	                   return false;
	               }
	            if(action.hasSpace(newCode) || action.hasSpace(repeatCode)){
	                   $.UIPopup("密码不能包含空格!");
	                   return false;
	            }
	           	if(!passwordReg.test(newCode)){
	           		$.UIPopup("请输入8位的数字字母组合！");
					return false;
				}
	           	if(!passwordReg.test(repeatCode)){
	           		$.UIPopup("请输入8位的数字字母组合！");
					return false;
				}
	            if (newCode != repeatCode){
	            	$.UIPopup("两次输入密码不一样！");
	            	return false;
	            }
				action.merOpenAcco(repeatCode)
				return false;
			});
			$("#thirdBackBtn").bind("tap", function() {
				$("#third").hide();
				$("#second").show();
				return false;
			})
		},
		hasSpace : function(str){
	           var arr = str.split(" ");
	           if (arr.length != 1){
	               return true;
	           }else{
	               return false;
	           }
	      },
		passwordKeyboard :  function(id, succ) {
			var password = "";
			var password2 = "";
			var keyValues = [];
			var $board = $(id),
			pswPlace = 6,
			psw,
			repsw,
			inputNotice = $("#input-notice"),
			pswBlock = $(".psw-block"),
			dot = pswBlock.find(".psw-dot");
			$board.on('tap', '.kb-btn', function() {
				var obj = $(this), keyValue = obj.attr('key-value'), resetPsw;
				obj.addClass('active');
				setTimeout(function() {
					obj.removeClass('active');
				}, 200);
				if (obj.hasClass('kb-del')) {
					keyValues.pop();
					dot.each(function(idx) {
						if (idx == keyValues.length) $(this).hide();
					});
				} else if (obj.hasClass('kb-reset')) {
					if (keyValues.length != pswPlace) {
						keyValues = [];
						dot.hide();
					}
				} else {
					if (keyValues.length > pswPlace - 1) {
						return false;
					}
					dot.each(function(idx) {
						if (idx < keyValues.length + 1) {
							$(this).show();
						}
					});
					keyValues.push(keyValue);
					if (keyValues.length == pswPlace) {
						if (psw) {
							repsw = keyValues.join('');
							if(psw == repsw){// 密码对比正确
								succ(repsw);
							}else{// 密码对比错误
								pswBlock.addClass('error');
								setTimeout(function(){
									pswBlock.removeClass('error');
									inputNotice.removeClass('flick').text('请设置交易密码');
									keyValues = [];
									psw='';
									dot.hide();
								},2000);
							}
						} else {
							psw = keyValues.join('');
							setTimeout(function(){
								inputNotice.text('请再次输入').addClass('flick');
								keyValues = [];
								dot.hide();
							}, 200);
						}
					}
				}
				$board.data('password', keyValues);
				return false;
			});
			return {
				reset : function() {
					psw = repsw = null;
					keyValues = [];
					dot.hide();
					inputNotice.removeClass('flick').text('请设置交易密码');
					$board.removeData('password');
				}
			}
		},
		sandclock :  {
			run : function() {
				if (action.constant.counter == 0) {
					$("#smscodebtn").attr("m-state","");
					$("#smscodebtn").html("获取");
				} else {
					$("#smscodebtn").html((action.constant.counter--)+"秒");
					setTimeout("action.sandclock.run()", 1000);
				}
			},
			start : function() {
				action.constant.counter = 120;
				$("#smscodebtn").attr("m-state","disabled");
				$("#smscodebtn").html((action.constant.counter--)+"秒");
				setTimeout("action.sandclock.run()", 1000);
			}
		},
		validateForm1 : function() {
			var bankserial = action.constant.bankserial;
			if (!bankserial) {
				$.UIAlert("请选择银行");
				return false;
			}
			return true;
		},
		validateForm : function() {
			var identitytype = $("#identitytype").UISelectField("value").trim();
			var identityno = $("#identityno").UITextField("value");
			var capitalmode = "r";
			var bankacco = $("#bankacco").UITextField("value").trim();
			var customername = $("#custname").UITextField("value").trim();
			var sex = $.trim($("#sexSel_div").UISelectField("value")); //性别
			var isvalidopenacco = "0";
			var busintype = "OPENACCO";
			var reg = /^(\d{15}|\d{18}|\d{17}[a-zA-Z]{1})$/;
			var handsetReg = /^[0-9]{11}$/;
			var numReg = /^\d+$/;

			if (!action.constant.bankserial || action.constant.bankserial == "") {
				$.UIPopup("请选择银行");
				return false;
			}
			var mobileval =  $("#telephone").UITextField("value").trim();
			if(null==mobileval || "" == mobileval){
				$.UIPopup("请输入手机号码！");
            	return false;
			}
			/*if ("" == identityno) {
				$.UIAlert("请输入证件号码！");
				return false;
			}
			if ("0" == identitytype && !reg.test(identityno)) {
				$.UIAlert("请输入正确的身份证号码！");
				return false;
			}*/
			var validForm = $.validForm();
			if("0" == identitytype){
				validForm.add("cerfiticate",identityno);
				if(!(validForm.valid())){
					return false;
				}
			}
			if ("" == bankacco) {
				$.UIAlert("请输入银行卡号！");
				return false;
			}
			if ("" == customername) {
				$.UIAlert("请输入您的真实姓名！");
				return false;
			}
			if ("" == identityno) {
				$.UIAlert("请输入您的证件号码！");
				return false;
			}
			if (!numReg.test(bankacco)) {
				$.UIAlert("银行卡号必须为数字！");
				return false;
			}
			action.constant.telephone = mobileval;
			var data = "mobile_open="+action.constant.loginphone+"&busintype=OPENACCO&capitalmode="+capitalmode+"&bankacco=" + bankacco
						+ "&customerappellation=" + customername + "&identitytype=" + identitytype
						+ "&identityno=" + identityno + "&bankserial=" + action.constant.bankserial
						+ "&isvalidopenacco=" + isvalidopenacco + "&busintype=" + busintype
						+ "&bankname="+action.constant.bankname + "&signbiztype=02&terminal=HTML5"
						+ "&mobile="+mobileval + "&chinapyh5returnurl="+$.hsf.appBaseUrl+"capital/chinapay/chinapayHtml5RomtePgConfirm.json";
			return data;
		},
		doSubmit: function() {
			var data = action.validateForm();
			if (data) {
				$.hsf.startLoading();
				$.hsf.ajax.app("capital/chinapay/chinapayHtml5openaccoOrder", encodeURI(data), "doChinapayOpenaccoOrderCallback", function(jsonResult) {
					if (jsonResult && jsonResult.successful) {
						$("#first").hide();
						var url = $.hsf.chanpayURL+encodeURI(jsonResult.data);
						$.hsf.hsOpen(url);
//						action.loadChinapay(url);
						$.hsf.stopLoading();
					} else {
						$.hsf.stopLoading();
						$.hsf.callFailProcess(jsonResult);
					}
				});
			}
		},
		loadChinapay : function(url) {
			$.hsf.ajax.html("../pages/chinapay-view.html", function(html) {
				$("body").prepend(html);
				require(["pages/chinapay-view"], function(m) {
					param = {
						accoreqserial : "",
						identitytype : $("#identitytype").UISelectField("value").trim(),
						identityno :  $("#identityno").UITextField("value"),
						customername : $("#custname").UITextField("value").trim(),
						url : url
					}
					m.init(param);
				});
			});
		},
		addChinapaySuccListener : function() {
			$.hsf.Event.addListener("chinapaySucc", function(obj) {
				action.constant.applyserial = obj;
				$("#second").hide();
				$("#third").show();
			});
		},
		//调用商户级别开户
        merOpenAcco : function(tradepassword) {
        	var identitytype = $("#identitytype").UISelectField("value").trim();
			var identityno = $("#identityno").UITextField("value");
			var bankacco = $("#bankacco").UITextField("value").trim();
			var customername = $("#custname").UITextField("value").trim();
            var sex = "1" || $("#sexSel_div").UISelectField("value");//性别
            var birthday = ""//生日
            birthday = birthday.replace(/\-/g,"");
            var workcode = "08";
            var zipcode = "000000"; //邮编
            var encrypt = new JSEncrypt()
						encrypt.setPublicKey($.hsf.publicKey);
            var data = "applyserial="+action.constant.applyserial
//            	+	"&bankname="+action.constant.bankname
//            	+	"&bankserial="+action.constant.bankserial//银行编号
                +	"&capitalmode=r"//资金方式
//                +	"&handset="+action.constant.telephone//手机号码
//                +	"&customerappellation="+customername//姓名
//                +	"&bankacco="+bankacco//银行账号
//                +	"&identityno=" +identityno//证件号码
//                +	"&identitytype=" +identitytype//证件类型
                +	"&password="+encodeURIComponent(encrypt.encrypt(tradepassword))//交易密码
//                +	"&sex="+sex//性别
//                +	"&birthday="+birthday//生日
//                +	"&workcode="+workcode//职业代码
//                +	"&zipcode="+zipcode//邮编
                +	"&detailcapitalmode=01"//明细资金方式
                +	"&reckoningsendtype=1"//对账单寄送方式
                +	"&reckoningmailtype=2"//对账单寄送途径
                +	"&invalidate=99991231"//默认永久有效
                +	"&nationality2=156"//国籍默认中国
                +	"&riskability=2";//风险承受能力,默认保守型
                console.log(data);
            $.hsf.startLoading("正在提交...");
            $.hsf.ajax.app("account/openacco/openacco",decodeURI(data), "openaccocallback", action.meropenaccoCallback);
        },
        sendMessageToHJS : function(){
        	$.hsf.ajax.app("threeparty/customized/notify", "mobile="+action.constant.telephone, "noticeb2ccallback", function(jsonResult) {
	    		if (jsonResult.successful) {

	    		}
        	});
        },
		meropenaccoCallback: function(jsonResult) {
			$.hsf.stopLoading();
			if (jsonResult && jsonResult.successful) {
				$.hsf.ajax.app('account/login/login', 'mobile=' + jsonResult.mobile,
						'loginCode', function(jsonResult) {
							if (jsonResult && jsonResult.successful) {
								$.platform.removeCache('clientid');
								$.platform.putCache('clientid', {
									clientid: jsonResult.clientid,
									custname: jsonResult.custname,
								});
							}
						});
				action.constant.loginphone = jsonResult.mobile;
				action.sendMessageToHJS();
				$('#third').hide();
				$('#four').show();
			} else {
				$.UIAlert(jsonResult.message, function() {
					$.platform.removeCache('clientid');
					$.platform.closeHSpage();
				});
				return false;
			}
		},
        validate2 : function(){
            var tradepassword = $.trim($("#tradepassword").UITextField("value"));
            var tradepassword2 = $.trim($("#tradepassword2").UITextField("value"));
            var birthday = action.constant.birthday ||$("#birthday_dateField").UIDateField("value");//生日
            birthday = birthday.replace(/\-/g,"");
            var mobile = action.constant.mobile || $("#mobile").UITextField("value");//手机号码
            var zipcodeReg = /^[0-9]{6}$/;
            var mobileReg = /^[1]\d{10}$/;
            if(""==birthday){
               $.UIPopup("请输入您的生日！");
				return false;
            }
            if("" == mobile){
               $.UIPopup("请输入手机号码！");
                return false;
            }
            if(!mobileReg.test(mobile)){
               $.UIPopup("请输入正确的手机号码！");
            	return false;
            }
            if(""==tradepassword){
               $.UIPopup("请输入8位数字交易密码！");
                return false;
            }else if(tradepassword.length!=8){
               $.UIPopup("密码需要8位有效数字！");
                return false;
            }
            if(tradepassword!=tradepassword2){
               $.UIPopup("两次密码输入不一致！");
                return false;
            }
            return true;
        }
	}
	window.action = action;
	return action;

})
