define(["global", "Backbone", "swiper"], function(G) {

    // 添加关注按钮
    var addFavor = function() {
        $(".fund-favor").off('tap').on('tap', function() {
            var _self = $(this);
            var fundcode=_self.attr("code");
            var status;
            $("#idxSearchInput input").blur();
            if (constant.mapfav&&constant.mapfav[fundcode]=="1") {
                status=false;
            }else{
                status=true;
            }
            var data;
            if(constant.openId){
                data = "status="+status+"&fundcode="+fundcode+"&openId="+constant.openId
            }else{
                data = "status="+status+"&fundcode="+fundcode
            }
            $.hsf.startLoading();
            $.hsf.ajax.app("account/myfollows/followChange", data, "addFavoriteCallback", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    constant.followChanged=true;
                    if(status){//关注
                        if(!constant.mapfav){
                            constant.mapfav=[];
                        }
                        constant.mapfav[fundcode]="1";
                        constant.mapfavArray[constant.mapfavArray.length]=fundcode;
                    }else{//取消关注
                        constant.mapfav[fundcode]=null;
                        for(var i=0;i<constant.mapfavArray.length;i++){
                            if(constant.mapfavArray[i]==fundcode){
                                Array.prototype.remove=function(dx){
                                    if(isNaN(dx)||dx>this.length){return false;}
                                    for(var i=0,n=0;i<this.length;i++){
                                        if(this[i]!=this[dx]){
                                            this[n++]=this[i];
                                        }
                                    }
                                    this.length-=1;
                                }
                                constant.mapfavArray.remove(i);
                            }
                        }
                    }
                    $.platform.removeCache("myfollows");
                    $.platform.putCache("myfollows", {myfollows:constant.mapfavArray});
                    if ( $("[code='"+fundcode+"']").hasClass('on')) {
                        $("[code='"+fundcode+"']").removeClass('on');
                    } else {
                        $("[code='"+fundcode+"']").addClass('on');
                    }
                }else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
            return false;
        });
    };

    var constant = {
        followChanged:false,//关注是否改变
        result:null,//产品列表
        mapfav:null,//map格式产品列表
        mapfavArray:[]//关注产品未格式化数组
    };

    return Backbone.View.extend({
        el: "#home",
        title: {
            left: {
                show: false
            },
            center: {
                text: "首页"
            },
            border: {
                show: false
            }
        },
        lastRequestTime: null,
        openid:null,
        firstLoad:true,
        events: {
            "tap #followmore":"followMore",
        },
        followMore:function () {
            window.location.hash = "discover";
            this.parent.setParam("m-id", "rel_2");
        },
        initialize: function(parent, platformApi) {
            var that = this;
            //this.platformApi = platformApi;
            //this.platformApi.initPage(that);
            $("body").removeClass('m-bg-white');
            that.setLabelSize();
            that.closeAdTxt();
            that.searchBtn();
            that.parent=parent;

            that.platformApi = platformApi;
            that.platformApi.initPage(this);
            that.mhref();
            that.taskGenerate = $.taskGenerate(6,function () {
                that.firstLoad=false;
                $.hsf.stopLoading();
                that.parent.unlockNavigate();
            });
            that.taskGenerate.add(1,null,function () {
                $(".idx-marquee").show();
            });
            that.parent.lockNavigate();//锁导航栏
            //获取盛钱宝
            that.initJSP(2);
            //this.getLikeList();
            //推荐基金
            that.getDiscoverList();
            that.getPhotoList(0);
            that.requestManager = $.hsf.requestManager(this);
            that.requestManager.add(that.getPhotoList,60);//广告 60s更新一次
            $.platform.getCache("myfollows", function(result) {
                if (result && result.myfollows) {
                    constant.mapfavArray=result.myfollows;
                    if(result/*&&result.length!=0*/){
                        //if(!constant.mapfav){
                        constant.mapfav={};
                        //}
                        for(var i=0;i<result.myfollows.length;i++){
                            constant.mapfav[result.myfollows[i]]="1";
                        }
                    }
                }
            });
            $.platform.getCache("fundlist", function(result) {
                if (result) {
                    //$.UIPopup("A="+result.length);
                    //$.hsf.startLo+resultading();
                    that.searchResult(result.productList);
                    //$.hsf.stopLoading();
                } else {
                    $.platform.getCache("openId", function(openId) {
                        constant.openId = openId;
                        that.requestProductlist(constant.openId);
                    });

                }
            });
            $.platform.getCache("openId", function(openId) {
                constant.openId = openId;
                that.getConcernList(4);
            });
            //获取关注列表&猜你喜欢列表
            this.getLikeList(5,function () {
                if(that.taskGenerate.get(4).result.successful && that.taskGenerate.get(4).result.myFollows.length>0) {
                    return false;
                }
                return true;
            });
            $.hsf.Event.addListener("login", function () {
                that.initJSP();
            });
            $.hsf.Event.addListener("Navigate",function () {
                if($("#indexSearchbarClose").hasClass('on')){
                    $("#indexSearchbarClose").trigger("tap");
                }
            });
            $.hsf.Event.addListener("Follow",function () {
                if(!($("[m-id='home']").hasClass("active"))){
                    $.platform.getCache("myfollows", function(result) {
                        if (result && result.myfollows) {
                            constant.mapfavArray = result.myfollows;
                            if (result/* && result.length != 0*/) {
                                //if (!constant.mapfav) {
                                constant.mapfav = {};
                                //}
                                for (var i = 0; i < result.myfollows.length; i++) {
                                    constant.mapfav[result.myfollows[i]] = "1";
                                }
                            }
                        }
                    });
                }
                that.getConcernList({},function (len) {
                    $.hsf.stopLoading();
                    if(len <=0){
                        /*$.platform.getCache("LikeList", function (LikeList4) {
                         if (LikeList4 && LikeList4.LikeList) {
                         $.doTemplate("concernList", LikeList4.LikeList, "refresh");
                         $("#concernId").html("猜你喜欢");
                         } else {
                         that.getLikeList();
                         }
                         });*/
                        that.getLikeList();
                    }
                });
            });
        },
        focusRefresh:function(fundcode,status){
            var _that =this;
            if(status){//关注
                if(!constant.mapfav){
                    constant.mapfav=[];
                }
                constant.mapfav[fundcode]="1";
                constant.mapfavArray[constant.mapfavArray.length]=fundcode;
            }
            else{//取消关注
                constant.mapfav[fundcode]=null;
                for(var i=0;i<constant.mapfavArray.length;i++){
                    if(constant.mapfavArray[i]==fundcode){
                        Array.prototype.remove=function(dx){
                            if(isNaN(dx)||dx>this.length){ return false;}
                            for(var i=0,n=0;i<this.length;i++){
                                if(this[i]!=this[dx]){
                                    this[n++]=this[i]
                                }
                            }
                            this.length-=1
                        };
                        constant.mapfavArray.remove(i);
                    }
                }
            }
            _that.getConcernList({},function (len) {
                $.hsf.stopLoading();
                //$.UIPopup("len："+len);
                if(len <=0){
                    _that.getLikeList();
                }
            });
        },
        triggerFollow:function () {
            if(constant.followChanged){
                constant.followChanged=false;
                //触发关注事件：
                if($.hsf.Event.hasKey("Follow"))
                    $.hsf.Event.trigger("Follow");
            }
        },
        //获取轮播图列表
        getPhotoList : function(taskIndex) {
            var that = this;
            var plist = [];
            //$.hsf.startLoading();
            var adsGroup = null;
            var platformApi = $.hsf.platform();
            if(platformApi=="platform/pcapi"||platformApi=="platform/weixinapi"){
                adsGroup = "WeixinIndexAd";
                return $.hsf.ajax.app("wxzt/m", "functionCode=1047&adsGroup="+adsGroup+"&originalId=App", "getPhotoListCallBack", function(jsonResult) {
                    function loadAd(jsonResult) {
                        if(jsonResult && "ETS-5BP0000"==jsonResult.code){
                            var result = jsonResult.message?JSON.parse(jsonResult.message):null;//eval('('++')');
                            if(result && result.result) {
                                plist = result.result.list;
                                if(constant.openId){
                                    for(var index=0,len=plist.length;index<len;index++) {
                                        if(plist[index].url){
                                            if(plist[index].url.indexOf("{wxname}")){
                                                plist[index].url=plist[index].url.replace("{wxname}",constant.openId);
                                            }
                                        }
                                    }
                                    $.doTemplate('photoArea', plist);
                                    that.resetSwiper(result.result.adsInterval);
                                }else{
                                    $.platform.getCache("openId", function(openId) {
                                        constant.openId = openId;
                                        for(var index=0,len=plist.length;index<len;index++) {
                                            if(plist[index].url){
                                                if(plist[index].url.indexOf("{wxname}")){
                                                    plist[index].url=plist[index].url.replace("{wxname}",constant.openId);
                                                }
                                            }
                                        }
                                        $.doTemplate('photoArea', plist);
                                        that.resetSwiper(result.result.adsInterval);
                                    });
                                }
                            }else{
                                $.doTemplate('photoArea', plist);
                                that.resetSwiper(2000);
                            }
                        }else{
                            $.doTemplate('photoArea', plist);
                            that.requestManager.resetTime(that.getPhotoList);
                            that.resetSwiper();
                        }
                    }
                    if(!isNaN(taskIndex))
                        that.taskGenerate.add(taskIndex,jsonResult,loadAd);
                    else
                        loadAd(jsonResult);
                });
            }else if(platformApi=="platform/iosapi" || platformApi=="platform/androidapi"){
                setTimeout(function(){
                    $.platform.getCache("openId", function(openId) {
                        constant.openId = openId;
                        $.hsf.ajax.app("wxzt/m","functionCode=1028&openid="+openId,"getSubscribeTimeCallBack",function(jsonResult){
                            if(jsonResult && "ETS-5BP0000"==jsonResult.code){
                                var subscribeTime = jsonResult.message&&JSON.parse(jsonResult.message)&&JSON.parse(jsonResult.message).result.subscribeTime;
                                var days = subscribeTime&&parseInt(Math.abs(new Date()-new Date(subscribeTime))/1000/60/60/24);
                                if(days<=7){
                                    adsGroup = "newappindexAd";
                                }else{
                                    adsGroup = "AppIndexAd";
                                }
                                return $.hsf.ajax.app("wxzt/m", "functionCode=1047&adsGroup="+adsGroup+"&originalId=App", "getPhotoListCallBack", function(jsonResult) {
                                    function loadAd(jsonResult) {
                                        if(jsonResult && "ETS-5BP0000"==jsonResult.code){
                                            var result = jsonResult.message?JSON.parse(jsonResult.message):null;//eval('('++')');
                                            if(result && result.result) {
                                                plist = result.result.list;
                                                if(constant.openId){
                                                    for(var index=0,len=plist.length;index<len;index++) {
                                                        if(plist[index].url){
                                                            if(plist[index].url.indexOf("{wxname}")){
                                                                plist[index].url=plist[index].url.replace("{wxname}",constant.openId);
                                                            }
                                                        }
                                                    }
                                                    $.doTemplate('photoArea', plist);
                                                    that.resetSwiper(result.result.adsInterval);
                                                }else{
                                                    $.platform.getCache("openId", function(openId) {
                                                        constant.openId = openId;
                                                        for(var index=0,len=plist.length;index<len;index++) {
                                                            if(plist[index].url){
                                                                if(plist[index].url.indexOf("{wxname}")){
                                                                    plist[index].url=plist[index].url.replace("{wxname}",constant.openId);
                                                                }
                                                            }
                                                        }
                                                        $.doTemplate('photoArea', plist);
                                                        that.resetSwiper(result.result.adsInterval);
                                                    });
                                                }
                                            }else{
                                                $.doTemplate('photoArea', plist);
                                                that.resetSwiper(2000);
                                            }
                                        }else{
                                            $.doTemplate('photoArea', plist);
                                            that.requestManager.resetTime(that.getPhotoList);
                                            that.resetSwiper();
                                        }
                                    }
                                    if(!isNaN(taskIndex))
                                        that.taskGenerate.add(taskIndex,jsonResult,loadAd);
                                    else
                                        loadAd(jsonResult);
                                });
                            }
                        });
                    });
                },2000);
            }
            //return $.hsf.ajax.app("wxzt/m", "functionCode=1047&adsGroup="+adsGroup+"&originalId=App", "getPhotoListCallBack", function(jsonResult) {
            //    function loadAd(jsonResult) {
            //        if(jsonResult && "ETS-5BP0000"==jsonResult.code){
            //            var result = jsonResult.message?JSON.parse(jsonResult.message):null;//eval('('++')');
            //            if(result && result.result) {
            //                plist = result.result.list;
            //                if(constant.openId){
            //                    for(var index=0,len=plist.length;index<len;index++) {
            //                        if(plist[index].url){
            //                            if(plist[index].url.indexOf("{wxname}")){
            //                                plist[index].url=plist[index].url.replace("{wxname}",constant.openId);
            //                            }
            //                        }
            //                    }
            //                    $.doTemplate('photoArea', plist);
            //                    that.resetSwiper(result.result.adsInterval);
            //                }else{
            //                    $.platform.getCache("openId", function(openId) {
            //                        constant.openId = openId;
            //                        for(var index=0,len=plist.length;index<len;index++) {
            //                            if(plist[index].url){
            //                                if(plist[index].url.indexOf("{wxname}")){
            //                                    plist[index].url=plist[index].url.replace("{wxname}",constant.openId);
            //                                }
            //                            }
            //                        }
            //                        $.doTemplate('photoArea', plist);
            //                        that.resetSwiper(result.result.adsInterval);
            //                    });
            //                }
            //            }else{
            //                $.doTemplate('photoArea', plist);
            //                that.resetSwiper(2000);
            //            }
            //            //$.hsf.stopLoading();
            //        }else{
            //            $.doTemplate('photoArea', plist);
            //            that.requestManager.resetTime(that.getPhotoList);
            //            that.resetSwiper();
            //        }
            //    };
            //    if(!isNaN(taskIndex))
            //        that.taskGenerate.add(taskIndex,jsonResult,loadAd);
            //    else
            //        loadAd(jsonResult);
            //
            //});
        },
        //获取关注列表列表
        packConcernList:function(myFollows) {
            var tools = $.hsf.hsTools;
            if(myFollows.length!=0){
                for ( var j = 0; j < myFollows.length; j++) {
                    myFollows[j].navdate = tools.yyyy_mm_dd(myFollows[j].navdate);
                    myFollows[j].dayinc = tools.decimal2(myFollows[j].dayinc,100,"%");
                    myFollows[j].incomeratio = tools.decimal4(myFollows[j].incomeratio);
                    if(typeof myFollows[j].fundtypestr == "string")
                        myFollows[j].fundtypestr = myFollows[j].fundtypestr.replace(/^(.)(.+)/,"$1");
                }
                var ConcernList4 = [];
                if(myFollows.length>4){
                    for ( var k = 0; k < 4; k++) {
                        ConcernList4.push(myFollows[k]);
                    }
                }else{
                    ConcernList4 = myFollows;
                }
                $.doTemplate("concernList", ConcernList4, "refresh");
                $("#concernId").html("我的关注");
                //$.hsf.stopLoading();
            }
            if(myFollows.length>4){
                $("#followmore").show();
            } else
                $("#followmore").hide();
        },
        //csGetMarketValueGate = "1";//0：代表关，1：代表开   默认为开  是否按照持有份额排序
        getConcernList: function(taskIndex,callback) {
            var that = this;
            var data="";
            if(constant.openId){
                data = "&openId="+constant.openId;
            }
            $.hsf.startLoading();
            $.hsf.ajax.app("account/myfollows/followQuery", "csGetMarketValueGate=1"+data, "followQueryCallback", function(jsonResult) {
                //$.hsf.stopLoading();
                function packConcernList(jsonResult) {
                    if(callback)
                        callback(jsonResult.successful?jsonResult.myFollows.length:0);
                    if (jsonResult.successful) {
                        that.packConcernList(jsonResult.myFollows);
                    }
                    else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                }
                if( $.hsf.platform()== "platform/pcapi"){
                    jsonResult = {successful:true,myFollows:[]};//不显示我的关注
                }
                if(!isNaN(taskIndex))
                    that.taskGenerate.add(taskIndex,jsonResult,packConcernList);
                else
                    packConcernList(jsonResult);
            });
        },
        //获取猜你喜欢列表
        // pi_qsrq 排名起始日期
        // pi_jzrq 排名结束日期
        getLikeList: function(taskIndex,callback) {
            function formatDate(date,seprater) {
                seprater = seprater || "";
                var year = date.getFullYear();
                var month = date.getMonth() + 1;
                var day = date.getDate();
                return [year, month, day].map(formatNumber).join(seprater);
            }
            function formatNumber(n) {
                n = n.toString();
                return n[1] ? n : '0' + n;
            }
            var that = this;
            //   $.hsf.startLoading("正在提交申请...");
            var date = new Date();
            var end = formatDate(date);
            date.setMonth(date.getMonth()-3);
            var start = formatDate(date);
            $.hsf.ajax.app("product/wind/webapi/queryWindWhichYouLike", "pi_qsrq="+start+"&pi_jzrq="+end, "pqueryWindWhichYouLikeCallback", function(jsonResult) {
                //$.hsf.stopLoading();
                function packLikeList(jsonResult) {
                    //console.log("task3 success--"+taskGenerate.get(3).result.successful+";length--"+taskGenerate.get(3).result.myFollows.length);
                    if(callback && !callback()){
                        return ;
                    }
                    var tools = $.hsf.hsTools;
                    if (jsonResult.successful) {
                        //if(jsonResult.myFollows.length==0){
                        //    //查询猜你喜欢
                        //}
                        for ( var j = 0; j < jsonResult.result.length; j++) {
                            var like = jsonResult.result[j];
                            like.navdate = tools.yyyy_mm_dd(like.navdate);
                            like.dayinc = tools.decimal2(like.dayinc,100,"%");//*100
                            like.incomeratio = tools.decimal4(like.incomeratio);
                            if(typeof like.fundtypestr == "string")
                                like.fundtypestr = like.fundtypestr.replace(/^(.)(.+)/,"$1");
                        }
                        var LikeList4 = [];
                        if(jsonResult.result.length>4){
                            for ( var k = 0; k < 4; k++) {
                                LikeList4.push(jsonResult.result[k]);
                            }
                        }else{
                            LikeList4 = jsonResult.result;
                        }
                        $.platform.putCache("LikeList", {LikeList:LikeList4});
                        $.doTemplate("concernList", LikeList4, "refresh");
                        $("#concernId").html("猜你喜欢");
                        //$.hsf.stopLoading();
                    } else {
                        $.doTemplate("concernList", [], "refresh");
                        $("#concernId").html("猜你喜欢");
                        $.hsf.callFailProcess(jsonResult);
                    }
                }
                if(!isNaN(taskIndex))
                    that.taskGenerate.add(taskIndex,jsonResult,packLikeList);
                else
                    packLikeList(jsonResult);
            });
        },
        constant : {
            ztDict : {
                "dayinc":{key:"dayinc", value:"日涨跌(%)"},
                "seasonhinc":{key:"sessonhinc", value:"近3月收益(%)"},
                "halfinc":{key:"halfinc", value:"近半年收益(%)"},
                "yearinc":{key:"yearinc", value:"近1年收益(%)"},
                "threeyearinc":{key:"threeyearinc",value:"近3年收益(%)"},
                "thisyearinc":{key:"thisyearinc", value:"今年以来收益(%)"},
                "setupinc":{key:"setupinc", value:"成立以来收益(%)"},
                "default" :{key:"thisyearinc", value:"今年以来收益(%)"},
                "incomeratio" :{key:"incomeratio", value:"七日年化(%)"}
            }
        },
        //获取推荐基金
        getDiscoverList : function() {
            $.hsf.startLoading();
            var that = this;
            $.hsf.ajax.app("product/product/findPage", "riskcheck=true&riskmatch=true", "discoverListCallback", function(jsonResult) {
                //$.hsf.stopLoading();
                that.taskGenerate.add(3,jsonResult,function (jsonResult) {
                    var tools = $.hsf.hsTools;
                    if (jsonResult.successful) {
                        if (jsonResult.recommendList) {
                            for ( var j = 0; j < jsonResult.recommendList.length; j++) {
                                jsonResult.recommendList[j].navdate = tools.yyyy_mm_dd(jsonResult.recommendList[j].navdate);
                                jsonResult.recommendList[j].dayinc = tools.decimal4(jsonResult.recommendList[j].dayinc);
                                jsonResult.recommendList[j].seasonhinc = tools.decimal2(jsonResult.recommendList[j].seasonhinc);
                                jsonResult.recommendList[j].halfinc = tools.decimal2(jsonResult.recommendList[j].halfinc);
                                jsonResult.recommendList[j].yearinc = tools.decimal2(jsonResult.recommendList[j].yearinc);
                                jsonResult.recommendList[j].threeyearinc = tools.decimal2(jsonResult.recommendList[j].threeyearinc);
                                jsonResult.recommendList[j].thisyearinc = tools.decimal2(jsonResult.recommendList[j].JNYLSYL);
                                jsonResult.recommendList[j].setupinc = tools.decimal2(jsonResult.recommendList[j].setupinc);
                                jsonResult.recommendList[j].incomeratio = tools.decimal4(jsonResult.recommendList[j].incomeratio);
                                jsonResult.recommendList[j].pernetvalue = tools.decimal4(jsonResult.recommendList[j].pernetvalue);

                                if (!jsonResult.recommendList[j].tags) {
                                    jsonResult.recommendList[j].tags = [];
                                }

                                var rateGD = that.constant.ztDict[jsonResult.recommendList[j].incInterval];
                                if (rateGD) {
                                    jsonResult.recommendList[j].rate = rateGD;
                                } else {
                                    jsonResult.recommendList[j].rate = that.constant.ztDict["default"];
                                }
                            }
                            //最多显示4条
                            var recommendList4 = [];
                            if(jsonResult.recommendList.length>4){
                                for ( var k = 0; k < 4; k++) {
                                    recommendList4.push(jsonResult.recommendList[k]);
                                }
                            }else{
                                recommendList4 = jsonResult.recommendList;
                            }
                            //对推荐基金进行排序,按照中台配置的fundsort进行排序。
                            recommendList4.sort(function (a,b) {
                                return a.fundsort < b.fundsort ? 1:-1;
                            });
                            $.doTemplate("recommend", recommendList4, "refresh");

                            $.doTemplate('recommandList', recommendList4,"refresh");

                            $("[m-role='UITableView']").UITableView("refresh");
                        }
                    } else {
                        if(jsonResult.code == "ETS-5BA00016"){
                            $.UIConfirm("您未做风险测评或测评结果已过期，如需查看推荐产品，您需要做风险测评",function(isOk){
                                if(isOk == "yes"){
                                    $.hsf.hsOpen("investment-suitability.html?flag=b");
                                }
                            });
                        }else{
                            $.hsf.callFailProcess(jsonResult);
                        }
                    }
                });
            });
        },
        getDiscoverListOther : function() {
            $.hsf.startLoading();
            var that = this;
            $.hsf.ajax.app("product/product/findPage", "riskcheck=true&riskmatch=true", "discoverListCallback", function (jsonResult) {
                $.hsf.stopLoading();
                var tools = $.hsf.hsTools;
                if (jsonResult.successful) {
                    if (jsonResult.recommendList) {
                        for (var j = 0; j < jsonResult.recommendList.length; j++) {
                            jsonResult.recommendList[j].navdate = tools.yyyy_mm_dd(jsonResult.recommendList[j].navdate);
                            jsonResult.recommendList[j].dayinc = tools.decimal4(jsonResult.recommendList[j].dayinc);
                            jsonResult.recommendList[j].seasonhinc = tools.decimal2(jsonResult.recommendList[j].seasonhinc);
                            jsonResult.recommendList[j].halfinc = tools.decimal2(jsonResult.recommendList[j].halfinc);
                            jsonResult.recommendList[j].yearinc = tools.decimal2(jsonResult.recommendList[j].yearinc);
                            jsonResult.recommendList[j].threeyearinc = tools.decimal2(jsonResult.recommendList[j].threeyearinc);
                            jsonResult.recommendList[j].thisyearinc = tools.decimal2(jsonResult.recommendList[j].JNYLSYL);
                            jsonResult.recommendList[j].setupinc = tools.decimal2(jsonResult.recommendList[j].setupinc);
                            jsonResult.recommendList[j].incomeratio = tools.decimal4(jsonResult.recommendList[j].incomeratio);
                            jsonResult.recommendList[j].pernetvalue = tools.decimal4(jsonResult.recommendList[j].pernetvalue);
                            if (!jsonResult.recommendList[j].tags) {
                                jsonResult.recommendList[j].tags = [];
                            }

                            var rateGD = that.constant.ztDict[jsonResult.recommendList[j].incInterval];
                            if (rateGD) {
                                jsonResult.recommendList[j].rate = rateGD;
                            } else {
                                jsonResult.recommendList[j].rate = that.constant.ztDict["default"];
                            }
                        }
                        //最多显示4条
                        var recommendList4 = [];
                        if (jsonResult.recommendList.length > 4) {
                            for (var k = 0; k < 4; k++) {
                                recommendList4.push(jsonResult.recommendList[k]);
                            }
                        } else {
                            recommendList4 = jsonResult.recommendList;
                        }
                        //对推荐基金进行排序,按照中台配置的fundsort进行排序。
                        recommendList4.sort(function (a,b) {
                            return a.fundsort < b.fundsort ? 1:-1;
                        });
                        $.doTemplate("recommend", recommendList4, "refresh");

                        $.doTemplate('recommandList', recommendList4, "refresh");

                        $("[m-role='UITableView']").UITableView("refresh");
                    }
                } else {
                    if (jsonResult.code == "ETS-5BA00016") {
                        $.UIConfirm("您未做风险测评或测评结果已过期，如需查看推荐产品，您需要做风险测评", function (isOk) {
                            if (isOk == "yes") {
                                $.hsf.hsOpen("investment-suitability.html?flag=b");
                            }
                        });
                    } else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                }

            });
        },
        initJSP: function (taskIndex) {
            var that = this;
            $.hsf.ajax.app("query/share/csMoneyFundShare", "datasource=DS", "checkLoginCode", function (jsonResult) {
                function packJSP(jsonResult) {
                    $(".proswiper-box").css("visibility","visible");
                    if (jsonResult.successful) {
                        //$.hsf.stopLoading();
                        //$(".proswiper-box").show();
                        //$(".proswiper-box").css("visibility","visible");
                        $("#homeIncomeratio").html(jsonResult.incomeratio+"%");
                        $("#homeHfincomeratio").html(jsonResult.hfincomeratio);
                        if(jsonResult.extra){//盛钱宝首页营销短语
                            var extra = JSON.parse(jsonResult.extra);
                            $("#jspFirstGG").html(extra.jspFirstGG).show();
                            $(".marquee").html(extra.systemMessage);
                        }
                        //盛钱宝第二页展示逻辑
                        if(jsonResult.isLogin==1){//登陆后
                            that.loadXjb(jsonResult);
                        }else{//未登陆
                            that.loadXjbNoLogin(jsonResult);
                        }
                    }
                    else {
                        //that.requestManager.resetTime(that.initAsset);
                        $.hsf.callFailProcess(jsonResult);
                    }
                }
                if(!isNaN(taskIndex))
                    that.taskGenerate.add(taskIndex,jsonResult,packJSP);
                else
                    packJSP(jsonResult);
            });
        },
        //获取产品列表
        requestProductlist:function (openid) {
            //$.UIPopup("b="+constant.openId);
            var that = this;
            $.hsf.startLoading();
            var data;
            if(constant.openId){
                data = 'openId=' + constant.openId;
            }else{
                data = '';
            }
            $.hsf.ajax.app("product/product/productInfoList", data, "productListback", function(jsonResult) {
                if (jsonResult.successful) {
                    that.reBulidData(jsonResult.productList);
                    $.platform.putCache("fundlist", jsonResult);
                    /*if(!constant.mapfav){//转换格式的关注列表
                     constant.mapfav=[];
                     }*/
                    constant.mapfav = [];
                    if(jsonResult.myFollows){
                        for(var i=0;i<jsonResult.myFollows.length;i++){
                            constant.mapfav[jsonResult.myFollows[i]]="1";
                        }
                        $.platform.putCache("myfollows", {myfollows:jsonResult.myFollows});
                        constant.mapfavArray=jsonResult.myFollows;//未转换格式的关注列表
                    }
                    that.searchResult(jsonResult.productList);
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        //组装搜索关键字字段
        reBulidData:function(fundlist){
            for(var i=0;i<fundlist.length;i++){
                fundlist[i].keywords=fundlist[i].fundname+fundlist[i].fundcode;
            }
        },
        //initJSP:function(){
        //    var that=this;
        //    $.hsf.startLoading();
        //    $.hsf.ajax.app("account/main/homePage", "", "checkLoginCode", function (jsonResult) {
        //        if (jsonResult.successful) {
        //            $.hsf.stopLoading();
        //                $("#homeIncomeratio").html(jsonResult.incomeratio+"%");
        //                $("#homeHfincomeratio").html(jsonResult.hfincomeratio);
        //        }
        //        else {
        //            //that.requestManager.resetTime(that.initAsset);
        //            $.hsf.callFailProcess(jsonResult);
        //        }
        //    });
        //
        //    $.hsf.ajax.app("account/main/homePage", "isSameLogin=0&isNeedTotalMarket=1", "checkLoginCode", function (jsonResult) {
        //        if (jsonResult.successful) {
        //            $.hsf.stopLoading();
        //            if(jsonResult.isLogin==1){
        //                that.loadXjb(jsonResult);
        //            }else{
        //                that.loadXjbNoLogin(jsonResult);
        //            }
        //        }
        //        else {
        //            //that.requestManager.resetTime(that.initAsset);
        //            $.hsf.callFailProcess(jsonResult);
        //        }
        //    });
        //},
        loadXjb: function (jsonResult) {
            $("#moneyFundDayincome").html(jsonResult.dayincome);
            $("#home_totalincome").html(jsonResult.totalIncome);
            $("#totalIncome").html(jsonResult.totalIncome);
            $(".jspLoginAndAsset").show();
            $(".unloginAndNoasset").hide();
        },
        loadXjbNoLogin: function (jsonResult) {
            if(jsonResult.extra){//盛钱宝三日成交量
                var json_extra = JSON.parse(jsonResult.extra);
                $("#yearinc").html(json_extra.oneYearIncome);
                $("#threeDayDeal").html(parseInt(json_extra.threeDayDeal)+parseInt(300*Math.random()));
            }
            $(".jspLoginAndAsset").hide();
            $(".unloginAndNoasset").show();
        },

        initBanner: function(a,b,adsInterval) {
            if (a) {
                this.newSwiper(adsInterval);
            }
            if (b) {
                this.proSwiper = this.proSwiper();
            }
        },
        render: function() {

        },
        afterSwitchView: function() {

            $("body").removeClass('m-bg-white');
            //this.requestManager.invoke(this.getPhotoList);
            //获取轮播图列表
            if(!this.firstLoad)
                this.requestManager.invoke(this.getPhotoList);
            //this.resetSwiper();
            this.getDiscoverListOther();
            // if($(".marquee-animate").length==0) this.marquee(10);


        },
        newSwiper: function(adsInterval) {
            this.swiper = new Swiper('.index-swiper', {
                autoplay: adsInterval || 3000,
                loop: true,
                paginationClickable: true,
                centeredSlides: true,
                pagination: '.swiper-pagination',
                autoplayDisableOnInteraction: false
            });
        },
        proSwiper: function() {
            return new Swiper('.proswiper', {
                prevButton: '.proswiper-prev',
                nextButton: '.proswiper-next'
            });
        },
        resetSwiper: function(adsInterval) {
            //if (!this.swiper) {
            this.initBanner(true,false,adsInterval);
            //} else {
            //    this.swiper.update();
            //    //               this.swiper && (function(swiper) {
            //    //                   swiper.destroy(false);
            //    //                   swiper = null;
            //    //                   swiper = swiper.newSwiper()(this.swiper);
            //    //               });
            //}
            if (!this.proSwiper||!(Object.prototype.toString.call(this.proSwiper)==="[object Object]")) {
                this.initBanner(false,true);
            } else {
                this.proSwiper.update();
            }
        },
        //       resetSwiper :  function() {
        //           if (!this.swiper) {
        //               this.initBanner();
        //           } else {
        //               this.swiper && (function(swiper) {
        //                   swiper.destroy(false);
        //                   swiper = null;
        //                   swiper = new Swiper('.index-swiper', {
        //                       pagination: '.swiper-pagination',
        //                       paginationClickable: true,
        //                       centeredSlides: true,
        //                       autoplay: 2500,
        //                       autoplayDisableOnInteraction: false
        //                   })(this.swiper);
        //               });
        //           }
        //       },
        setLabelSize:function(){
            var winW=$(window).width();
            if(winW<340){
                $(".idx-pro-label").css({
                    "font-size":"10px"
                });
            }else{
                $(".idx-pro-label").css({
                    "font-size":"12px"
                });
            }
        },
        closeAdTxt:function(){//关闭无效需修改
            $(".idx-adtext-close").on('tap',function(){
                $(".idx-marquee").slideUp();
                return false;
            });
        },

        // marquee:function(dur,delay){
        //
        //     var delay=delay||100;
        //     var dur=dur||5;//play time
        //     var marquee=$(".marquee"),width=marquee.children().length?marquee.children().outerWidth():marquee.outerWidth(),parentWidth=$(".idx-marquee-txt").outerWidth();
        //
        //     var head=$("head");
        //     var style="<style>.marquee-animate{-webkit-animation: rollTxt "+dur+"s linear infinite ;animation: rollTxt "+dur+"s linear infinite ;}  @-webkit-keyframes rollTxt {0% {-webkit-transform: translate3d("+parentWidth+"px,0,0);} 100% {-webkit-transform: translate3d(-"+width+"px,0,0);}}</style>";
        //     head.append(style);
        //
        //     marquee.addClass('marquee-animate');
        //
        // },

        // 搜索按钮
        searchBtn: function() {
            var that = this;
            $("#idxSearchInput").on('tap', function() {
                $(this).find('input').focus();
                $("#indexSearchbarClose").addClass('on');
                $("#idxAccountBtn").hide();
                $(".nav-searchbar-result").addClass('on');
                $(window).scrollTop(0);
                return false;
            });
            $("#indexSearchbarClose").on('tap', function() {
                $("#idxSearchInput input").val('').blur();
                $(".nav-searchbar-result").removeClass('on');
                $("#idxAccountBtn").show();
                $(".nav-searchbar-list dl").empty();
                $(this).removeClass('on');
                that.triggerFollow();
                return false;
            });
        },
        // 搜索结果
        searchResult:function(result){
            var that=this;

            for (var index in result) { //排序
                result.sort(function(a, b) {
                    return parseFloat(a.seasonhinc) < parseFloat(b.seasonhinc) ? 1 : -1;
                });
            }
            var data=result;


            //// 基金数据
            //var data={
            //    0:{
            //        fundname:"长盛电子信息产业",
            //        fundcode:"324503",
            //        fundtype:"混",
            //        keywords:"长盛电子信息产业324503"
            //    },
            //    1:{
            //        fundname:"长盛混合型",
            //        fundcode:"389363",
            //        fundtype:"混",
            //        keywords:"长盛混合型389363"
            //    },
            //    2:{
            //        fundname:"长盛保本型",
            //        fundcode:"522677",
            //        fundtype:"保",
            //        keywords:"长盛保本型522677"
            //    }
            //}

            // 返回拼装好的html结构
            var listDom=function(fundname,fundcode,fundtype,keyword,fundtypestr){
                var fd=fundcode;
                fundname=search_do(fundname,keyword);
                fundcode=search_do(fundcode,keyword);
                var dom=['<dd m-href="fund-detail.html?fundcode='+fd+'">',
                    '<div m-role="cell" m-layout="fit" m-valign="middle" class="padding-l-10 padding-r-10">',
                    '<div m-role="cell" m-layout="fit" m-mode="y" m-padding="1 0 1 0">',
                    '<div m-role="cell" class="m-font-14">'+fundname+'</div>',
                    '<div m-role="cell" m-valign="middle">',
                    '<div class="m-font-14 m-font-light" m-margin="0 1 0 0">'+fundcode+'</div>',
                    '<div class="fund-tag fund-tag-min">'+fundtypestr.substr(0,1)+'</div>',
                    '</div>',
                    '</div>',
                    '<div m-role="cell" code='+fd+' class="fund-favor padding-10'+(constant.mapfav&&constant.mapfav[fd]=="1"?" on":" ")+'">',
                    '<div m-icon="fund-like"></div>',
                    '</div>',
                    '</div>',
                    '</dd>'];
                var domHtml=dom.join('');
                return domHtml;
            };

            // 输入事件
            $("#idxSearchInput input").on('input',function(){
                var _self=$(this),
                    val= $.trim(_self.val());

                var searchResultHtml="";
                if(val){
                    $.each(data, function(index, v) {
                        if(v.keywords.indexOf(val)!=-1){
                            searchResultHtml+=listDom(v.fundname,v.fundcode,v.fundtype,val, v.fundtypestr);
                        }
                    });
                }

                $(".nav-searchbar-list dl").html(searchResultHtml);
                addFavor();
            });

            // 清空事件
            $("#idxSearchInput").on('blur','input',function(){
                if($(this).val()==""){
                    $(".nav-searchbar-list dl").empty();
                }

            });
            //$("#idxSearchInput .UITextFieldClear").on('tap',function(){
            //    $(".nav-searchbar-list dl").empty();
            //});

            // 高亮关键字
            function search_do(content,keyWord){
                var keyWordArr = keyWord.replace(/[\s]+/g,' ').split(' ');
                var re;
                for(var n = 0; n < keyWordArr.length; n ++) {
                    //re = new RegExp(">[\s\S]*?"+keyWordArr[n]+"[\s\S]*?<\S","gmi");
                    re = new RegExp(""+keyWordArr[n]+"","gmi");
                    content = content.replace(re,'<span class="keyword-highlight">'+keyWordArr[n]+'</span>');
                }
                return content;
            }
        },

        //按钮链接
        mhref:function(){
            //工资宝
            // $("#gzb").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/adv/pages/xsyx/index.html"));
            $("#gzb").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/adv/pages/xsyx/index.html"));
            // $("#gzb").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/adv/pages/gzb/index.html"));
            //定投区
            $("#dtq").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/adv/pages/dtn/index.html"));
            //金算盘组合
            $("#jspzh").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/adv/pages/jspzh/index.html"));
            //活动区
            $("#hdq").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/adv/pages/hdq/index.html"));
            //在线客服
            $("#zxkf").on("tap",function () {
              //$.hsf.goOnlineService();
              if($.hsf.platform()=="platform/iosapi"){
                $.platform.openChat && $.platform.openChat();
              }else{
                $.hsf.hsOpen("webpage.html?url="+encodeURIComponent("https://www.csfunds.com.cn/hsipccweb/chat/addcustinfo?subtrade=def&channelId=0&idType=10")+"&ischat=true");
              }
              return false;
            });
//            $("#zxkf").attr("m-href","webpage.html?url="+encodeURIComponent("https://www.csfunds.com.cn/hsipccweb/chat/addcustinfo?subtrade=def&channelId=0&idType=10")+"&ischat=true");
            //常见问题
            $("#cjwt").attr("m-href","webpage.html?url="+encodeURIComponent("https://trade.csfunds.com.cn/csweisvr/notice/index.html"));
            //设置
            $("#sz").on('tap',function(){
                $.hsf.startLoading();
                $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                    $.hsf.stopLoading();
                    if (jsonResult.successful) {
                        $.hsf.hsOpen("account-setting.html");
                    } else {
                        $.hsf.innerLogin();
                    }
                });
                return false;
            });
            //账户管理
            $("#zhgl").on('tap', function () {
                $.hsf.startLoading();
                $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                    $.hsf.stopLoading();
                    if (jsonResult.successful) {
                        $.hsf.hsOpen("account-info.html");
                    } else {
                        $.hsf.innerLogin();
                    }
                });
                return false;
            });
        }
    });
});
