define("pages/investment-suitability-a", ["Backbone"], function (B) {
    return Backbone.View.extend({
        title: {
            left: {
                show: $.hsf.hsTools.getParam("hsback")=="1"
            },
            center: {
                text: "资料修改"
            }
        },
        el: "#investment-suitability-a",
        _private: {
            beneficiaryname:"",
            holdingname:"",
            record:"",//不良记录
            IDTYPE:"0",
            provincecode:"",
            cityno:"",
            proviceAndCities:[], // 一级省
            cities:[],// 地级市
            contries:[],// 区县
        },
        choiceTag:"0",//1 诚信记录  2实际控制人  3实际受益人 输入框弹出的输入对象
        initialize: function (global) {
            var that = this;
            this.global = global;
            //获取字典项（职业、学历）
            this.renderUserInfo();
            this.validForm = $.validForm();
            this.formGenerate = $.formGenerate();
            this.period();
            this.record();
            this.radio();
            if ($.hsf.matchNative()) {
                $.platform.addListener("refreshAccount",function(){
                    window.location.reload();
                    return false;
                })
            }
            this.getCrsInfo();
            $(document).on('tap','#keep',function(){
                var val=$('.feedback_txt textarea').val();
                if(val==''){
                    $.UIPopup("请输入内容!");
                    return false;
                }else {
                    if (that.choiceTag == '1') {//诚信
                        that._private.record = val;
                    } else if (that.choiceTag == '2') {//实际控制人
                        that._private.holdingname = val;
                    } else if (that.choiceTag == '3') {//实际收益人
                        that._private.beneficiaryname = val;
                    }
                    $("[m-role='right']").empty();
                    $('#investment-suitability-a').addClass('view-active');
                    $('#explain-one').removeClass('view-active');
                    $('.feedback_txt textarea').val("");
                }
            });
            $("#validdateSwitch").UISwitch("change", function (value) {
                if (value == 1) {
                    $("#dateLine").hide();
                    $("#modifyVal").UIDateField("value","长期有效");
                } else {
                    $("#dateLine").show();
                    var value1 =  $("#modifyVal").UIDateField("value");
                    if(value1=="长期有效"){
                        $("#modifyVal").UIDateField("value","");
                        $("#modifyVal").trigger("tap");
                    }
                }
            });

            $("#jumin").UISelectField("change",function(val){
                if(val=="1"){
                   $.UIAlert("您的税收居民身份请到网上交易修改。");
                   return;
                }
            })
            //拦截柜台用户，引导去开通网上委托
            $.platform.getCache("loginInfo", function(cacheResult) {
                if (!!cacheResult && cacheResult.custRole == "DB") {
                    $("#nextBtn").hide();
                    $.UIConfirm({"html": $.hsf.openEntrust
                    ,"submitText":" 确定","cancelText":"取消"},function(result){
                      if(result == "yes") {
                        if($.hsf.matchNative()){
                            $.platform.hsOpenAndCloseSelf("account-openetrading.html");
                        }else{
                            $.platform.hsOpen("account-openetrading.html");
                        }
                      } else{
                        $.hsf.hsBack();
                      }
                    });
                }else{
                    $("#nextBtn").show();
                }
            });
        },
        events: {
            "tap #nextBtn": "next"
        },
        mobile:"",
        getCrsInfo: function () {
            var that=this;
            $.hsf.ajax.app("account/crs/querycrsinfo", "", "rscInfoCallBack", function (jsonResult) {
                if (jsonResult.successful) {
                    that._private.jsresult=jsonResult.result;
                    if(that._private.jsresult!=null){   //  crs修改
                        that._private.json_id = jsonResult.result.jsonid;
                    }
                }
            });
        },
        renderUserInfo:function(){
            var that = this;
            var ajaxLoginInfo = function(){
                return $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack");
            };
            var ajaxDict = function(name,ii){
                return $.hsf.ajax.app("atomicquery/account/dict", "dictname="+name, "pdictForm"+ii)
            };
            $.hsf.startLoading();
            $.when(ajaxLoginInfo(),ajaxDict("职业",1),ajaxDict("学历",2),ajaxDict("婚姻",3),ajaxDict("性别",4),ajaxDict("国籍代码",5))
                .done(function(logininfo,dict1,dict2,dict3,dict4,dict5){
                    that.userinfo=logininfo[0];
                    var userinfo = logininfo[0];
                    $.hsf.stopLoading();
                    if(userinfo.successful){
                        if (userinfo.result.invalidate.replace(/-/g, "") == '99991231') {
                            $('#validdateSwitch').UISwitch("state", "on");
                            $("#modifyVal").UIDateField("value", "长期有效");
                        }else {
                            $("#modifyVal").UIDateField("value", $.hsf.hsTools.yyyy_mm_dd(userinfo.result.invalidate));
                        }
                        // 身份证
                        that._private.IDTYPE = userinfo.result.idtype;
                        if(that._private.IDTYPE=="0"){
                            $("#notIdCard").hide();
                            $("#IdCard").show();
                        }else{
                            $("#notIdCard").show();
                            $("#IdCard").hide();
                        }
                        if(userinfo.result.marriage=='-'||userinfo.result.marriage==''){
                            userinfo.result.marriage=''
                        }
                        $.doTemplate('workcodeSel', dict1[0].dictResult.items);
                        $.doTemplate('educationalSel', dict2[0].dictResult.items);
                        // 婚姻状况增加非必填项
                        dict3[0].dictResult.items.unshift({key: '', value: '请选择'});
                        $.doTemplate('marriageSel', dict3[0].dictResult.items);
                        //性别
                        dict4[0].dictResult.items = dict4[0].dictResult.items.filter(function(item) {
                            return item.key == '0' || item.key == '1';
                        });
                        $.doTemplate("sexSel", dict4[0].dictResult.items);
                        // 国籍
                        if (userinfo.result.idtype == '0') {//身份证
                            that._private.countries = dict5[0].dictResult.items.filter(function(item) {
                                return item.key == '156';
                            });
                            $.doTemplate("countrySel",that._private.countries);
                            $("#country").UISelectField("value", "156");
                        } else {
                            dict5[0].dictResult.items.unshift({key: '', value: '请选择'});
                            that._private.countries = dict5[0].dictResult.items;
                            $.doTemplate("countrySel",that._private.countries);
                            $("#country").UISelectField("value", userinfo.result.nationality2);
                        }
                        that.packUserInfo(userinfo);
                    }else{
                        $.hsf.callFailProcess(userinfo)
                    }
                }).always(function () {
                    $.hsf.stopLoading();
                });
        },
        //初始化表单数据
        packUserInfo: function (jsonResult) {
            var that = this;
             var p = that._private;
            var userinfo = jsonResult.result;
            $("#custname").text(userinfo.customerappellation);
            if (userinfo.idtype == "0") {
                $("#idtype").text("身份证");
            } else if (userinfo.idtype == 'M') {
                $("#idtype").text("手机号");
            } else if (userinfo.idtype == "F") {
                $("#idtype").text("基金账号");
            } else if (userinfo.idtype == "4") {
                $("#idtype").text("港澳通行证");
            } else if (userinfo.idtype == "8") {
                $("#idtype").text("文职");
            } else if (userinfo.idtype == "9") {
                $("#idtype").text("警官");
            } else if (userinfo.idtype == "1") {
                $("#idtype").text("中国护照");
            } else if (userinfo.idtype == "2") {
                $("#idtype").text("军官证");
            } else if (userinfo.idtype == "3") {
                $("#idtype").text("士兵证");
            } else if (userinfo.idtype == "5") {
                $("#idtype").text("出生证/户口本");
            } else if (userinfo.idtype == "7") {
                $("#idtype").text("其他");
            }
            $("#idno").text(userinfo.idnostr);
            //身份证
            if ($.hsf.antiMoneyLaunder && userinfo.idtype == "0") {
                $.hsf.ajax.app("/atomicquery/account/hgxTradeRestrictQuery", "","callback",function(j){
                    if(j.successful){
                        var result = j.returnlist;
                        result = result&&result.sort(function(a,b){return a>b?1:-1})
                        if (result && result.length>0){
                            for (var i = 0; i < result.length; i++) {
                                var item = result[i];
                                function popMessage(item){
                                    if (item.status == "00") {//未审核
                                        that._private.needUploadIdentityImg = null;
                                        $("#certPicShow").show();
                                        $("#certPicText").text("待审核");
                                    } else if (item.status == "01") {//审核不过
                                        that._private.needUploadIdentityImg = "1";
                                        $("#certPicShow").show();
                                        $("#certPicText").text("审核失败");
                                    } else {// 未上传
                                        that._private.needUploadIdentityImg = "1";
                                        $("#certPicShow").show();
                                        $("#certPicText").text("未上传");
                                    }
                                }

                                if(item.checktype=="A4"){
                                    popMessage(item);
                                    break;
                                }else{
                                    if(item.limittype=="03"||item.limittype=="02"||item.limittype=="01"){
                                        popMessage(item);
                                        break;
                                    }else{
                                        p.needUploadIdentityImg = null;
                                        $("#certPicShow").show();
                                        $("#certPicText").text("已上传");
                                    }
                                }
                            }
                        }else{
                            p.needUploadIdentityImg = null;
                            $("#certPicShow").show();
                            $("#certPicText").text("已上传");
                        }
                    }
                });
                p.sex = $.hsf.hsTools.getSexFromCard(userinfo.idno)+"";//转化成字符串，不然验证不通过
                $("#cert-sex").text(p.sex=="0"?"女":"男");
                if(userinfo.invalidate=="99991231" || userinfo.invalidate==null || userinfo.invalidate=="23591231"){
                    invalidate = "长期有效";
                }else{
                    var currentDate = $.hsf.hsTools.getCurrentDate().replace(/-/g, "");
                    if(userinfo.invalidate<currentDate){
                        p.needUploadIdentityImg = "1";
                        $("#certPicText").text("重新上传");
                        $("#certPicShow").show();
                    }
                    invalidate = $.hsf.hsTools.yyyy_mm_dd(userinfo.invalidate);
                }
                $("#cert-validdate").text(invalidate);
                p.age = $.hsf.hsTools.getAge(userinfo.idno);
                $("#cert-birthday").text($.hsf.hsTools.getBirthdayFromCard(userinfo.idno));
                $("#certValiddateShow").show();
                $("#certSexShow").show();
                $("#certBirthdayShow").show();
                validdate = $("#cert-validdate").text(invalidate);
                birthday = $("#cert-birthday").text($.hsf.hsTools.getBirthdayFromCard(userinfo.idno));
                $("#dateLine").hide();
            }else{
                if(userinfo.invalidate=="99991231" || userinfo.invalidate==null || userinfo.invalidate=="23591231"){
                    invalidate="长期有效";
                }else{
                    invalidate = $.hsf.hsTools.yyyy_mm_dd(userinfo.invalidate);
                    $("#validdateSwitch").UISwitch("state","off")
                }
                $("#modifyVal").UIDateField("value",invalidate);
                p.sex = userinfo.sex=="0"?"0":"1";
                $("#sex").UISelectField("value",p.sex);
                if(userinfo.birthday && userinfo.birthday!=""){
                    var birthday = $.hsf.hsTools.yyyy_mm_dd(userinfo.birthday);
                    p.age = $.hsf.hsTools.jsGetAge(birthday);
                    $("#birthday").UIDateField("value", birthday);
                }
                $("#certupdateValiddateShow").show();
                $("#updateSexShow").show();
                $("#updateBirthdayShow").show();

                $("#validdate").UIDateField("value",invalidate);
                $("#birthday").UIDateField("value",userinfo.birthday?userinfo.birthday.replace(/(\d{4})(\d{2})(\d{2})/,"$1-$2-$3"):that.getBirthdayFromCard(userinfo.idno));
                $("#dateLine").show();
            }


            if(userinfo.beneficiary!=userinfo.customerappellation && userinfo.beneficiary!=""){
                that._private.beneficiaryname=userinfo.beneficiary;
                $(".beneficiary-period-change").html("他人");
            }else{
                that._private.beneficiaryname=userinfo.customerappellation;
                $(".beneficiary-period-change").html("本人");
            }

            if(userinfo.holdingname!=userinfo.customerappellation && userinfo.holdingname!=""){
                that._private.holdingname=userinfo.holdingname;
                $(".holdingname-period-change").html("他人");
            }else{
                that._private.holdingname=userinfo.customerappellation;
                $(".holdingname-period-change").html("本人");
            }
// 初始化省市
            that.renderProvincesAndCities(jsonResult);

            if(userinfo.badintegritydesc && userinfo.badintegritydesc!=""){//有不良记录
                that._private.record=userinfo.badintegritydesc;
                $('.unharmful').hide();
                $('.harmful').show();
                $('.change-record>div').each(function(i,dom){
                    if($(dom).text()=="不良"){
                        $(this).addClass('period-selected').siblings().removeClass('period-selected');
                    }
                });
            }else{
                that._private.record="";
                $('.unharmful').show();
                $('.harmful').hide();
                $('.change-record>div').each(function(i,dom){
                    if($(dom).text()=="无不良记录"){
                        $(this).addClass('period-selected').siblings().removeClass('period-selected');
                    }
                });
            }
            //$("#beneficiary").text(userinfo.beneficiary?userinfo.beneficiary:userinfo.customerappellation);
            //$("#holdingname").text(userinfo.holdingname?userinfo.holdingname:userinfo.customerappellation);
            $("#sex").UISelectField("value", userinfo.sex?userinfo.sex:that.getSexFromCard(userinfo.idno));
            if(userinfo.handset) $("#handset").UITextField("value",userinfo.handset);
            this.mobile = userinfo.handset;
            $("#email").UITextField("value", userinfo.email);
            $("#jobdutys").UITextField("value", userinfo.jobdutys);

            $("#marriage").UISelectField("value", userinfo.marriage);

            if (userinfo.workcode == null || userinfo.workcode == "" || userinfo.workcode == "09") {
                $("#workcode").UISelectField("value", "09");
            } else {
                $("#workcode").UISelectField("value", userinfo.workcode);
            }
            if (userinfo.educational == null || userinfo.educational == "" || userinfo.educational == "03") {
                $("#educational").UISelectField("value", "03");
            } else {
                $("#educational").UISelectField("value", userinfo.educational);
            }
        },
        //没有填写的，不再默认，添加“请点击选择”项
        processSelect: function(value,selector){
            if(value){
                $(selector).UISelectField("value", value);
            }else{
                $(selector).find("select").prepend("<option value disabled selected>请选择</option>");
                $(selector).find(".UISelectFieldText").html("请点击选择")
            }
        },
        // 省市
        renderProvincesAndCities: function (jsonResult) {
            var that = this;
            var p = that._private;
            //获取省份并选中
            p.proviceAndCities = jsonResult.proviceAndCities;
            $.doTemplate('provincecodeSel', p.proviceAndCities, "refreshable");
            that.processSelect("", "#provincecode"); // 请选择
            $("#cityPanel").hide();
            $("#countyPanel").hide();
            //切换省份下拉框
            $("#provincecode").UISelectField("change", function (value) {
                if (value != null && value != "") {
                    p.provincecode = value;
                    // //境外不显示市、区
                    for(var i=0;i<p.proviceAndCities.length;i++){
                        var province = p.proviceAndCities[i];
                        if (value == province.proviceno) {
                            if (province.cities.length > 0) {
                                p.cities = province.cities;
                                $.doTemplate('citynoSel', p.cities, 'refresh');
                                that.processSelect('', '#cityno');
                                $("#cityPanel").show();
                                $("#countyPanel").hide();
                            } else {
                                p.cities = [];
                                $.doTemplate('citynoSel', [], 'refresh');
                                $("#cityPanel").hide();
                                $("#countyPanel").hide();
                            }
                            break;
                        }
                    }
                } else {
                    $.hsf.stopLoading();
                    $("#citynoSel option").remove();
                }
            });
            //切换城市
            $("#cityno").UISelectField("change", function (value) {
                if (value != null && value != "") {
                    that._private.cityno = value;
                    for(var i=0;i<p.cities.length;i++){
                        var city = p.cities[i];
                        if (value == city.cityno) {
                            if (city.contries.length > 0) {
                                p.contries = city.contries;
                                $.doTemplate('countynoSel', p.contries,"refresh");
                                that.processSelect('', '#countyno');
                                $("#countyPanel").show();
                            } else {
                                p.contries = []
                                $.doTemplate('countynoSel', [],"refresh");
                                $("#countyPanel").hide();
                            }
                            break;
                        }
                    }
                } else {
                    $.hsf.stopLoading();
                    $("#countyPanel").hide();
                    $("#countynoSel option").remove();
                }
            });

            setTimeout(function(){
                $("#provincecode").UISelectField("value",jsonResult.result.provincecode);
                $("#cityno").UISelectField("value",jsonResult.result.cityno);
                $("#countyno").UISelectField("value",jsonResult.result.countyno);
            },100);

            //详细地址
            setTimeout(function () {
                var provinceValue = $("#provincecode option:selected").text() || "";
                var cityValue = $("#cityno option:selected").text() || "";
                var countyValue = $("#countyno option:selected").text() || "";
                var address;
                if (jsonResult.result && jsonResult.result.communicationaddr) {
                    address = jsonResult.result.communicationaddr.replace(provinceValue, "").replace(cityValue, "").replace(countyValue, "");
                } else {
                    address = ""
                }
                $("#detailedAddress").UITextField("value", address);
            }, 1000);
        },
        getSexFromCard:function(identityno){
            var sex=0;
            if(identityno.length==15){
                sex = identityno.substr(13,1);
            }else if(identityno.length==18){
                sex = identityno.substr(16,1);
            }
            return sex % 2;
        },
        getBirthdayFromCard:function (identityno){
            var year = '';
            var month = '';
            var day = '';
            if (identityno.length == 15) {
                year = '19' + identityno.substr(6, 2);
                month = identityno.substr(8, 2);
                day = identityno.substr(10, 2);
            } else if (identityno.length == 18) {
                year = identityno.substr(6, 4);
                month = identityno.substr(10, 2);
                day = identityno.substr(12, 2);
            }
            return year+"-"+month+"-"+day;
        },
        getAge :function(identityno){
            //获取年龄
            var myDate = new Date();
            var month = myDate.getMonth() + 1;
            var day = myDate.getDate();
            var age = myDate.getFullYear() - identityno.substring(6, 10) - 1;
            if (identityno.substring(10, 12) < month || identityno.substring(10, 12) == month && identityno.substring(12, 14) <= day) {
                age++;
            }
            return age;
        },
        addcrsinfoForm: function (dat, func) {
            return $.hsf.ajax.app("account/crs/addcrsinfo", dat, "addcrsinfo", func || function (jsonResult) {
            });
        },
        deletecrsinfoForm: function (dat2, func) {
            return $.hsf.ajax.app("account/crs/deletecrsinfo", dat2, "deletecrsinfo", func || function (jsonResult) {
            });
        },

        next: function () {
            $("[m-role='UITextField'] input").blur();
            var that = this;
            var juminVal = $("#jumin").UISelectField("value");
            if (juminVal == "1") {
                $.UIAlert("您的税收居民身份请到网上交易修改。");
                return;
            } else {
                var jsonId = that._private.json_id || "";
                dat=getJsonId(jsonId,"0")
            }

            function getJsonId(jsonId,oricustflag){
                var main = {
                    'engname': "",
                    'englastname': "",
                    'engcurrentworknation': "",
                    'engcurrentaddr': "",
                    'currentaddr': "",
                    'currentworknation': "",
                    'currentworkaddr': "",
                    'currentworkcity': "",// 中国的时候字段传空，外国的存省市字段的值
                    'bornnation': "",
                    'homeplace': "",
                    'engbornnation': "",
                    'enghomeplace': "",
                    'cust_flag': "",
                    'json_id': jsonId,
                    'oricustflag': oricustflag
                };
                var taxlist = [];
                var crsjson = {
                    "main": main,
                    "taxs": taxlist
                };
                dat = "crsjson=" + encodeURIComponent(JSON.stringify(crsjson));
                return dat;
            }
            var checkContract2 = $("#checkContract2").UICheckBox("value");
            if (checkContract2 != "yes2") {
                $.UIPopup("请确认已阅读《风险不匹配警示函》和《投资者确认书》!");
                return ;
            }
            var holdingname = that._private.holdingname;
            var beneficiary=that._private.beneficiaryname;
            var badintegritydesc="";
            if( that._private.record){
                badintegritydesc=that._private.record;
            }
            //身份证
            var validdate = '';
            var birthday = '';
            if($.hsf.antiMoneyLaunder && that._private.IDTYPE=="0"){
                validdate = $("#cert-validdate").text();
                birthday = $("#cert-birthday").text();
            }else{
                validdate = $("#modifyVal").UIDateField("value");
                birthday = $("#birthday").UIDateField("value");
            }
          invalidate = validdate=="长期有效" ? "9999-12-31" : validdate;
            //这里添加判断,如果是年龄大于46岁,则证件有效期只能选择长期,如果是年龄在26-45岁之间,则选择不能大于当前时间20年。如果是18-25岁之间,则选择时间不能大于10年。
            if(that._private.IDTYPE=="0"){
                var idno = that.userinfo.result && that.userinfo.result.idno;
                var age = that.getAge(idno);
                var invalidateType = $("#validdateSwitch").attr("m-value");	//1长期,0短期
                var invalidate = $("#modifyVal").UIDateField("value");  //用户选择的证件有效期日期

                if(age>=46){
                    //    大于46岁,不做限制。
                }else if(age>=26 && age <=45){
                    if(invalidateType == 1){
                        $.UIAlert("《中华人民共和国居民身份证法》规定：二十六周岁至四十五周岁的，发给有效期二十年的居民身份证。您输入的证件有效期不符合法规规定，请核实您身份证件上的有效期限后进行填写。");
                        return false;
                    }else{
                        //	获取一段时间差值,判断是否大于20
                        var selectDate = invalidate.replace(/-/g,"/");
                        var s1 = $.hsf.hsTools.yyyymmdd(new Date(selectDate));
                        var s2 = $.hsf.hsTools.add20Years();
                        if(s1 > s2){
                            $("#modifyVal").UIDateField("value","");
                            $.UIAlert("《中华人民共和国居民身份证法》规定：二十六周岁至四十五周岁的，发给有效期二十年的居民身份证。您输入的证件有效期不符合法规规定，请核实您身份证件上的有效期限后进行填写。");
                            return false;
                        }
                    }
                }else if(age >=18 && age <=25){
                    // 需要大于16 岁
                    if(invalidateType == 1){
                        $.UIAlert("《中华人民共和国居民身份证法》规定：十六周岁至二十五周岁的，发给有效期十年的居民身份证。您输入的证件有效期不符合法规规定，请核实您身份证件上的有效期限后进行填写。");
                        return false;
                    }else{
                        //	获取一段时间差值,判断是否大于10
                        var selectDate = invalidate.replace(/-/g,"/");
                        var s1 = $.hsf.hsTools.yyyymmdd(new Date(selectDate));
                        var s2 = $.hsf.hsTools.add10Years();
                        if(s1 > s2){
                            $("#modifyVal").UIDateField("value","");
                            $.UIAlert("《中华人民共和国居民身份证法》规定：十六周岁至二十五周岁的，发给有效期十年的居民身份证。您输入的证件有效期不符合法规规定，请核实您身份证件上的有效期限后进行填写。");
                            return false;
                        }
                    }
                }
            }
            var email = $("#email").UITextField("value").trim();
            var handset = $("#handset").UITextField("value").trim();
            var workcode = $("#workcode").UISelectField("value");
            if (that._private.IDTYPE == "0" && $.hsf.antiMoneyLaunder) {
                var sex = $("#cert-sex").text()=="男"?"1":"0";
            }else{
                var sex = $("#sex").UISelectField("value");
            }

            var marriage = $("#marriage").UISelectField("value");
            var educational = $("#educational").UISelectField("value");
            var jobdutys = $('#jobdutys').UITextField('value').trim();
            var country = $('#country').UISelectField('value');
            var birthday = '';

            if(jobdutys==""){
                jobdutys="[ISNULL]";
            }
            // 省市数据校验
            var provincecode = $('#provincecode').UISelectField('value').trim() || '';
            var provinceValue = $('#provincecode option:selected').text() || '';
            var cityno = $('#cityno').UISelectField('value').trim();
            var cityValue = $('#cityno option:selected').text() || '';
            var countyno = $("#countyno").UISelectField("value").trim();
            var countyValue = $("#countyno option:selected").text()||"";
            var detailedAddress = $('#detailedAddress').UITextField('value').trim() || '';
            var communicationaddr = '';//拼接后的地址
            if (provincecode == '') {
                $.UIPopup('请选择通讯地址所在省');
                return false;
            }else{
                if($.hsf.appendAddress){
                    communicationaddr = communicationaddr + provinceValue;
                }
            }
            if(provincecode=="99") { //境外不需要市、区
                cityno = "";
                countyno = "";
            }else{
                if (cityno=="" || cityno=="[ISNULL]") {
                    $.UIPopup('请选择通讯地址所在市');
                    return false;
                }else{
                    if($.hsf.appendAddress){
                        communicationaddr = communicationaddr + cityValue;
                    }
                }
                if (that._private.contries.length!==0) {// 71 台湾 81 香港
                    if (countyno == "" || countyno == "[ISNULL]") {
                        $.UIPopup('请选择通讯地址所在区/县');
                        return false;
                    } else {
                        if ($.hsf.appendAddress) {
                            communicationaddr = communicationaddr + countyValue;
                        }
                    }
                }
            }
            if(detailedAddress==""){
                $.UIPopup('请输入详细通讯地址');
                return false;
            }else{
                var senFlag = "";
                for(var i=0;i<$.hsf.addressSensitive.length;i++){
                    if(detailedAddress.indexOf($.hsf.addressSensitive[i])!=-1){
                        senFlag = $.hsf.addressSensitive[i];
                        break;
                    }
                }
                if(""!=senFlag){
                    $.UIPopup("通讯地址不能含有敏感词 ["+senFlag+"]");
                    return false;
                }
                communicationaddr = communicationaddr + detailedAddress;
            }

            if(that._private.IDTYPE=="0"&&$.hsf.antiMoneyLaunder){
                birthday = $("#cert-birthday").text().replace(/-/g,'');
                invalidate = $("#cert-validdate").text()==='长期有效'?"9999-12-31":$("#cert-validdate").text();
            }else{
                birthday  = $("#birthday").UIDateField("value").replace(/-/g,"");
                invalidate = ("1" == $("#validdateSwitch").attr("m-value")) ? "9999-12-31" : $("#modifyVal").UIDateField("value");
            }
            var dateReg = /^([0-9]{4})-([0-9]{2})-([0-9]{2})$/;
            this.validForm.add("empty", beneficiary, "请输入实际受益人");
            this.validForm.add("empty", holdingname, "请输入实际控制人");
            this.validForm.add("empty", handset, "请输入手机号码");
            this.validForm.add("empty", sex, "请选择性别");
            //this.validForm.add("empty", marriage, "请选择婚姻状况");
            this.validForm.add("empty", educational, "请选择学历");
            this.validForm.add("empty", workcode, "请选择职业");
            this.validForm.add("empty", country, "请选择国籍");
            this.validForm.add("empty", birthday, "请选择出生日期")
                .add("mobile", handset, "手机号码格式不正确")
                .add("empty", communicationaddr, "请输入通讯地址")
                .add("empty", email, "请输入邮箱地址")
                .add("email", email, "邮箱地址格式不正确");
            if("0" == $("#validdateSwitch").attr("m-value")){
                if ("" == invalidate || !dateReg.test(invalidate)) {
                    $.UIPopup("请选择您的证件有效期");
                    return false;
                }
            }

            if (this.validForm.valid()) {
                $.hsf.startLoading();
                var g = this.formGenerate;
                g.add("beneficiary", beneficiary);
                g.add("holdingname", holdingname);
                g.add("communicationaddr", communicationaddr);
                if (email && email != '无') {
                    g.add('email', email);
                }
                g.add("birthday", birthday);
                g.add("handset", handset);
                g.add("workcode", workcode);
                g.add("provincecode", provincecode);
                g.add("cityno", cityno);
                g.add("countyno", countyno);
                g.add("invalidate",invalidate.replace(/-/g,""));
                g.add("nationality2",country);
                g.add("sex", sex);
                g.add("jobdutys", jobdutys);
                g.add("netauditflag","1");
                g.add("marriage", marriage);
                g.add("educational", educational);
                g.add("badintegritydesc", badintegritydesc);
                g.add("datasource", "DS");
                function jumpCrs(jsonResult) {
                    if (that._private.jsresult != null) {
                        dat = getJsonId(that._private.json_id, "0");
                    }
                    that.addcrsinfoForm(dat).then(function (r1) {
                        if (r1.successful) {
                            $.UIAlert("修改成功", function () {
                                var flag = $.hsf.hsTools.getParam("flag");
                                if (flag && flag.indexOf("c") != -1) {
                                    window.location.hash = "investment-suitability-c";
                                } else {
                                    var hsback = $.hsf.hsTools.getParam("hsback");
                                    if (hsback == "1") {
                                        $.hsf.hsBack();
                                    } else {
                                        $.hsf.hsOpen("index.html");
                                    }
                                }
                            });
                        } else {
                            $.hsf.callFailProcess(r1);
                        }
                    })
                }
                if (this.mobile != handset) {
                    $.hsf.ajax.app("atomicquery/account/mobileusedinfo", "mobileno=" + handset, "mobileusedinfo", function (jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            var dcisexist = jsonResult.mobileUsedInfoQueryResult.dcisexist;
                            var dsisexist = jsonResult.mobileUsedInfoQueryResult.dsisexist;
                            if (dsisexist == 1) {
                                $.UIPopup("该手机号已经被使用，请使用其他手机号");
                                return;
                            } else {
                                $.hsf.ajax.app("account/account/modifyInfo", g.generate(), "modifyInfo", function (jsonResult) {
                                    if (jsonResult.successful) {
                                        jumpCrs(jsonResult);
                                    }else{
                                        $.hsf.callFailProcess(jsonResult);
                                    }
                                });
                            }
                        }else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }else{
                    $.hsf.ajax.app("account/account/modifyInfo", g.generate(), "modifyInfo", function (jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            jumpCrs(jsonResult)
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            }
        },
        //本人或他人
        period:function(){
            var that = this;
            $("#beneficiary-change").on("tap", function () {//实际收益人
                that.choiceTag="3";
                var Text=$(".beneficiary-period-change").text();
                $(".beneficiary-period-change").addClass('period-word');
                $('.mask').show();
                $("#data_box").addClass('active').show();
                $('.change-period>div').siblings().removeClass('period-selected');
                $('.change-period>div').each(function(i,dom){
                    if($(dom).text()== Text){
                        $(this).addClass('period-selected');
                    }
                });
            });

            $("#holdingname-change").on("tap", function () {
                that.choiceTag="2";
                var Text=$(".holdingname-period-change").text();
                $(".holdingname-period-change").addClass('period-word');
                $('.mask').show();
                $("#data_box").addClass('active').show();
                $('.change-period>div').siblings().removeClass('period-selected');
                $('.change-period>div').each(function(i,dom){
                    if($(dom).text()==Text){
                        $(this).addClass('period-selected');
                    }
                });
            });

            $('.change-period>div').on('tap',function(){
                var Text=$(this).text();
                if(Text=='他人'){
                    $("[m-role='right']").show();
                    var copy='<div m-role="UIButton"  class="back link" id="keep" style="color:#000">保存</div>';
                    $("[m-role='right']").append(copy);
                    if(that.choiceTag=="2"){//实际控制人
                        if(that._private.holdingname!=that.userinfo.result.customerappellation){
                            $('.feedback_txt textarea').val(that._private.holdingname);
                        }
                    }else if(that.choiceTag=="3"){//实际收益人
                        if(that._private.beneficiaryname!=that.userinfo.result.customerappellation){
                            $('.feedback_txt textarea').val(that._private.beneficiaryname);
                        }
                    }
                    $('#investment-suitability-a').removeClass('view-active');
                    $('#explain-one').addClass('view-active');
                }else{
                    if(that.choiceTag=="2"){//实际控制人
                        that._private.holdingname=that.userinfo.result.customerappellation;
                    }else if(that.choiceTag=="3"){//实际收益人
                        that._private.beneficiaryname=that.userinfo.result.customerappellation;
                    }
                }

                if($(this).hasClass('period-selected')){
                    $('.period-word').text(Text);
                }else {
                    $(this).addClass('period-selected').siblings().removeClass('period-selected');
                    $('.period-word').text(Text);
                }

                $("#backBtn").on('tap',function(){
                    if(that.choiceTag=="2"){//实际控制人
                        if(that._private.holdingname==that.userinfo.result.customerappellation){//如果之前选的是本人
                            $(".holdingname-period-change").html("本人");
                        }else{//如果之前选的是他人
                            $(".holdingname-period-change").html("他人");
                        }
                    }else if(that.choiceTag=="3"){//实际收益人
                        if(that._private.beneficiaryname==that.userinfo.result.customerappellation){
                            $(".beneficiary-period-change").html("本人");
                        }else{
                            $(".beneficiary-period-change").html("他人");
                        }
                    }
                    $('#investment-suitability-a').addClass('view-active');
                    $('#explain-one').removeClass('view-active');
                    $("[m-role='right']").empty();
                    $(this).off("tap");
                    $('.feedback_txt textarea').val("");
                    return false;
                });
                $(".holdingname-period-change").removeClass('period-word');
                $(".beneficiary-period-change").removeClass('period-word');
                $("#data_box").removeClass('active');
                $('.mask').hide();
            })
        },
        //记录
        record:function(){
            var that=this;
            $(".record-change").on("tap", function () {
                that.choiceTag="1";
                var Text=$(".record-change").text();
                $("#record_box").addClass('active').show();
                $('.mask').show();
                return false;
            });
            $('.change-record>div').on('tap',function(){
                var Text=$(this).text().replace(/(^\s*)|(\s*$)/g, "");
                if(Text=='不良'){
                    $("[m-role='right']").show();
                    var copy='<div m-role="UIButton"  class="back link" id="keep" style="color:#000">保存</div>';
                    $("[m-role='right']").append(copy);
                    $("#backBtn").on('tap',function(){//输入框后退按钮
                        if (that._private.record==""){//如果之前是无不良记录
                            $('.unharmful').show();
                            $('.harmful').hide();
                            $('.change-record>div').each(function(i,dom){
                                if($(dom).text()=="无不良记录"){
                                    $(this).addClass('period-selected').siblings().removeClass('period-selected');
                                }
                            });
                        }else{//如果之前勾选的是不良
                            $('.change-record>div').each(function(i,dom){
                                if($(dom).text()=="不良"){
                                    $(this).addClass('period-selected').siblings().removeClass('period-selected');
                                }
                            });
                        }
                        $('#investment-suitability-a').addClass('view-active');
                        $('#explain-one').removeClass('view-active');
                        $("[m-role='right']").empty();
                        $(this).off("tap");
                        $('.feedback_txt textarea').val("");
                        return false;
                    });
                    if(that._private.record!=""){
                        $('.feedback_txt textarea').val(that._private.record);
                    }
                    $('#investment-suitability-a').removeClass('view-active');
                    $('#explain-one').addClass('view-active');
                    $('.unharmful').hide();
                    $('.harmful').show();
                }else {
                    $('.unharmful').show();
                    $('.harmful').hide();
                    that._private.record="";
                }
                if(!$(this).hasClass('period-selected')){
                    $(this).addClass('period-selected').siblings().removeClass('period-selected');
                }
                $("#record_box").removeClass('active');
                $('.mask').hide();
            });
        },
        //按钮
        radio:function(){
            $('.cz_btn').on('tap', function () {
                var radioId = $(this).find('label').attr('name');
                $('.cz_btn label').removeAttr('class') && $(this).find('label').attr('class', 'checked');
                $('.cz_btn input[type="radio"]').removeAttr('checked') && $('#' + radioId).attr('checked', 'checked');
            });
        }
    });
});


define("pages/investment-suitability-b", ["Backbone"], function (Backbone) {
    return Backbone.View.extend({
        title: {
            left: {
                show: $.hsf.hsTools.getParam("hsback")=="1"
            },
            center: {
                text: "风险测评"
            }
        },
        action: {
            constant: {
                question: ""
            }
        },
        el: "#investment-suitability-b",
        initialize: function (parent, platformApi) {
            var that = this;
            this.parent = parent;
            this.platformApi = platformApi;
            $.hsf.startLoading();
            $.hsf.ajax.app("account/risk/getModifyRiskForm", "", "riskCallBack", function (jsonResult) {
                if (jsonResult.successful) {
                    that.action.constant.question = jsonResult.questionList;
                    that.action.constant.minrisklist = jsonResult.minrisklist;
                    var question1 = [];//风险问卷
                    var question2 = [];//诚信问卷
                    $(jsonResult.questionList).each(function (k, m) {
                        if (m.integrityflag == "" ||m.integrityflag == "0" || typeof m.integrityflag === 'undefined') {
                            question1.push(m);
                        }else if (m.integrityflag == "1") {
                            question2.push(m);
                        }
                    });
                    $.doTemplate("risk-form", [question1,question2,jsonResult.minrisklist,jsonResult.riskablilityStr], "keepid");
                    $("[m-role='UITableView']").UITableView();
                    that.getLoginInfo();
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
            //拦截柜台用户，引导去开通网上委托
            $.platform.getCache("loginInfo", function(cacheResult) {
                if (!!cacheResult && cacheResult.custRole == "DB") {
                    $("#risk-submit").hide();
                    $.UIConfirm({"html": $.hsf.openEntrust
                    ,"submitText":" 确定","cancelText":"取消"},function(result){
                      if(result == "yes") {
                        if($.hsf.matchNative()){
                            $.platform.hsOpenAndCloseSelf("account-openetrading.html");
                        }else{
                            $.platform.hsOpen("account-openetrading.html");
                        }
                      } else{
                        $.hsf.hsBack();
                      }
                    });
                }else{
                    $("#risk-submit").show();
                }
            });
        },
        events: {
            "tap #risk-submit": "preCheck",
            "tap #completeBtn": "nextPageC",
            "tap #agreement1": "agreementAlert"
            //"tap #checkContract1": "checkContract",
            //"tap #content": "showContent",
        },
        getLoginInfo:function(){
            $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                if (jsonResult.successful) {
                    if (jsonResult.result.pubhgflag!="1") {
                        $("#agreement").show();
                    }
                    $.hsf.stopLoading();
                }
            });
        },
        getNotificationPage:function (data,result) {
            $.hsf.ajax.html("../pages/notification1.html?result", function(html) {
                $("body").prepend(html);
                $(".e-page-nav").hide();
                $(".containerPage").hide();
                require(["pages/notification"], function(m) {
                    m.init(data,result);
                })
            });
        },
        agreementAlert: function () {
            $.UIAlert("长盛基金管理有限公司公募基金投资准入协议<br><br>按照《证券期货投资者适当性管理办法》第十四条规定公募基金的投资者要符合一定准入要求，请确认是否符合如下要求：<br>1、基金投资不保证盈利，投资者应具备基金风险识别能力和风险承担能力。<br>2、购买产品前如实填写了风险调查问卷，并且购买风险匹配的产品，如有超风险购买行为，看到相应的风险警示，会慎重考虑，愿意承担相应风险。");
            return false;
        },
        preCheck:function(){
            var that=this;
            var ddMarked = $("dd[m-marked='yes']");
            if (ddMarked.length < (this.action.constant.question.length+that.action.constant.minrisklist.length)) {
                var $riskform = $("#risk-form");
                $riskform.find("dl").each(function (i, n) {
                    var $dl = $(n);
                    if ($dl.find("dd[m-marked='yes']").length == 0) {
                        $dl.parent().blur().focus();
                        return false;
                    }
                });
                $.UIPopup("请做完风险测评再提交");
                return false;
            }

            if(!$("#agreement").is(":hidden")){
                var checkContract = $("#checkContract1").UICheckBox("value");
                if (checkContract!= "yes") {
                    $.UIPopup("请阅读并接受《准入要求》");
                    return false;
                }
            }

            var qnoandanswer = "";
            var minriskquestioncont="";
            ddMarked.each(function () {
                var _self = $(this);
                var qno = _self.parent().parent().attr("qno");
                var qanswer = _self.attr("qitemvalue");

                if(qno&&qno!=""&&qno!="undefined"){
                    qnoandanswer += "\"" + qno + "\"" + ":" + "\"" + qanswer + "\"" + ",";
                }else{
                    minriskquestioncont=qanswer;
                }
            });
            qnoandanswer = "{" + qnoandanswer.substr(0, qnoandanswer.length - 1) + "}";
            var data = "qnoandanswer=" + qnoandanswer+"&minriskquestioncont="+minriskquestioncont;
            $.hsf.startLoading("正在提交...");
            $.hsf.ajax.app("account/risk/modifyRisk", data+"&precheckflag=1", "risktestCallback", function (jsonResult) {
                if (jsonResult.successful) {
                    that.getNotificationPage(data,jsonResult);
                    $.hsf.stopLoading();
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
            return false;
        },
        //showContent:function () {
        //    window.location.hash = "investment-suitability-d";
        //},
        //checkContract: function () {
        //    var checkContract = $("#checkContract1").UICheckBox("value");
        //    if (checkContract == "yes") {
        //        $("#completeBtn").attr("m-state", "");
        //    } else {
        //        $("#completeBtn").attr("m-state", "disabled");
        //    }
        //},
        //next: function () {
        //    var ddMarked = $("dd[m-marked='yes']");
        //    if (ddMarked.length < this.action.constant.question.length) {
        //        var $riskform = $("#risk-form");
        //        $riskform.find("dl").each(function (i, n) {
        //            var $dl = $(n);
        //            if ($dl.find("dd[m-marked='yes']").length == 0) {
        //                $dl.parent().blur().focus();
        //                return false;
        //            }
        //        });
        //        $.UIPopup("请做完风险测评再提交");
        //        return false;
        //    }
        //    var qnoandanswer = "";
        //    ddMarked.each(function () {
        //        var _self = $(this);
        //        var qno = _self.parent().parent().attr("qno");
        //        var qanswer = _self.attr("qitemvalue");
        //        qnoandanswer += "\"" + qno + "\"" + ":" + "\"" + qanswer + "\"" + ",";
        //    });
        //    qnoandanswer = "{" + qnoandanswer.substr(0, qnoandanswer.length - 1) + "}";
        //    var data = "qnoandanswer=" + qnoandanswer;
        //    $.hsf.startLoading();
        //    $.hsf.ajax.app("account/risk/modifyRisk", data, "risktestCallback", function (jsonResult) {
        //        if (jsonResult.successful) {
        //            var riskablityStr = jsonResult.riskablilityStr;
        //            $("#risktype").html(riskablityStr);
        //            $("#risk-first").hide();
        //            $("#risk-second").show();
        //            $.platform.changeRisk && $.platform.changeRisk(riskablityStr);
        //            $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
        //                if (jsonResult.successful) {
        //                    $.hsf.stopLoading();
        //                    if (jsonResult.result.pubhgflag!="1") {
        //                        $("#agreement").show();
        //                        $("#completeBtn").attr("m-state", "disabled");
        //                    }else{
        //                        $("#completeBtn").attr("m-state", "");
        //                    }
        //                }
        //            });
        //
        //        } else {
        //            $.hsf.callFailProcess(jsonResult);
        //        }
        //    });
        //    return false;
        //},
        nextPageC: function () {
            var data = $.platform.warningchannel;
            $.hsf.startLoading();
            $.hsf.ajax.app("trade/common/todolist","warningchannel="+data,"toDoListCallBack",function(jsonResult){
                $.hsf.stopLoading();
                if (jsonResult.successful && $.hsf.hsTools.hasTodo(jsonResult)) {
                    window.location.hash = "investment-suitability-c";
                }else{
                    var flag = $.hsf.hsTools.getParam("flag");
                    if(flag && flag.indexOf("a")!=-1){
                        window.location.hash = "investment-suitability-a";
                    }else{
                        var hsback = $.hsf.hsTools.getParam("hsback");
                        if(hsback){
                            $.hsf.hsBack();
                        }else{
                            $.hsf.hsOpen("index.html");
                        }
                    }
                }
            });
            return false;
        }
    });
});


define("pages/investment-suitability-c", ["Backbone"], function (Backbone) {
    return Backbone.View.extend({
        title: {
            left: {
                show: $.hsf.hsTools.getParam("hsback")=="1"
            },
            center: {
                text: "待办事项"
            }
        },
        avgrHtmlcurrentTarget:"",//继续使用的定投点击目标
        todoList1:[],//定投类待办事项集合
        avgrTodo:null,//点击继续使用的定投待办事项
        todolistBData: "",
        el: "#investment-suitability-c",
        initialize: function (parent, platformApi) {
            var that = this;
            this.parent = parent;
            this.platformApi = platformApi;
            this.getTodolist();
            this.uievent();
            //拦截柜台用户，引导去开通网上委托
            $.platform.getCache("loginInfo", function(cacheResult) {
                if (!!cacheResult && cacheResult.custRole == "DB") {
                    $("#risk-submit").hide();
                    $.UIConfirm({"html": $.hsf.openEntrust
                    ,"submitText":" 确定","cancelText":"取消"},function(result){
                      if(result == "yes") {
                        if($.hsf.matchNative()){
                            $.platform.hsOpenAndCloseSelf("account-openetrading.html");
                        }else{
                            $.platform.hsOpen("account-openetrading.html");
                        }
                      } else{
                        $.hsf.hsBack();
                      }
                    });
                }else{
                    $("#risk-submit").show();
                }
            });
        },
        constant : {
            weeks : {
                "2" : "周一",
                "3" : "周二",
                "4" : "周三",
                "5" : "周四",
                "6" : "周五"
            }
        },
        events: {
            "tap .operation": "showWarnPage",
            "tap #ok": "ok",
            "tap .bbbOk": "bbbOk"
        },
        uievent:function(){
            var that=this;
            $("#trade-agreement-agree").bind("tap", function () {
                that.warnPageAgree();
                return false;
            });
            $("#trade-agreement-cancel").bind("tap", function () {
                that.warnPageCancel();
                return false;
            });
        },
        showWarnPage:function(html){
            var that= this;
            $("#warntitle").html("风险不匹配警示函");
            that.avgrHtmlcurrentTarget=html.currentTarget;
            var serialno = $(html.currentTarget).attr("data-id");
            var type = $(html.currentTarget).attr("data-type");
            if(type=="0"){//继续使用
                for(var i=0;i<that.todoList1.length;i++){
                    if(serialno==that.todoList1[i].serialno){
                        $("#showfundname").html(that.todoList1[i].fundname);
                        $("#showfundnamerisklevel").html(that.todoList1[i].fundriskStr);
                        $("#custrisklevel").html(that.todoList1[i].riskablilityStr);
                        that.avgrTodo=that.todoList1[i];
                    }
                }
                $("#tradeAgreementPage").show();
                $(".e-page-nav").hide();
                $(".containerPage").hide();
                return false;
            }else{
                that.next(that.avgrHtmlcurrentTarget);
            }
        },
        warnPageAgree:function(){
            var that= this;
            var checkContract3 = $("#checkContract3");
            if (!checkContract3.is(':checked')) {
                $.UIPopup("请确认已阅读《风险不匹配警示函》和《投资者确认书》!");
            }else{
                $("#tradeAgreementPage").hide();
                $(".e-page-nav").show();
                $(".containerPage").show();
                that.next(that.avgrHtmlcurrentTarget);
                return false;
            }
            return false;
        },
        warnPageCancel:function(){
            $("#tradeAgreementPage").hide();
            $(".e-page-nav").show();
            $(".containerPage").show();
            return false;
        },
        bbbOk: function (html) {
            var thats=this;
            var that = html;
            var id = $(html.currentTarget).attr("data-id");
            var requestno = $(html.currentTarget).attr("data-requestno");
            var warningno = $(html.currentTarget).attr("data-warningno");
            var fundcode = $(html.currentTarget).attr("data-fundcode");
            var businflag = $(html.currentTarget).attr("data-businflag");
            var placeholder = $(html.currentTarget).attr("data-placeholder");
            var requestlist = {};
            requestlist.serialno = id;
            requestlist.requestno = requestno;
            requestlist.warningno = warningno;
            requestlist.fundcode = fundcode;
            requestlist.businflag = businflag;
            requestlist.placeholder = placeholder;

            var request = new Array();
            request.push(requestlist);
            var data = "requestlist=" + JSON.stringify(request) + "&dealtype=0";

            $.hsf.startLoading("正在处理...");
            $.hsf.ajax.app("trade/common/dealAndTrace", data, "dealAndTrace", function (jsonResult) {
                $.hsf.stopLoading();
                if (jsonResult.successful) {
                    var $target = $(that.target).parent().parent();
                    $target.slideUp(function(){
                        $target.remove();
                        //$.UIPopup("待办事项处理成功!");
                        var content = $(".bbbOk").length;
                        if(content == 0){
                            //$(".e-has-notice").html("暂无需要处理的信息");
                        }
                        if($(".risk-change").length==0){
                            $.UIAlert("待办事项已全部处理完成！",function(){
                                thats.hsBack();
                            });
                        }
                    })
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
            return false;
        },
        ok: function () {
            var that = this;
            if($(".dt-item").length > 0 ){
                $.UIPopup("您还有待办事项需要处理");
                return false;
            }
            if(this.todolistBData.length>0){
                var data = "requestlist=" + JSON.stringify(this.todolistBData) + "&dealtype=0";
                $.hsf.startLoading();
                $.hsf.ajax.app("trade/common/dealAndTrace", data, "dealAndTrace", function (jsonResult) {
                    $.hsf.stopLoading();
                    if (jsonResult.successful) {
                        $.UIPopup("待办事项处理成功!");
                        $(".aaaTodo").remove();
                        if($(".risk-change").length==0){
                            $.UIAlert("待办事项已全部处理完成！",function(){
                                that.hsBack();
                            });
                        }
                    } else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                });
            }else{
                that.hsBack();
            }
        },
        hsBack:function(){
            var flag = $.hsf.hsTools.getParam("flag");
            var hsback = $.hsf.hsTools.getParam("hsback");
            if(flag && flag.indexOf("b")!="-1"){
                if(flag && flag.indexOf("a")!=-1){
                    window.location.hash = "investment-suitability-a";
                }else{
                    $.hsf.hsOpen("index.html");
                }
            } else{
                if(hsback){
                    $.hsf.hsBack();
                }else{
                    $.hsf.hsOpen("index.html");
                }
            }
        },
        formatAvgrDate : function(cycleunit, jyzq, jyrq) {
            var that=this;
            if ("0" === cycleunit) {
                jyzq = "每月";
                jyrq = jyrq+"日";
            } else if ("1" === cycleunit) {
                if ("1" === jyzq) {
                    jyzq = "每周的";
                    jyrq = that.constant.weeks[jyrq];
                } else if ("2" === jyzq) {
                    jyzq = "每两周的";
                    jyrq = that.constant.weeks[jyrq];
                }
            }
            return jyzq+jyrq;
        },
        next: function (avgrHtmlcurrentTarget) {
            var thats=this;
            var avgrHtmlcurrentTarget=avgrHtmlcurrentTarget;
            var id = $(avgrHtmlcurrentTarget).attr("data-id");
            var type = $(avgrHtmlcurrentTarget).attr("data-type");
            var requestno = $(avgrHtmlcurrentTarget).attr("data-requestno");
            var warningno = $(avgrHtmlcurrentTarget).attr("data-warningno");
            var fundcode = $(avgrHtmlcurrentTarget).attr("data-fundcode");
            var businflag = $(avgrHtmlcurrentTarget).attr("data-businflag");
            var placeholder = $(avgrHtmlcurrentTarget).attr("data-placeholder");
            var requestlist = {};
            requestlist.serialno = id;
            requestlist.requestno = requestno;
            requestlist.warningno = warningno;
            requestlist.fundcode = fundcode;
            requestlist.businflag = businflag;
            requestlist.placeholder = placeholder;

            var request = new Array();
            request.push(requestlist);
            var data = "requestlist=" + JSON.stringify(request) + "&dealtype=" + type;
            var confirmHtml = type == "1"?"终止后定投计划将不再继续定时扣款":"确定继续使用该定投协议？";
            $.UIComfirm({"html":confirmHtml, "submitText":"确定","cancelText":"取消"}, function(confirm) {
                if ("yes" == confirm) {
                    $.hsf.startLoading("正在处理...");
                    $.hsf.ajax.app("trade/common/dealAndTrace", data, "dealAndTrace", function (jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            if(type=="0"){
                                thats.makeTraceWarnC();
                            }
                            var $target = $(avgrHtmlcurrentTarget).parent().parent();
                            $target.slideUp(function(){
                                $target.remove();
                                $.UIPopup("待办事项处理成功!");
                                //var content = $(".operation").length;
                                //if(content == 0){
                                //    $(".e-has-notice").html("暂无需要处理的信息");
                                //}
                                if($(".risk-change").length==0){
                                    $.UIAlert("待办事项已全部处理完成！",function(){
                                        thats.hsBack();
                                    });
                                }
                            })
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
            return false;
        },
        makeTraceWarnC:function(){
            var that = this;
            that.toDoMakeTrace(that.avgrTodo.warningCNo, that.avgrTodo.fundcode, that.avgrTodo.warningCContent, that.avgrTodo.productRiskLevel, that.avgrTodo.riskability,that.avgrTodo.requestno)
        },
        //待办事项界面C类留痕参数
        toDoMakeTrace: function (warningno, fundcode, content, fundrisklevel, custrisktype,requestno) {
            requestno = requestno || "";
            this.requestTrace({
                warningno: warningno,
                businflag: "090",
                fundcode: fundcode,
                content: content,
                fundrisklevel: fundrisklevel,
                custrisktype:custrisktype,
                requestno: requestno
            });
        },
        requestTrace:function(data){
            var param = $.map(data,function(value,key){
                return key+"="+value
            }).join("&");
            $.hsf.ajax.app("account/risk/trace",param,"traceCallback",function(jsonResult) {
                if (jsonResult.successful) {
                }
            });
        },
        //获取待办
        getTodolist: function () {
            var that = this;
            that.todolistBData = [];
            $.hsf.startLoading("正在加载...");
            $.hsf.ajax.app("trade/common/todolist", "warningchannel="+$.platform.warningchannel, "toDoListCallBack", function (jsonResult) {
                $.hsf.stopLoading();
                if (jsonResult.successful) {
                    if(jsonResult.resultlist.length>0){
                        var todolist1 = [];
                        var todolist2 = [];
                        var todolist3 = [];
                        $(jsonResult.resultlist).each(function (k, m) {
                            if (m.businflag == "AAA") {
                                var requestlist = {};
                                requestlist.serialno = m.serialno;
                                requestlist.requestno = m.requestno;
                                requestlist.warningno = m.warningno;
                                requestlist.fundcode = m.fundcode;
                                requestlist.businflag = m.businflag;
                                requestlist.placeholder = m.placeholder;
                                todolist2.push(m);
                                that.todolistBData.push(requestlist);
                            }else if(m.businflag == "BBB"){
                                todolist3.push(m);
                            }else{
                                if(m.businflag == "090" || m.businflag == "091" ||m.businflag == "982") {
                                    m.dtdate = that.formatAvgrDate(m.cycleunit, m.jyzq, m.jyrq)
                                    m.riskability=jsonResult.riskability;
                                    todolist1.push(m);
                                }
                            }
                        });
                        that.todoList1 = todolist1;
                        $.doTemplate("todolistTemp", {
                            todolist1: todolist1,
                            todolist2: todolist2,
                            todolist3: todolist3,
                            minriskflag: jsonResult.minriskflag
                        }, "keepid");
                        $("[m-role='UITableView']").UITableView();
                        $.hsf.stopLoading();
                    }
                } else {
                    $.hsf.callFailProcess(jsonResult);
                    $.doTemplate("todolistTemp", {todolist1:[],todolist2:[]}, "keepid");
                }
            });
        }
    });
});


define("pages/investment-suitability", ["Backbone"], function (B) {
    var flag = $.hsf.hsTools.getParam("flag");
    if(!flag) return $.bone("investment-suitability-a");
    if(flag.length == 3){
        return $.bone("investment-suitability-a");
    }else if(flag.length == 2){
        var flagarr = flag.split("");
        return $.bone("investment-suitability-"+flagarr[0]);
    }else if(flag.length == 1) {
        return $.bone("investment-suitability-" + flag);
    }else {
        return $.bone("investment-suitability-a");
    }
});
