define([$.hsf.platform()], function(platform) {
	var platformApi = $.extend({}, platform.baseapi);
	var action = {
		historyBack : true,
		disableHistoryBack : function() {
			action.historyBack = false;
		},
		init : function() {
			action.historyBack = true;
			$("[m-role='UITextField']").UITextField();
			$("[m-role='UISelectField']").UISelectField();
			this.events();
		},
		events : function() {
			$("#loginButton").bind("tap", function() {
				action.checkLoginCode();
				return false;
			});
			$("#backBtn").bind("tap", function() {
				try {
					action.historyBack && platformApi.hsBack();
					action.popDown();
					return false;
				} catch (e) {
					console.log(e);
				}
			});
		},
		getAccountNo : function() {
			var accountNoHidden = $("#accountNoHidden").val();
			var account = $("#accountNo");
			if (accountNoHidden != "" && account.indexOf("****") > 0) {
				return accountNoHidden;
			} else {
				return $("#accountNo").UITextField("value");
			}
		},
		checkLoginCode : function() {
			var pw = $("#pw").UITextField("value");
			var verifycode = $("#verifycode").UITextField("value");
			var data = "channel=weixin&password=" + pw +"&authcode="+verifycode;
			if (pw.length === 0) {
				$.UIPopup("请输入密码");
				return false;
			}
			if (pw.length > $.hsf.pwLength) {
				$.UIPopup("密码长度不能超过" + $.hsf.pwLength + "位");
				$("#pw").focus();
				return false;
			}
			$("input").blur();
			$.hsf.startLoading();
			$.hsf.ajax.app("account/weixinlogin/wxlogin", data, "checkLoginCode", this.loginCallback);
		},
		loginCallback : function(jsonResult) {
			$.hsf.stopLoading();
			if (jsonResult && jsonResult.successful) {
				$.platform.getCache("accountTypeStr", function (accountType) {
					accountType=accountType||"0"; // 默认 0
					$.hsf.hsTools.hgxTradeRestrictQuery(accountType, platformApi, function(){
						$.platform.putCache("loginInfo",{custRole:jsonResult.custRole});
						action.triggerSucc();
					});
				})

			} else {
				if (jsonResult.needauthcode == "1") {
					$("#verifycodeDD").show();
					$("#verifycodeImg").attr("src", $.hsf.appBaseUrl+"authcode.jpg");
				}
				$.hsf.callFailProcess(jsonResult);
			}
			return false;
		},
		triggerSucc : function() {
			$.hsf.hsTools.checkInvestmentSuitabilityAll(function(){
				setTimeout(function succ() {
					$.hsf.Event.trigger("login", function() {
						action.popDown();
					});
				}, 500);
			},true);
		},
		popDown : function() {
			$("#login").bind("webkitAnimationEnd", function() {
				$("#login").remove();
			})
			.removeClass("pop-up")
			.addClass("pop-down");
		}
	}
	return action;
});

