define('pages/ocr-Idcard-cert-ocr', ['Backbone'], function(B) {
	return Backbone.View.extend({
		$nextBtn: $('#upload-cert-img'),
		$getCertFrontImg: $('#get-cert-front-img'),
		$getCertBackImg: $('#get-cert-back-img'),
		certFrontImg: '../images/ocr/box.png',
		certBackImg: '../images/ocr/box2.png',
		certInfo: {
			certType: '0',
			certTypeName: '身份证'
		},
		check:$.hsf.hsTools.getParam("check"),
		certUploadState: {
			A: false,
			B: false
		},
		title: {
			center: {
				text: '上传身份证'
			}
		},
		_data: {
			idCardInfo: {}
		},
		initialize: function(parent, platformApi) {
			this.platformApi = platformApi;
			this.parent = parent;
			this.eventss();
		},
		OCRIdcard: function(imgBaseData, imgType) {
			var that = this;
			var fileextName = imgBaseData.split('data:image/')[1].split(';base64,')[0];
			var base64content = imgBaseData.split('data:image/')[1].split(';base64,')[1];
			var data = $.formGenerate()
				.add('base64content', encodeURIComponent(base64content))
				.add('imgType', imgType)
				.add('archivestype', '02')
				.add('processtype', '3')
				.add('fileextname', fileextName)
				.generate();
			$.hsf.startLoading();
            var removeImage = function() {
                if (imgType == "1") {
                    that.certFrontImg = "../images/ocr/box.png";
                    that.$getCertFrontImg.attr("src", "../images/ocr/box.png");
                    that.certUploadState.A = false;
                    $("#front-text").hide();
                } else {
                    that.certBackImg = "../images/ocr/box2.png";
                    that.$getCertBackImg.attr("src", "../images/ocr/box2.png");
                    that.certUploadState.B = false;
                    $("#back-text").hide();
                }
            };
			$.hsf.ajax.app('atomicquery/account/ocrAndSaveIdentityImg', data, 'queryAccoinfoCallback', function(jsonResult) {
                $.hsf.stopLoading();
                if (jsonResult && jsonResult.successful) {
                    if (imgType == '1') {
                        if (jsonResult.sameIdNo && jsonResult.sameIdNo=="0" && jsonResult.idNo) {
                            $.UIAlert("上传的证件识别信息与账户信息不符，请重新上传");
                            removeImage();
                            return false;
                        }
                        that.checkidCardFront(jsonResult, imgBaseData);
                    } else {
                        that.checkidCardBack(jsonResult, imgBaseData);
                    }
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            },'post');
		},
		checkidCardFront: function(result, certFrontImg) {
			var that = this;
			try {
				for (var p in result) {
					if (typeof result[p] == 'string') {
						result[p] = result[p].trim();
					}
				} //给每个字段做一次trim
				if (!result.idBirthday) {
					$.UIPopup('身份证人像面照片的出生日期无法识别');
					throw {}
				}
				result.idBirthday = result.idBirthday.replace(/年|月|日/g, ''); //格式化
				if (result.successful) {
					if (
						!$.validForm()
							.hope('notEmpty', result.idNo || '', '身份证人像面照片的身份证号码无法识别')
							.hope('=',{a: 8, b: result.idBirthday.length}, '身份证人像面照片的出生日期无法识别' )
							.hope("birthday", $.hsf.hsTools.yyyy_mm_dd(result.idBirthday), "身份证人像面照片的出生日期无法识别")
							.hope('notEmpty', result.idName || '', '身份证人像面照片的姓名无法识别')
							.hope('notEmpty', result.idAdress || '','身份证人像面照片的地址无法识别' )
							.hope('notEmpty', result.idSex || '', '身份证人像面照片的性别无法识别')
							.hope('certificate', result.idNo, '您的身份证号不合法或者未满18周岁')
							.valid()
					) {
						throw {}
					}
                    if(!$.hsf.hsTools.IdentityCodeValid(result.idNo)){
                        $.UIAlert("您的身份证号识别有误或不合法，请上传正确的18位身份证。");
                        throw {};
                    }
                    if($.hsf.hsTools.yyyy_mm_dd(result.idBirthday) != $.hsf.hsTools.getBirthdayFromCard(result.idNo)){
                        $.UIAlert("身份证人像面照片的出生日期识别有误");
                        throw {};
                    }
					that.$getCertFrontImg.attr('src', certFrontImg);
					that.certInfo.certNo = result.idNo;
					that.certInfo.name = result.idName;
					that.certInfo.birthday = result.idBirthday;
					that.certInfo.clientgender = result.idSex == '男' ? '1' : '0';
                  if($.hsf.hsTools.getGenderFromCard(result.idNo) != that.certInfo.clientgender){
                    $.UIAlert("身份证人像面照片的性别识别有误");
                    throw {};
                  }
					that.certInfo.clientgenderText = result.idSex;
					that.certInfo.address = result.idAdress;
					that.certUploadState.A = true;
				} else {
					$.hsf.callFailProcess(result);
					throw {}
				}
			} catch (e) {
				that.$getCertFrontImg.attr('src', '../images/ocr/box.png');
				if (e.msg) {
					$.UIPopup(e.msg);
				} else {
					console.log(e);
				}
				that.certUploadState.A = false;
			}
		},
		checkidCardBack: function(result, certBackImg) {
			var that = this;
			try {
				for (var p in result) {
					if (typeof result[p] == 'string') {
						result[p] = result[p].trim()
					}
				} //给每个字段做一次trim
				if (result.successful) {
					//识别不出
					if (!$.validForm().hope('notEmpty', result.idPeriod || '').valid()) {
						throw {msg: '身份证国徽面照片无法识别'}
					}
					if (/^((19|20)\d{2}\.((0[1-9]{1})|1[0-2]{1}).(([0-2]{1}[0-9]{1})|(3[0-1]{1})))-((19|20)\d{2}\.((0[1-9]{1})|1[0-2]{1}).(([0-2]{1}[0-9]{1})|(3[0-1]{1})))$/.test(result.idPeriod)) {
						//非长期
						that.$getCertBackImg.attr('src', certBackImg);
						var endDate = result.idPeriod.split('-')[1].replace(/\./g, '');
						if(!$.validForm().hope("=", {a: 8, b: endDate.length}, "身份证国徽面照片有效期无法识别")
								.hope("birthday", $.hsf.hsTools.yyyy_mm_dd(endDate), "身份证国徽面照片有效期无法识别")
								.valid()){
							throw {};
						}
						that.certInfo.idenddate = endDate;
						var startDate = result.idPeriod.split('-')[0].replace(/\./g, '');
						that.certInfo.startDate = startDate;
						that.certUploadState.B = true
					} else if (/^((19|20)\d{2}\.((0[1-9]{1})|1[0-2]{1}).(([0-2]{1}[0-9]{1})|(3[0-1]{1}))-长期)$/.test(result.idPeriod)) {
						//长期
						that.$getCertBackImg.attr('src', certBackImg);
						that.certInfo.idenddate = '99991231';
						var startDate = result.idPeriod.split('-')[0].replace(/\./g, '');
						that.certInfo.startDate = startDate;
						that.certUploadState.B = true
					} else {
						throw {
							msg: '身份证国徽面照片无法识别'
						}
					}
				} else {
					$.hsf.callFailProcess(result);
					throw {}
				}
			} catch (e) {
				that.$getCertBackImg.attr('src', '../images/ocr/box2.png');
				if (e.msg) {
					$.UIPopup(e.msg);
				} else {
					console.log(e);
				}
				that.certUploadState.B = false;
			}
		},
		eventss: function() {
			var that = this;
			window.idcard = 'obverse';
			if ($.hsf.matchNative()) {
				$('#file1').hide();
				$('#file2').hide();
				window.idcardCallback = function(res) {
					that.platformApi.getCache('ocrImage', function(res2) {
						if (idcard == 'obverse') {
							if (res.num) {
								that.certFrontImg = res2;
								that.OCRIdcard(res2, '1');
							} else {
								$.UIPopup('请拍摄身份证的人像面！');
							}
						} else {
							if (res.period) {
								that.certBackImg = res2;
								that.OCRIdcard(res2, '2');
							} else {
								$.UIPopup('请拍摄身份证的国徽面！');
							}
						}
					});
				}
			}
			this.$nextBtn.on('tap', function() {
				var idenddateTime = new Date(
					$.hsf.hsTools.yyyy_mm_dd(that.certInfo.idenddate)
				).getTime();
				var nowTime = new Date().getTime();
				if (that.certUploadState.A == false) {
					$.UIAlert('请上传身份证人像面照片');
				} else if (that.certUploadState.B == false) {
					$.UIAlert('请上传身份证国徽面照片');
				} else if (nowTime > idenddateTime) {
					$.UIAlert('请上传未过期的身份证照片');
				} else if (
					!$.hsf.hsTools.jugdeIdenddate(
						that.certInfo.birthday,
						that.certInfo.startDate,
						that.certInfo.idenddate
					)
				) {
					$.UIAlert('您的出生日期或者证件有效期限识别有误请重新上传');
				} else {
					that.parent.setParam('certFrontImg', that.certFrontImg);
					that.parent.setParam('certBackImg', that.certBackImg);
					that.parent.setParam('idCardInfo', that.certInfo);
					window.location.hash = 'ocr-Idcard-confirm';
				}
			});
			that.platformApi.getNativeImg(function(imgSrc) {
				idcard = 'obverse';
				var certFrontImg = imgSrc.indexOf('data:') >= 0 ? imgSrc : 'data:image/jpg;base64,' + imgSrc;
				that.certFrontImg = certFrontImg;
				that.OCRIdcard(certFrontImg, '1');
			}, 'file1', this.$getCertFrontImg, 'obverse');
			that.platformApi.getNativeImg(function(imgSrc) {
				idcard = 'back';
				var certBackImg = imgSrc.indexOf('data:') >= 0 ? imgSrc : 'data:image/jpg;base64,' + imgSrc;
				that.certBackImg = certBackImg;
				that.OCRIdcard(certBackImg, '2');
			}, 'file2', this.$getCertBackImg, 'back');
		}
	})
});


define('pages/ocr-Idcard-confirm', ['Backbone'], function(B) {
	return Backbone.View.extend({
		$certFrontImg: $('#cert-front-img'),
		$certBackImg: $('#cert-back-img'),
		certFrontImg: '',
		certBackImg: '',
		idCardInfo: {},
		$nextBtn: $('#ocr-confirm-next'),
		_private: {
			customerappellation: '',
			idno: ''
		},
		title: {
			center: {
				text: '确认信息'
			}
		},
		initialize: function(parent, platformApi) {
			this.parent = parent;
			this.platformApi = platformApi;
			this.userInfo();
			this.eventss();
		},
		afterSwitchView: function() {
			var parent = this.parent;
			this.certFrontImg = parent.getParam('certFrontImg');
			this.certBackImg = parent.getParam('certBackImg');
			this.idCardInfo = parent.getParam('idCardInfo');
			this.$certFrontImg.attr('src', this.certFrontImg);
			this.$certBackImg.attr('src', this.certBackImg);
			this.initView(this.idCardInfo);
			$.checkNullGroup([$('#trueInfoCheck')], this.$nextBtn);
		},
		userInfo: function() {
			var that = this;
			$.hsf.ajax.app(
				'atomicquery/account/logininfo','','userInfoCallback',function(result) {
					if (result && result.successful) {
						that._private.customerappellation = result.result.customerappellation;  // 姓名
						that._private.idno = result.result.idno; // 身份证号
					} else {
						$.hsf.callFailProcess(result);
					}
				}
			)
		},
		initView: function(idCardInfo) {
			if (!idCardInfo) {
				$.UIAlert('身份证识别信息丢失请返回上一步重试！', function() {
					$.hsf.hsBack();
				});
			} else {
				$('#confitm-name').text(idCardInfo.name);
				$('#confitm-no').text(idCardInfo.certNo);
				$('#confitm-address').text(idCardInfo.address);
				$('#confirm-birthday').text($.hsf.hsTools.yyyy_mm_dd(idCardInfo.birthday));
				$('#confirm-date-time').text(idCardInfo.idenddate == '99991231' ? '长期有效' : $.hsf.hsTools.yyyy_mm_dd(idCardInfo.idenddate));
			}
		},
		eventss: function() {
			var that = this;
			$("#ocr-confirm-back").bind("tap", function () {
				$.hsf.hsBack();
				return false;
			});

			this.$nextBtn.bind('tap', function() {
				var trueInfoCheck=$('#trueInfoCheck').attr('m-checked');
				if(trueInfoCheck!="yes"){
					$.UIPopup('请核对信息并勾选确认');
					return false;
				}
				if (that.$nextBtn.attr('m-state') == 'disabled') {
					return false;
				}
				// 判断页面上显示的文字和用户信息查询出来的文字是否一样
				var name = $('#confitm-name').text();
				var certNo = $('#confitm-no').text();
				$.hsf.startLoading();
				var data="netauditflag=1";
				$.hsf.ajax.app('atomicquery/account/uploadIdentityImg',data,'queryAccoinfoCallback',function(jsonResult) {
                      if (jsonResult && jsonResult.successful) {
                          $.hsf.stopLoading();
                          if ($.hsf.matchNative()) {//只有app才需要通知上一个页面刷新
                              $.platform.sendBroadcast("refreshAccount");
                          }
                          $.UIAlert('身份证上传成功', function() {
                              that.parent.finish();
                              $.hsf.hsBack();
                              return false
                          });
                      } else {
                          if (jsonResult.code == 'ETS-V045003'||jsonResult.code=='文件传输失败') {
                              jsonResult.message = '证件照片上传失败，请稍后再试';
                          }
                          $.hsf.callFailProcess(jsonResult);
                      }
                  });
			});
		}
	});
});

define('pages/ocr-Idcard', function() {
	return $.bone('ocr-Idcard-cert-ocr')
});
