/**
 * Created by apple on 15/5/29.
 */
define(["Backbone"], function(Backbone) {
	return Backbone.View.extend({
		el: "#setting",
		title: {
			left: {
				show: false
			},
			center: {
				text: "设置"
			},
			border: {
				show: false
			}
		},
		_private: {
			loginSucc: false
		},
		initialize: function(parent, platformApi) {
			var that = this;
			this.parent = parent;
			this.platformApi = platformApi;
			$.hsf.Event.addListener("login", function() {
				that.loadUserInfo();
			});
			this.requestManager = $.hsf.requestManager(this);
			this.requestManager.add(this.loadUserInfo, 60 * 30);
			this.platformApi.initPage(this);
		},
		resetPage: function() {
			this._private.loginSucc = false;
			this.requestManager.resetTime(this.loadUserInfo);
			this.$el.find("#openedTag").hide();
			this.$el.find("#username").hide();
			this.$el.find("#signin").hide();
			this.$el.find("#username").html("");
			this.$el.find("#signin").show();
		},
		loadUserInfo: function() {
			var $that = this.$el;
			var that = this;
			var render = function($that, that, jsonResult) {
				that._private.loginSucc = true;
				$that.find("#avatar").show();
				$that.find("#openedTag").show();
				$that.find("#username").show();
				$that.find("#signin").hide();
				$that.find("#username").html(jsonResult.result.customerappellation);
			};
			$.hsf.startLoading();
			$.hsf.ajax.app("atomicquery/account/logininfo", "", "checkLoginCode", function(jsonResult) {
				if (jsonResult.successful) {
					if (jsonResult.result.code == "ETS-5BP0000") {
						render($that, that, jsonResult);
					} else {
						$that.find("#signin").show();
					}
					$.hsf.stopLoading();
				} else {
					$that.find("#signin").show();
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		goInfo: function() {
			if (this._private.loginSucc) {
				$.hsf.hsOpen("account-info.html");
			} else {
				$.hsf.innerLogin();
			}
		},
		goAccountSafe: function() {
			if (this._private.loginSucc) {
				$.hsf.hsOpen("account-safe.html");
			} else {
				$.hsf.innerLogin();
			}
			return false;
		},
		events: {
			"tap #signin": "login",
			"tap #personInfo": "goInfo",
			"tap #account-safe": "goAccountSafe"
		},
		login: function() {
			$.hsf.innerLogin();
			return false;
		},
		afterSwitchView: function() {
			this.requestManager.invoke(this.loadUserInfo);
		}
	});
});