define([], function() {
	var action = {
		constant : {
			apply : {
				pageNo : 1,
				totalNum : 0,
				loadedNum : 0,
				oneTimeRecord : 20
			},
			tradeIcon : {
				"020" : "trade-list-icon trade-list-icon-blue",
				"022" : "trade-list-icon trade-list-icon-blue",
				"098" : "trade-list-icon trade-list-icon-yellow",
				"024" : "trade-list-icon trade-list-icon-yellow",
				"029" : "trade-list-icon trade-list-icon-blue",
				"036" : "trade-list-icon trade-list-icon-purple",
				"987" : "trade-list-icon trade-list-icon-pink",
				"090" : "trade-list-icon trade-list-icon-pink",
				"988" : "trade-list-icon trade-list-icon-pink",
				"093" : "trade-list-icon trade-list-icon-pink",
				"060" : "trade-list-icon trade-list-icon-pink",
				"039" : "trade-list-icon trade-list-icon-pink",
				"053" : "trade-list-icon trade-list-icon-yellow"
			},
			searchList : {},
		},
		init : function() {
			action.initQueryForm();
			action.events();
		},
		events : function() {
			$("#moreBtn").bind("tap", function() {
				action.applyPackForm(action.constant.paramHistory, "more");
				return false;
			});
			$(".shortcut").bind("tap", function() {
				var _self = this;
				$(".shortcut").attr("m-style", "style-3");
				$(_self).attr("m-style", "style-6");
				return false;
			});
			$("#queryBtn").bind("tap", function() {
				var value = $("div[m-role='UIButton'][m-style='style-6']").attr("value");
				var startDate = $("#startDate").UIDateField("value").replace(/-/g, "");
				var endDate = $("#endDate").UIDateField("value").replace(/-/g, "");
				var searchText = $("#searchText").UITextField("value");
				var param = "&callingcode="+value+"&fundcode="+searchText+"&startdate="+startDate+"&enddate="+endDate;
				if (startDate && endDate && startDate >endDate) {
					$.UIPopup("请正确设置开始时间和结束时间");
					return false;
				}
				if (typeof searchText == "string" && searchText.length > 8) {
					$.UIPopup("请输入正确的基金代码关键字");
					return false;
				}
				action.applyPackForm(param, "query");
				return false;
			});
			$("#secondBackBtn").bind("tap", function() {
				$("#second").hide();
				$("#first").show();
				$("body").scrollTop(0);
				return false;
			});
		},
		initQueryForm : function() {
			$.hsf.ajax.app("query/tradeapply/applyForm", "", "applyForm", function(jsonResult) {
				if (jsonResult.successful) {
					for (var index in jsonResult.fundlist) {
						action.constant.searchList[jsonResult.fundlist[index].key] = jsonResult.fundlist[index].value;
					}
					var timer;
					var $searchText = $("#searchText");
					$searchText.UITextField("search", function (value) {
						clearTimeout(timer);
						var $this = $(this);
						var html = action.search(value);
						timer = setTimeout(function () {
							$searchText.UITextField("autoComplete", html, function () {
								$(".search_result").UITableView();
								$(".search_result dd").bind("tap", function () {
									$("#searchText").UITextField("value", this.getAttribute("key"));
									$.UIBubble("hide");
								})
							});
						}, 200)
					});
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		search : function(str) {
			var result = {};
			var head = ["<div m-role=\"UITableView\" class=\"search_result\">", "<dl>"];
			var content = [];
			var tail = ["</dl>", "</div>"];
			for(var index in action.constant.searchList) {
				if (action.constant.searchList[index].indexOf(str) >= 0|| index.indexOf(str) >= 0) {
					content = content.concat(["<dd key='"+index+"'>", action.constant.searchList[index]+" "+index, "</dd>"])
				}
			}
			return head.concat(content).concat(tail).join("");
		},
		applyPackForm : function(param, source) {
			if (source == "query") {
				$("#first").hide();
				$("#second").show();
				action.constant.paramHistory = param;
				action.constant.apply.pageNo = 1;
				action.constant.apply.loadedNum = 0;
				$("#applyList").find("dd").remove();
				$("#moreBtn").hide();
			}
			$.hsf.startLoading();
			$.hsf.ajax.app("query/tradeapply/applyList", "datasource=DC&applyrecordno="+action.constant.apply.oneTimeRecord+"&pageno="+action.constant.apply.pageNo+param, "checkLoginCode", function(jsonResult) {
				if (jsonResult.successful) {
					var list = jsonResult.returnList;
					if (list.length > 0) {
						for (var index in list) {
							var apply = list[index];
							if (apply.callingcode == "036") {
								apply.fundname = apply.fundname +"->"+ apply.targetfundname;
								apply.businflagstr = "转换";
							}
							if (apply.apply == "--") {
								apply.applyUnit = "";
							} else {
								if (apply.callingcode == '01' || apply.callingcode == '02' || apply.callingcode == '50' || apply.callingcode == '16' || apply.callingcode == '39') {
									apply.applyUnit = "元";
								} else {
									apply.applyUnit = "份";
								}	
							}
							apply.businflagIconBorder = action.constant.tradeIcon[apply.callingcode] || "trade-list-icon trade-list-icon-purple";
							apply.businflagIcon = apply.businflagstr.substr(0,1);
						}
						$.doTemplate("template1", list, "repeat");
						$("#applyList").UITableView("refresh");
						action.constant.apply.pageNo++;
						action.constant.apply.loadedNum += list.length;
						if (action.constant.apply.loadedNum >= jsonResult.totalRecord) {
							$("#moreBtn").hide();
						} else {
							$("#moreBtn").show();	
						}
						$.hsf.stopLoading();
					} else {
						$("#moreBtn").hide();
						$.hsf.stopLoading();
						$.UIPopup("没有记录了");
					}
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		}
	};
	return action;
});