﻿// 返回上一页刷新
window.addEventListener('pageshow', function (event) {
    if (event.persisted) { // ios 有效, android 和 pc 每次都是 false
        location.reload();
    } else { // ios 除外
        if (sessionStorage.getItem('refresh') === 'true') {
            location.reload();
        }
    }
    sessionStorage.removeItem('refresh');
});


define(function (require) {
    var action = {
        constant: {
            day: ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"],
            weeks: {
                "2": "周一",
                "3": "周二",
                "4": "周三",
                "5": "周四",
                "6": "周五"
            },
            result: null,
            fundcode: $.hsf.hsTools.getParam("fundcode"),
            counter: 0,//计时器
            repeatSeconds: 10,//倒计时时间
            buybusin:"090"// 默认值 银行卡定投
        },
        init: function () {
            var that = this;
            $.hsf.hsTools.investmentSuitability(function () {
                that.packForm();
                that.event();
            });
        },
        packForm: function () {
            $.hsf.startLoading();
            action.initAgreeFunc();
            action.packNamelist(action.constant.fundcode);	/*名称*/
        },
        // 信披
        initAgreeFunc: function () {
            $.platform.getCache("agreeUserInfo", function (r) {
                if (!!r) {
                    $.hsf.hsTools.initAgree(action.constant.fundcode, r.result.idno, r.result.idtype,$("#main"),$("#fundRatePage"));
                } else {
                    $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                        if (jsonResult && jsonResult.successful) {
                            $.platform.putCache("agreeUserInfo", jsonResult);
                            $.hsf.hsTools.initAgree(action.constant.fundcode, jsonResult.result.idno, jsonResult.result.idtype,$("#main"),$("#fundRatePage"));
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            })
        },
        /**初始化**/
        packFirstPage: function (jsonResult) {
//			action.packNamelist(jsonResult); /*名称*/
            $(".fundname").html(jsonResult.fundname);
            $(".fundcode").html(jsonResult.fundcode);
            action.renderAWarning(jsonResult);
            //$(".notice-box").html(jsonResult.warningCContent);
            $("#showfundname").html(jsonResult.fundname);
            $("#showfundnamerisklevel").html(jsonResult.riskmatchResult.fundriskStr);
            $("#custrisklevel").html(jsonResult.riskmatchResult.riskbilityStr);
            action.renderLowRiskLimit(jsonResult);
//			var buyConfirmDate = jsonResult.buyConfirmDate;
//			$("#predictConfirmDate").html($.hsf.hsTools.mm_dd(buyConfirmDate) + "(" + $.hsf.hsTools.dayOfWeek(buyConfirmDate) + ")");
            if (jsonResult.bankCards.length > 0) {
                $(".selectedBankName").html(jsonResult.bankCards[0].bankname);
                $("#selectBankLogo").removeClass().addClass('bank-logo-min bank-' + jsonResult.bankCards[0].alias);
                $(".selectedBankcardNo2").html("(尾号" + $.hsf.hsTools.maskCardHead(jsonResult.bankCards[0].bankacco) + ")");
                $(".selectedBankcardMiniIcon").addClass("bank-" + jsonResult.bankCards[0].alias);
                var bankname = jsonResult.bankCards[0].bankname;//.split("_");
//					$("#limitTip")[0].style.visibility = "visible";
                /*if (bankname[1] == null) {
                 bankname[1] = jsonResult.bankCards[0].bankname;
                 }*/
                var oncemaxvalue = jsonResult.bankCards[0].oncemaxvalue;
                var daymaxvalue = jsonResult.bankCards[0].daymaxvalue;
                if (oncemaxvalue && daymaxvalue) {
                    $("#banklimit").html(bankname + "卡支付限额：单笔" + oncemaxvalue + "万，日累计" + daymaxvalue + "万");
                    $("#noticeIcon")[0].style.visibility = "visible";
                } else {
                    $("#banklimit").html("");
                    $("#noticeIcon")[0].style.visibility = "hidden";
                }
                /*$("#banklimit").html(bankname);
                 $("#minlimit").html(jsonResult.bankCards[0].onceMaxValue);
                 $("#daylimit").html(jsonResult.bankCards[0].dayMaxValue);*/
                // $("#nextworkdate").html(action.getNextWorkDate(1,0));
                action.queryDate();
                $("#minValue").html(action.constant.limit);
                action.constant.selectedTradeAcco = jsonResult.bankCards[0];
                action.constant.selectedTradeAcco.capsource = "0"; //银行卡
                action.constant.cycleunit = "0";	//默认定投周期为月
            } else {
                $.UIConfirm({"html": "您还没有可以交易的银行卡，是否添加?", "submitText": "确定", "cancelText": "取消"}, function (result) {
                    if (result == "yes") {
                        location.href = "account-addAcco-tl-validate.html";
                    } else {
                        $.hsf.hsBack();
                    }
                });
            }
            $("#applysum").find("input").attr("placeholder", "请输入定投金额  0.00");
            for (var index in jsonResult.sharetypes) {
                $("#share" + jsonResult.sharetypes[index].key).show();
            }
        },
        packBanklist: function (jsonResult) {
            var bankSelect = document.getElementById("bankSelect");
            bankSelect.options.length = 0;
            if (jsonResult.bankCards.length > 0) {
                for (var i = 0; i < jsonResult.bankCards.length; i++) {
                    var bankname = jsonResult.bankCards[i].bankInfo;//.split("_");
                    /*if (bankname[1] == null) {
                     bankname[1] = jsonResult.bankCards[i].bankInfo;
                     }*/
                    bankSelect[i] = new Option(bankname, i);
                    bankSelect[i].setAttribute("m-logo", "bank-" + jsonResult.bankCards[i].alias);
                }
            }
            var lenOfAllBankLength = bankSelect.options.length;
            bankSelect[lenOfAllBankLength] = new Option("添加新的银行卡", "account-addAcco-tl-validate.html");

//			$bankcardList.find("dd").first().attr("m-marked", "yes");
//			$bankcardList.UITableView("refresh");
//			$("#bankcardList dd").bind("tap", function(result) {
//				var result = $(this).attr("m-id");
//				$(".selectedBankName").html($.hsf.hsTools.banknameDeal(action.constant.result.bankCards[result].bankname));
//				$(".selectedBankcardNo").html(action.mask(action.constant.result.bankCards[result].bankacco));
//				$(".selectedBankcardNo2").html("(尾号"+action.mask2(action.constant.result.bankCards[result].bankacco)+")");
//				action.constant.selectedTradeAcco = action.constant.result.bankCards[result];
//				action.constant.selectedTradeAcco.capsource = "0";
//				$(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny bank-"+action.constant.result.bankCards[result].alias);
//				$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-"+action.constant.result.bankCards[result].alias);
//				$("#bankcardPage").hide();
//				$("#first").show();
//				return false;
//			});
        },
        packNamelist: function (fundcode) {
            var that = this;
            if (typeof (fundcode) == "string") {
                that.initSingleBuyForm();
            } else {
                $.hsf.ajax.app("product/product/queryFundListSequence", "sequenceField=fundNameFirstPinyinName&sequenceWay=asc", "productListback", function (jsonResult) {
                    if (jsonResult.successful) {
                        $.hsf.stopLoading();
                        action.constant.fundlist = jsonResult.resultList;
                        var fundnameSelect = document.getElementById("fundnameSelect");
                        fundnameSelect.options.length = 0;
                        for (var i = 0; i < action.constant.fundlist.length; i++) {
                            fundnameSelect[i] = new Option(action.constant.fundlist[i].fundname + "[" + action.constant.fundlist[i].fundcode + "]", i);
                        }
                        that.selectFund();
                        action.constant.fundcode = action.constant.fundlist[0].fundcode;
                        that.initMultiBuyForm();
                        //fundnameSelect[1] = new Option("---- 设置显示2 ----", 1);
                        //fundnameSelect[2] = new Option("---- 设置显示3 ----", 2);
                        $("#fundNameDouble").show();
                        $("#fundNameSingle").hide();
                    } else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                });
                //var fundnameSelect = document.getElementById("fundnameSelect");
                //fundnameSelect.options.length = 0;
                //fundnameSelect[0] = new Option("---- 设置显示1 ----", 0);
                //fundnameSelect[1] = new Option("---- 设置显示2 ----", 1);
                //fundnameSelect[2] = new Option("---- 设置显示3 ----", 2);
                //
                //$("#fundNameDouble").show();
                //$("#fundNameSingle").hide();
                //	$.hsf.stopLoading();
            }
        },
        tobuy: function () {
            var navfor = $("#nextTo2Btn").attr("for");
            action.renderBWarning(function () {
                $(".confirmsum").html(action.getApplySum() + "元");
                var shareTypeText = action.constant.result.sharetypes[0].value;
                $(".fee1").html(shareTypeText);
                var jyzq = $("#selectCycle").UISelectField("value");
                if (jyzq == "0") {
                    var jyrq = $("#jyrq_0").UISelectField("value");
                    $(".dtdate").html(action.formatAvgrDate("0", "1", jyrq));
                } else if (jyzq == "1") {
                    var jyrq = $("#jyrq_1").UISelectField("value");
                    $(".dtdate").html(action.formatAvgrDate("1", "1", jyrq));
                } else if (jyzq == "2") {
                    var jyrq = $("#jyrq_1").UISelectField("value");
                    $(".dtdate").html(action.formatAvgrDate("1", "2", jyrq));
                }
                $("#first").removeClass('view-active');
                $("#" + navfor).addClass('view-active');
                action.sandclock.start();
            });
        },
        event: function () {
            $(".up-btn-search").bind("tap", function () {
                $.hsf.hsOpen("bankcard.html");
                return false
            });
            $("#trade-agreement-agree").bind("tap", function () {
                var checkContract2 = $("#checkContract2");
                if (!checkContract2.is(':checked')) {
                    $.UIPopup("请确认已阅读《风险不匹配警示函》和《投资者确认书》!");
                } else {
                    $("#tradeAgreementPage").hide();
                    $("#first").addClass('view-active');
                    action.tobuy();
                    return false;
                }
                return false;
            });
            $("#trade-agreement-cancel").bind("tap", function () {
                $("#tradeAgreementPage").hide();
                $("#first").addClass('view-active');
                return false;
            });
            action.selectBank();
            action.selectCycle();
            action.selectDate();
            $("#applysum input").bind("input", function () {
                var _self = $(this),
                    val = _self.val(),
                    exp = /^[-]?([1-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/g;
                val = val.toString().replace(/,/g, '');
                if (!exp.test(val)) {
                    var value = val.replace(/[^0-9,\.]/g, "");
                    if (value.substr(value.indexOf(".")).length > 3) {
                        _self.blur();
                        $.UIPopup("请输入数字(例:0.00),最高保留两位小数");
                    }
                    var str = $.hsf.hsTools.formatMoney(value, true);
                    $("#applysum").UITextField("value", str);
                    return false;
                }
                return false;
            });
            $("#limitBtn, #bankcardSelect,#nextTo2Btn").bind("tap", function () {
                if ("nextTo2Btn" == $(this).attr("id")) {
                    var above_risk = $(this).hasClass("above_risk");
                    if (above_risk) {
                        $.UIAlert("您的风险等级过低，不允许定投该产品！");
                        return false;
                    }
                    if (!$.hsf.hsTools.checkRead()) {
                        return false;
                    }
                    if (!action.formValidate()) {
                        return;
                    } else {
                        action.renderCWarning(function () {
                            action.tobuy();
                        });
                        return false;
                    }
                }
//				$("#first").hide();
//				$("#"+$(this).attr("for")).show();
                $("#first").removeClass('view-active');
                $("#" + $(this).attr("for")).addClass('view-active');
                return false;
            });
            $("#limitBackBtn, #bankcardBackBtn, #secondBackBtn").on("tap", function () {
                $(this).parents(".view").removeClass('view-active');
                $("#tradepassword").UITextField("value", "");
                $("#first").addClass('view-active');
                return false;
            });
            $("#purchaseBtn").bind("tap", function () {
                $("#tradepassword input").blur();
                if (!(action.sandclock.readyStart())) return false;
                if (action.formValidate2()) {
                    $.hsf.startLoading("正在提交申请...");
                    var selectCard = action.constant.selectedTradeAcco;
                    var avgrParam = action.getAvgrParam();
                    var tradepassword = $("#tradepassword").UITextField("value");
                    var data = "fundcode=" + action.constant.result.fundcode
                        + "&tradeacco=" + selectCard.tradeacco
                        + "&sharetype=" + action.constant.result.sharetypes[0].key
                        + "&cycleunit=" + avgrParam[0]
                        + "&jyzq=" + avgrParam[1]
                        + "&jyrq=" + avgrParam[2]
                        + "&zzrq=99991231"
                        + "&scjyrq=000000"
                        + "&applysum=" + action.getApplySum()
                        + "&tradepassword=" + tradepassword
                        + "&xybm=";
                    // 信披入参
                  if ($.hsf.infoDisclosure.enable) {
                      // 银行卡
                    if (selectCard.capsource == "0") {
                      action.constant.buybusin = "090";
                    } else {
                      action.constant.buybusin = "982";
                    }
                      data += "&channelno=3"+"&antiMoneyBusinestype=" + action.constant.buybusin
                    }
                    $.hsf.ajax.app("valuavgr/fixdeclare/fixDeclare", data, "purchaseCallback", function (jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            if (action.constant.result.riskmatchResult.riskflag == "1"
                                || action.constant.result.riskmatchResult.riskflag == "2"
                                || action.constant.result.riskmatchResult.riskflag == "3") {
                                jsonResult.tradeResult && action.makeTrace("C", jsonResult.tradeResult.applyserial || "");
                            }
                            $("#stateText").html("定投设置成功");
                            $("#state0").show();
                            $(".nextdate").html($("#nextworkdate").html());
                            $("#second").hide();
                            $("#third").show();
                            $.hsf.stopLoading();
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
                return false;
            });
        },
        selectBank: function () {
            $("#selectBank").UISelectField("change", function (value) {
                if (value.indexOf('.html') != -1) {
                    $.hsf.hsOpen(value);
                    return false;
                }
                var self = $(this),
                    bankLogo;
                self.find("option").each(function () {
                    var _self = $(this);
                    if (_self.val() == value) bankLogo = _self.attr("m-logo");
                });
                if (action.constant.result.bankCards.length > 0) {
                    $(".selectedBankName").html(action.constant.result.bankCards[self.val()].bankname);
                    $(".selectedBankcardNo2").html("[" + action.getLastFourNumber(action.constant.result.bankCards[self.val()].bankacco) + "]");
                    var bankname = action.constant.result.bankCards[self.val()].bankname;
                    var oncemaxvalue = action.constant.result.bankCards[self.val()].oncemaxvalue;
                    var daymaxvalue = action.constant.result.bankCards[self.val()].daymaxvalue;
                    if (oncemaxvalue && daymaxvalue) {
                        $("#banklimit").html(bankname + "卡支付限额：单笔" + oncemaxvalue + "万，日累计" + daymaxvalue + "万");
                        $("#noticeIcon")[0].style.visibility = "visible";
                    } else {
                        $("#banklimit").html("");
                        $("#noticeIcon")[0].style.visibility = "hidden";
                    }
                    //$("#minlimit").html(action.constant.result.bankCards[self.val()].onceMaxValue);
                    //$("#daylimit").html(action.constant.result.bankCards[self.val()].dayMaxValue);
                    $("#limitTip")[0].style.visibility = "visible";
                    action.constant.selectedTradeAcco = action.constant.result.bankCards[self.val()];
                    action.constant.selectedTradeAcco.capsource = "0"; //银行卡
                }
                $("#selectBankLogo").removeClass().addClass('bank-logo-min ' + bankLogo);
                $(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny " + bankLogo);
            });
        },
        initSingleBuyForm: function () {
            $.hsf.ajax.app("valuavgr/fixdeclare/fixDeclareForm", "fundcode=" + action.constant.fundcode + "&warningchannel=" + $.platform.warningchannel, "chargeFormCode", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.hsTools.checkHgxForTrade(jsonResult, function () {//检查合规性
                        action.constant.result = jsonResult;
                        $("#fundNameSingle").html(jsonResult.fundname + "[" + jsonResult.fundcode + "]");
                        $("#fundNameDouble").hide();
                        $("#fundNameSingle").show();
                        if (!jsonResult.tradeLimitResult.limits[0]) {
                            action.constant.limit = 100;
                        } else {
                            action.constant.limit = action.constant.result.tradeLimitResult.limits[0].minValue;
                        }
                        action.packFirstPage(jsonResult);
                        action.packBanklist(jsonResult);
                    });
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
                $.hsf.stopLoading();
            });
            //
            //var data="fundcode="+action.constant.fundcode+"&businflag=022"
            //
            //$.hsf.ajax.app("trade/buy/buyForm", data, "chargeFormCode", function(jsonResult) {
            //	if (jsonResult.successful) {
            //		action.constant.result = jsonResult;
            //		$("#fundNameSingle").html(jsonResult.fundname);
            //		$("#fundNameDouble").hide();
            //		$("#fundNameSingle").show();
            //
            //		action.packFirstPage(jsonResult);
            //		action.packBanklist(jsonResult);
            //
            //	} else {
            //		$.hsf.callFailProcess(jsonResult);
            //	}
            //	$.hsf.stopLoading();
            //});
        },
        initMultiBuyForm: function () {
            $.hsf.startLoading();
            $.hsf.ajax.app("valuavgr/fixdeclare/fixDeclareForm", "fundcode=" + action.constant.fundcode + "&warningchannel=" + $.platform.warningchannel, "chargeFormCode", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    $.hsf.hsTools.checkHgxForTrade(jsonResult, function () {//检查合规性
                        action.constant.result = jsonResult;
                        if (!jsonResult.tradeLimitResult.limits[0]) {
                            action.constant.limit = 100;
                        } else {
                            action.constant.limit = action.constant.result.tradeLimitResult.limits[0].minValue;
                        }
                        action.packFirstPage(jsonResult);
                        action.packBanklist(jsonResult);
                    });
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        /*
         * 选择日期
         * */
        selectDate: function () {
            $("#jyrq_0,#jyrq_1").UISelectField("change", function (value) {
                var day = null;
                var cycle = $("#selectCycle").UISelectField("value");
                if ($(this).parent().attr("id") == "jyrq_0") {
                    day = value;
                } else {
                    day = value - 1;
                }
                // $("#nextworkdate").html(action.getNextWorkDate(day,cycle));
                action.queryDate();
            });
        },
        /*
         * 选择交易周期
         * */
        selectCycle: function () {
            $("#selectCycle").UISelectField("change", function (value) {
                var day = null;
                if (value == "0") {
                    $("#jyrq_1").hide();
                    $("#jyrq_0").show();
                    action.constant.cycleunit = 0;
                    day = $("#jyrq_0").UISelectField("value");
                } else {
                    $("#jyrq_0").hide();
                    $("#jyrq_1").show();
                    action.constant.cycleunit = 1;
                    day = $("#jyrq_1").UISelectField("value") - 1;
                }
                action.queryDate();
            });
        },
        /*
         * jyzq:是指交易周期,就是每月(1),每周(1),每两周(2)
         * cycleunit:循环周期,每月(0),每周、每两周(1)
         * jyrq:用户选择的日期
         * */
        queryDate: function () {
            // action.constant.jyzq = $("#dingtouzhouqi").UITextField("value").trim();
            // if($("#dingtouzhouqi").UITextField("value").trim() == ""){
            // 	action.constant.jyzq = 1;
            // }
            var avgrParam = action.getAvgrParam();
            var data = "cycleunit=" + avgrParam[0]
                + "&cycle=" + avgrParam[1]
                + "&tradedate=" + avgrParam[2]
                + "&fundcode=" + action.constant.fundcode
                + "&type=5";
            // var data = "tradeacco="+action.constant.selectedTradeAcco.tradeacco+"&cycleunit="+action.constant.cycleunit+"&tradedate="+action.constant.jyrq+"&fundcode="+action.constant.fundcode+"&exptype=02"
            console.log("data=" + data);
            $.hsf.ajax.app("comquery/common/queryDate", data, "fixDeclareCallback", function (jsonResult) {
                if (jsonResult.successful) {
                    $("#nextworkdate").html($.hsf.hsTools.yyyy_mm_dd(jsonResult.date));
                }
            });
        },
        getNextWorkDate: function (dd, cycle) {
            var nowDate = new Date();
            cycle = cycle || 0;
            var month;
            if (cycle == 0) {
                if (nowDate.getDate() == dd) {
                    if (nowDate.getHours() < 15)
                        return "今天";
                }
                if (nowDate.getDate() >= dd)
                    nowDate.setMonth(nowDate.getMonth() + 1);
                if (dd)
                    nowDate.setDate(dd);
            } else {
                var dayOfWeek = nowDate.getDay();
                if (dd > dayOfWeek)
                    nowDate.setDate(nowDate.getDate() + (dd - dayOfWeek) + (cycle - 1) * 7);
                else
                    nowDate.setDate(nowDate.getDate() + (dd - dayOfWeek) + (cycle) * 7);
                if (dd == dayOfWeek && nowDate.getHours() < 15) {
                    if (cycle == 1)
                        return "今天";
                    else
                        nowDate.setDate(nowDate.getDate() - 7);
                }
            }
            month = (nowDate.getMonth() + 1);
            if (month < 10) month = "0" + month;
            var day = nowDate.getDate();
            if (day < 10) day = "0" + day;
            return nowDate.getFullYear() + "-" + month + "-" + day;
        },
        /*取银行卡后四位*/
        getLastFourNumber: function (str) {
            return str.length > 4 ? str.substr(str.length - 4, 4) : str;
        },
        formValidate: function () {
            var applysum = action.getApplySum();
            var limit = action.constant.limit;
            if ("" == applysum || parseFloat(applysum) == 0) {
                $.UIPopup("请输入定投金额");
                return false;
            }
            if (parseFloat(applysum) < limit) {
                $.UIPopup("定投金额不低于" + limit + "元");
                return false;
            }
            var oncelimit = action.constant.selectedTradeAcco.oncemaxvalue;
            if (oncelimit && parseFloat(oncelimit) * 10000 < applysum) {
                $.UIPopup("单笔交易不能高于" + oncelimit + "万元");
                return false;
            }
            return true;
        },
        getApplySum: function () {
            return $.hsf.hsTools.recoveryMoney($("#applysum").UITextField("value"));
        },
        formatAvgrDate: function (cycleunit, jyzq, jyrq) {
            if ("0" === cycleunit) {
                jyzq = "每月";
                jyrq = jyrq + "日";
            } else if ("1" === cycleunit) {
                if ("1" === jyzq) {
                    jyzq = "每周的";
                    jyrq = action.constant.weeks[jyrq];
                } else if ("2" === jyzq) {
                    jyzq = "每两周的";
                    jyrq = action.constant.weeks[jyrq];
                }
            }
            return jyzq + jyrq;
        },
        formValidate2: function () {
            var tradepassword = $("#tradepassword").UITextField("value");
//          var checkContract = $("#checkContract").UICheckBox("value");
            if ("" == tradepassword) {
                $.UIPopup("请输入交易密码");
                return false;
            }
//          if (checkContract != "yes") {
//				$.UIPopup($(".for-agree-checkbox").html());
//				return false;
//			}
            return true;
        },
        getAvgrParam: function () {
            var jyzq = $("#selectCycle").UISelectField("value");
            if (jyzq == "0") {
                var jyrq = $("#jyrq_0").UISelectField("value");
                action.constant.jyzq = 1;
                action.constant.jyrq = jyrq;
                return ["0", "1", jyrq];
            } else if (jyzq == "1") {
                var jyrq = $("#jyrq_1").UISelectField("value");
                action.constant.jyzq = 1;
                action.constant.jyrq = jyrq;
                return ["1", "1", jyrq];
            } else if (jyzq == "2") {
                var jyrq = $("#jyrq_1").UISelectField("value");
                action.constant.jyzq = 2;
                action.constant.jyrq = jyrq;
                return ["1", "2", jyrq];
            }
        },
        selectFund: function () {
            var that = this;
            $("#selectFundname").UISelectField("change", function (value) {
                if (value < action.constant.fundlist.length) {
                    action.constant.fundcode = action.constant.fundlist[value].fundcode;
                    that.initMultiBuyForm();
                }
            });
        },
        formDateToChinese: function (str) {
            return str.substr(0, 4) + "年" + str.substr(4, 2) + "月" + str.substr(6, 2) + "日";
        },
        //以下是适当性改造
        sandclock: {//倒计时方法
            run: function () {
                if (action.constant.counter == 0) {
                    $("#purchaseBtn").attr("m-state", "").html("确认");
                    action.constant.counter = -1;
                } else {
                    $("#purchaseBtn").html((action.constant.counter--) + " 秒");
                    // setTimeout("action.sandclock.run()", 1000);
                    action.constant.timer = setTimeout(action.sandclock.run.bind(action), 1000);
                }
            },
            start: function () {
                //清除上次
                if (action.constant.timer) clearTimeout(action.constant.timer);
                action.constant.counter = action.constant.repeatSeconds;
                $("#purchaseBtn").attr("m-state", "disabled").html((action.constant.counter--) + " 秒");
                setTimeout(action.sandclock.run.bind(action), 1000);
            },
            readyStart: function () {
                if (action.constant.counter == -1) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        renderAWarning: function (jsonResult) {
            //如果不是专业投资者,显示tip
            if (jsonResult.pubprofessionflag != "1") {
                $("#tip").html(jsonResult.warningAContent).UITip("show");
                this.makeTrace("A");//留痕
            }
        },
        renderBWarning: function (callback) {
            var that = this;
            var jsonResult = action.constant.result;
            if (jsonResult.pubprofessionflag != "1" && jsonResult.productRiskLevel == $.hsf.theHighestRiskLevel) {
                $.UIConfirm({
                    "html": jsonResult.warningBContent,
                    "submitText": "取消",
                    "cancelText": "确认"
                }, function (result) {
                    if (result == "no") {
                        that.makeTrace("B");
                        callback && callback.call(that);
                    }
                });
            } else {
                callback && callback.call(that);
            }
        },
        renderCWarning: function (callback) {
            var that = this;
            var jsonResult = action.constant.result;
            if (jsonResult.riskmatchResult.riskflag == "1"
                || jsonResult.riskmatchResult.riskflag == "2"
                || jsonResult.riskmatchResult.riskflag == "3") {//不匹配
                $("#tradeAgreementPage").show();
                $("#first").removeClass('view-active');
            } else {
                callback && callback.call(that);
            }
        },
        makeTrace: function (type, requestno, pflag) {
            var jsonResult = action.constant.result;
            requestno = requestno || "";
            var typestr = "warning" + type + "No";
            this.requestTrace({
                warningno: jsonResult[typestr],
                businflag: "090",
                fundcode: jsonResult.fundcode,
                content: jsonResult["warning" + type + "Content"],
                fundrisklevel: jsonResult.productRiskLevel,
                custrisktype: jsonResult.accoRiskability,
                requestno: requestno
            });
        },
        requestTrace: function (data) {
            var param = $.map(data, function (value, key) {
                return key + "=" + value
            }).join("&");
            $.hsf.ajax.app("account/risk/trace", param, "traceCallback", function (jsonResult) {
                if (jsonResult.successful) {
                }
            });
        },
        renderLowRiskLimit: function (jsonResult) {
            var minriskflag = jsonResult.minriskflag;
            var fundrisklevel = jsonResult.productRiskLevel;
            var riskflag = jsonResult.riskmatchResult.riskflag;
            if (minriskflag && fundrisklevel) {
                if ((minriskflag == "1" && fundrisklevel > $.hsf.theLowestRiskLevel) || riskflag == "3") {
                    $("#nextTo2Btn").addClass("above_risk").attr("m-state", "disabled");
                } else {
                    $("#nextTo2Btn").attr("m-state", "").removeClass("above_risk")
                }
            } else {
                $("#nextTo2Btn").attr("m-state", "").removeClass("above_risk")
            }
        }
    };
    return action;
});
