define(["JSON"], function(JSON) {
	var baseapi = {
		channel : "weixin",
    warningchannel: "2",
    serviceOnlineChannel: "13",
		putCache : putCache,
		getCache : getCache,
		removeCache : removeCache,
		removeAllCache : removeAllCache,
		tongji  :function() {},
		hsOpen : function(url) {
			window.location.href = url;
		},
		hsOpen_loc : function(url) {
			window.location.href = url;
		},
		hsOpenAndCloseSelf:function (url) {
			$.hsf.hsOpen(url);
			// baseapi.hsBack(null, "finish");
    },
    openWebPage: function(url) {
			$.hsf.hsOpen(url)
		},
		hsBack : function(url) {
			if (url && url != "") {
				window.location.href=url;
			} else {
				history.back();
			}
    },
    getDeviceId: function(func) {
			func.call(this);
		},
		getNativeImg: function(cb, elemId) {
			var canvas = document.createElement('canvas');
			var context = canvas.getContext('2d');
			var reader = new FileReader();
			var img = new Image();
			reader.onload = function(e) {
				img.src = e && e.target && e.target.result
			}
			img.onload = function() {
				// 图片原始尺寸
				var originWidth = this.width;
				var originHeight = this.height;
				var size = this.getAttribute("src").length;
				var maxSize = 1600,
						ratio = 1;
				if(Math.max(originWidth, originHeight) > maxSize) {
					ratio = Math.max(originWidth, originHeight) / maxSize;
				}
				canvas.width = Math.round(originWidth / ratio);
				canvas.height = Math.round(originHeight / ratio);

				context.clearRect(0, 0, canvas.width, canvas.height); // 清除画布
				context.drawImage(img, 0, 0, canvas.width, canvas.height); // 图片压缩

				var content = canvas.toDataURL('image/jpeg', 0.7); // canvas转为blob并上传
				cb(content);
			}
			// 压缩图片需要的一些元素和对象
			var eleFile = document.querySelector('#' + elemId).addEventListener('change', function(event) {
				var file = event.target.files[0];
				$("#file1").val("");
				$("#file2").val("");
				// 选择的文件是图片
				if(file.type.indexOf("image/jp") == 0) {
					reader.readAsDataURL(file);
				} else {
					$.UIAlert("请使用jpg/jpeg格式照片");
				}
			});
		},
		deviceReady : true
	};

	var api = {
		"login-view" : {
			channel : "web",
			initPage : function() {
				$("#rememberPassword").hide();
				$("#login [m-role=\"title\"]").html("登录");
				$("#loginButton").html("登&nbsp;&nbsp;录");
				$("#licenseName").html("《用户登录协议》且同意接受条款");
			},
			loginUrl : "account/login/login",
			loginSuccess : function() {
			}
		},
		"jinsp-buy":{
			initPage : function(action) {
				$("#rememberPw").parent().hide();
			},
			buySuccess : function() {
			}
		},
		"account-openAcco-form" : {
			loginUrl : "account/login/login"
		},
		"account-safe" : {
			initPage : function() {}
		},
		"asset" : {
			initPage : function(m) {
			}
		},
		"setting" : {
			initPage : function(m) {
			}
		},
		"xjb" : {
			initPage : function() {
				var $backBtn = $("#backBtn");
				$backBtn.unbind("tap.mhref").bind("tap", function() {
					var url = $(this).attr("m-href") || "index.html";
					window.location.href= url;
				});
			}
		},
		"about-us":{
			phoneCall : function(){
				window.location.href="tel:400-888-2666";
			},
			openWebsite : function(){
				window.location.href="http://www.csfunds.com.cn";
			}
		},
		"trade-history" : {
			initPage : function() {
				var $backBtn = $("#backBtn");
				$backBtn.unbind("tap.mhref").bind("tap", function() {
					var url = $(this).attr("m-href") || "index.html#asset";
					window.location.href= url;
				});
			}
		},
		"message" : {
			initPage : function() {
			},
		},
		"home" : {
			initPage : function(m) {

			}
		},
		"discover" : {
			initPage : function(m) {
				var $seg = $("#discover-seg").parent()
				$seg.before('<div m-role="title">超市</div>').remove();
				$(".favor-col").remove();
			}
		},
		"fund-list":{
			initPage : function(){
			}
		},
		"fund-detail":{
			changeFocusFund : function(fundcode, state) {
			},
			moveChart : function() {
				$("#placeholder").bind("touchstart", function(e) {
					e.preventDefault();
				}).bind("touchmove", function(e) {
					e.preventDefault();
				});;
			},
			discoverrefresh : function() {

			},
		},
		"attention" : {
			initPage : function(action){
			}
		},
		"account-setting": {
			initPage : function(action){
			}
		},
	};
	return {api:api, baseapi: baseapi}




























	function putCache(name, jsonResult) {
		var target = "session";
		var date = new Date();
		var storageObject = {y: date.getFullYear(),
								m: (date.getMonth()+1),
								d: date.getDate(),
								h: date.getHours(),
								r: jsonResult};
		if (target == "session") {
			putSessionStorage(name, JSON.stringify(storageObject));
		}
	}

	function getCache(name, func) {
		var cacheStr = null;
		cacheStr = getSessionStorage(name);
		if (typeof cacheStr == "string" && cacheStr != "") {
			var cache = JSON.parse(cacheStr);
			if (cache) {
				$.hsf.ajax.app("account/weixinlogin/keepalived", "", "islogin2Callback", function(jsonResult) {});
			}
			func.call(this, cache.r);
		} else {
			func.call(this, null);
		}
	}

	function removeCache(key) {
		removeLocalStorage(key);
	}

	function removeAllCache() {
		window.sessionStorage.clear();
	}

	function putLocalStorage(key,value){//把数据放到本地存储
		window.localStorage.setItem(key,JSON.stringify(value));
	}
	function getLocalStorage(key){/*获取本地存储数据*/
		var obj = window.localStorage.getItem(key);
		if(obj!=null){
			return JSON.parse(obj);
		}else{
			return null;
		}
	}
	function removeLocalStorage(key){/*清除本地数据*/
		window.localStorage.removeItem(key);
		window.sessionStorage.removeItem(key);
	}
	function putSessionStorage(key,value){//把数据放到本地存储
		window.sessionStorage.setItem(key,JSON.stringify(value));
	}
	function getSessionStorage(key){/*获取本地存储数据*/
		var obj = window.sessionStorage.getItem(key);
		if(obj!=null){
			return JSON.parse(obj);
		}else{
			return null;
		}
	}
	function removeSessionStorage(key){/*清除本地数据*/
		window.sessionStorage.removeItem(key);
	}

});


