"use strict";

(function () {
    //对外开放对象
    window.agreeComponent = {}; //公共参数
    var pdfurl='';
    window.agreeComponent.pdfurl=pdfurl;
    //公共参数
    var option = {
        color: '#49A0E2',
        title: '产品资料概要',
        readTimeout: 10,
        scrollEndCheck: true,
        type: '',
        url: '',
        agreeCallback: function agreeCallback() {}
    }; //私有参数

    //私有参数
    var privateOption = {
        alreadyTimeOut: true,
        alreadyScrollEnd: true,
        btnCanClick: false,
        interval: null
    }; //样式插入

    var hasStyle = document.getElementsByTagName("style").length > 0;
    var style = null;

    if (hasStyle) {
        style = document.getElementsByTagName("style")[0];
    } else {
        style = document.createElement("style");
        document.getElementsByTagName("head")[0].appendChild(style);
    }

    style.appendChild(document.createTextNode(".agreeIframe {\n    position: fixed;\n    width: 100%;\n    height: 90%;\n    bottom: 0px;\n    display: flex;\n    z-index: 1000;\n  }"));
    style.appendChild(document.createTextNode(".agreeBoxMark {\n    position: fixed;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    width: 100%;\n    height: 100%;\n    z-index: 999;\n    background-color:rgba(0, 0, 0, 0.3);\n  }")); //协议div的插入

    var agreeParent = document.createElement("div");
    agreeParent.setAttribute('id', 'agreeParent');
    agreeParent.setAttribute('style', ' display:block;');
    agreeParent.innerHTML = "\n    <div class=\"agreeBoxMark\" style=\"display: none\"></div>\n    <div id='agreeIframeParent' class=\"agreeIframe\" style=\"background-color:#FFF;display: none\">\n      <div style=\"flex-direction:row;align-items:center;justify-content:center;height: 40px;width: 100%;position: absolute;top: 0px;display:flex;\">\n        <p id='agreeTitle' style=\"color: #000; font-size: 16px;\">".concat(option.title, "</p>\n      </div>\n      <div style=\"flex: 1;margin-top: 40px;margin-bottom: 40px;\">\n        <iframe id='agreeIframe' style=\"width: 100%;height: 100%;\" src=\"").concat(option.url, "\" frameborder=\"0\"></iframe>\n      </div>\n      <div id='agreeBtn' style=\"flex-direction:row;align-items:center;justify-content:center;background-color:").concat(option.color, ";height: 40px;width: 100%;position: absolute;bottom: 0px;display:flex;\">\n        <p id='agreeBtnText' style=\"color: rgb(255, 255, 255); font-size: 16px;\">\u5DF2\u9605\u8BFB\u5E76\u786E\u8BA4</p>\n      </div>\n    </div>\n  ");
    var body = document.body||document.documentElement;

    if (document.getElementById('agreeParent')) {
        body.removeChild(document.getElementById('agreeParent'));
    }

    body.appendChild(agreeParent);

    var agreeBoxMark = document.getElementsByClassName('agreeBoxMark')[0]; //协议遮罩

    var agreeIframeParent = document.getElementById("agreeIframeParent"); //协议iframe父节点

    var agreeTitle = document.getElementById('agreeTitle'); //协议标题

    var agreeIframe = document.getElementById('agreeIframe'); //协议iframe

    var agreeBtn = document.getElementById('agreeBtn'); //协议按钮

    var agreeBtnText = document.getElementById('agreeBtnText'); //协议按钮上面的文字
    //事件绑定

    agreeBoxMark.addEventListener('click', function () {
        //遮罩点击事件
        agreeBoxMark.style.display = 'none';
        window.agreeComponent.hideAgree();


        if (document.getElementById('agreeParent')) {
            body.removeChild(document.getElementById('agreeParent'));
        }

        // agreeParent.height()

        return;
    });
    agreeBtn.addEventListener('click', function () {
        //同意按钮点击
        if (privateOption.btnCanClick) {
            typeof option.agreeCallback === 'function' && option.agreeCallback();
            agreeBoxMark.style.display = 'none';
            window.agreeComponent.hideAgree();


            if (document.getElementById('agreeParent')) {
                body.removeChild(document.getElementById('agreeParent'));
            }
        }

        return;
    }); //初始化方法

    window.agreeComponent.initComponent = function (param) {
        option = Object.assign(option, param);
        var url;

        if (option.type === 'pdf') {
           url = "../res/pdf/web/viewer.html?color=".concat(encodeURIComponent(option.color), "&file=").concat(encodeURIComponent(option.url));
        } else {
            url = option.url;
        }
        window.agreeComponent.pdfurl=url;
        agreeTitle.innerText = option.title;
        agreeIframe.setAttribute('src', "");
        agreeIframe.setAttribute('src', url);
        agreeBtn.style.backgroundColor = option.color;
        privateOption = {
            alreadyTimeOut: true,
            alreadyScrollEnd: true,
            btnCanClick: false
        };
    };

    var steps = 16; //步骤

    var nowStep = 0; //现在到第几步

    var stepLength;
    var height;


    var showAgreeDom = function showAgreeDom() {

        if (document.getElementById('agreeParent')){

            agreeIframeParent = document.getElementById("agreeIframeParent"); //协议iframe父节点
            agreeIframeParent.style.display = 'flex';
            agreeBoxMark = document.getElementsByClassName('agreeBoxMark')[0]; //协议遮罩
            agreeBoxMark.style.display = 'inherit';
            height = agreeIframeParent.offsetHeight;
            stepLength = height / steps; //每步需要移动的高度

            agreeIframeParent.style.transform = "translateY(".concat(height, "px)"); //把协议移动到最下面

            showAgree();
        }else {
            var hasStyle = document.getElementsByTagName("style").length > 0;
            var style = null;

            if (hasStyle) {
                style = document.getElementsByTagName("style")[0];
            } else {
                style = document.createElement("style");
                document.getElementsByTagName("head")[0].appendChild(style);
            }
            style.appendChild(document.createTextNode(".agreeIframe {\n    position: fixed;\n    width: 100%;\n    height: 90%;\n    bottom: 0px;\n    display: flex;\n    z-index: 1000;\n  }"));
            style.appendChild(document.createTextNode(".agreeBoxMark {\n    position: fixed;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    width: 100%;\n    height: 100%;\n    z-index: 999;\n    background-color:rgba(0, 0, 0, 0.3);\n  }")); //协议div的插入

            agreeParent = document.createElement("div");
            agreeParent.setAttribute('id', 'agreeParent');
            agreeParent.innerHTML = "\n    <div class=\"agreeBoxMark\" style=\"display: none\"></div>\n    <div id='agreeIframeParent' class=\"agreeIframe\" style=\"background-color:#FFF;display: none\">\n      <div style=\"flex-direction:row;align-items:center;justify-content:center;height: 40px;width: 100%;position: absolute;top: 0px;display:flex;\">\n        <p id='agreeTitle' style=\"color: #000; font-size: 16px;\">".concat(option.title, "</p>\n      </div>\n      <div style=\"flex: 1;margin-top: 40px;margin-bottom: 40px;\">\n        <iframe id='agreeIframe' style=\"width: 100%;height: 100%;\" src=\"").concat(option.url, "\" frameborder=\"0\"></iframe>\n      </div>\n      <div id='agreeBtn' style=\"flex-direction:row;align-items:center;justify-content:center;background-color:").concat(option.color, ";height: 40px;width: 100%;position: absolute;bottom: 0px;display:flex;\">\n        <p id='agreeBtnText' style=\"color: rgb(255, 255, 255); font-size: 16px;\">\u5DF2\u9605\u8BFB\u5E76\u786E\u8BA4</p>\n      </div>\n    </div>\n  ");
            var body = document.body||document.documentElement;

            if (document.getElementById('agreeParent')) {
                body.removeChild(document.getElementById('agreeParent'));
            }

            body.appendChild(agreeParent);


             agreeBoxMark = document.getElementsByClassName('agreeBoxMark')[0]; //协议遮罩

             agreeIframeParent = document.getElementById("agreeIframeParent"); //协议iframe父节点

             agreeTitle = document.getElementById('agreeTitle'); //协议标题

             agreeIframe = document.getElementById('agreeIframe'); //协议iframe

             agreeBtn = document.getElementById('agreeBtn'); //协议按钮

             agreeBtnText = document.getElementById('agreeBtnText'); //协议按钮上面的文字
            //事件绑定

            agreeBoxMark.addEventListener('click', function () {
                //遮罩点击事件
                agreeBoxMark.style.display = 'none';
                window.agreeComponent.hideAgree();


                if (document.getElementById('agreeParent')) {
                    body.removeChild(document.getElementById('agreeParent'));
                }
                

                return;
            });
            agreeBtn.addEventListener('click', function () {
                //同意按钮点击
                if (privateOption.btnCanClick) {
                    typeof option.agreeCallback === 'function' && option.agreeCallback();
                    agreeBoxMark.style.display = 'none';
                    window.agreeComponent.hideAgree();


                    if (document.getElementById('agreeParent')) {
                        body.removeChild(document.getElementById('agreeParent'));
                    }
                }

                return;
            }); //初始化方法

            //重新设置 pdf 的 url
            agreeTitle.innerText = option.title;
            agreeIframe.setAttribute('src', "");
            agreeIframe.setAttribute('src', window.agreeComponent.pdfurl);
            agreeBtn.style.backgroundColor = option.color;


            agreeIframeParent = document.getElementById("agreeIframeParent"); //协议iframe父节点
            agreeIframeParent.style.display = 'flex';
            agreeBoxMark = document.getElementsByClassName('agreeBoxMark')[0]; //协议遮罩
            agreeBoxMark.style.display = 'inherit';
            height = agreeIframeParent.offsetHeight;
            stepLength = height / steps; //每步需要移动的高度

            agreeIframeParent.style.transform = "translateY(".concat(height, "px)"); //把协议移动到最下面

            showAgree();

        }


    };

    var hideAgreeDom = function hideAgreeDom() {
        // agreeIframeParent.style.display = 'none';
        // agreeBoxMark.style.display = 'none';

        if (document.getElementById('agreeParent')) {
            body.removeChild(document.getElementById('agreeParent'));
        }



    };

    var initBtnState = function initBtnState () {
        // 当pdf只有一页的情况
        var iframes = document.getElementsByTagName("iframe");
        var currentPage = "";
        var totalPages = "";
        if (iframes && iframes[0]) {
            for(var i=0;i<iframes.length;i++){
                if($(iframes[i]).attr("id")=="agreeIframe"){
                    currentPage = iframes[i].contentWindow.PDFViewerApplication.page;
                    totalPages = iframes[i].contentWindow.PDFViewerApplication.pagesCount;
                }
            }
            // 只有一页的情况 或者 前一次滚动到最后一页，第2+次打开pdf时，页面也是最后一页；优化，pdf底部“已阅读并同意”按钮为激活状态
            if (currentPage == totalPages) {
                option.scrollEndCheck = false;
            }
        }
        //判断是否需要倒计时或者滑动到底部
        if (option.readTimeout > 0 || option.scrollEndCheck) {
            agreeBtn.style.backgroundColor = '#cccccc';
            privateOption.btnCanClick = false; //倒计时大于0的操作

            if (option.readTimeout > 0) {
                beginTimeout();
            } //需要滑到底部的操作


            if (option.scrollEndCheck) {
                if (privateOption.alreadyTimeOut) {
                    agreeBtnText.innerText = "请阅读至最后一页确认";
                }

                privateOption.alreadyScrollEnd = false;
            } else {
                privateOption.alreadyScrollEnd = true;
            }
        } else {
            privateOption.btnCanClick = true;
        }
    };

    var showAgree = function showAgree() {
        if (nowStep === 0) {
            window.requestAnimationFrame(showAgreeDom); //第一步先把协议展示出来

            // initBtnState()
            nowStep++;
            return;
        }
        nowStep++;
        if (nowStep > 16) {
            return;
        }
        var moveHeight = height - nowStep * stepLength;
        agreeIframeParent.style.transform = "translateY(".concat(moveHeight, "px)");
        window.requestAnimationFrame(showAgree);
        return;
    }

    var beginTimeout = function beginTimeout() {
        //倒计时处理
        var temp = option.readTimeout;
        privateOption.alreadyTimeOut = false;
        agreeBtnText.innerText = "已阅读并确认("+temp+"秒)";
        privateOption.interval = setInterval(function () {
            if (--temp > 0) {
                agreeBtnText.innerText = "已阅读并确认("+temp+"秒)";
            } else {
                privateOption.alreadyTimeOut = true;
                if (privateOption.alreadyScrollEnd) {
                    agreeBtnText.innerText = "已阅读并确认";
                    agreeBtn.style.backgroundColor = option.color;
                    privateOption.btnCanClick = true;
                } else {
                    agreeBtnText.innerText = "请阅读至最后一页确认";
                }
                clearInterval(privateOption.interval);
                privateOption.interval = null;
            }
        }, 1000);
    };

    var hideAgree = function hideAgree() {
        if (nowStep === 0) {
            window.requestAnimationFrame(hideAgreeDom);
            return;
        }

        nowStep--;
        var moveHeight = height - nowStep * stepLength;
        agreeIframeParent.style.transform = "translateY(".concat(moveHeight, "px)");
        // 隐藏的时候清除定时器、重置按钮
        clearInterval(privateOption.interval);
        privateOption.interval = null;
        agreeBtnText.innerText = "已阅读并确认";
        window.requestAnimationFrame(hideAgree);
    };

    window.agreeComponent.hideAgree = hideAgree;
    window.agreeComponent.showAgree = showAgree;
    window.addEventListener('message', function (ev) {
        if (ev.data.type === 'documentloaded') {
            initBtnState()
        }
        if (ev.data.type === 'pageChange' && ev.data.currentPage == ev.data.totalPage) {
            privateOption.alreadyScrollEnd = true;
            if (privateOption.alreadyTimeOut) {
                agreeBtnText.innerText = "已阅读并确认";
                agreeBtn.style.backgroundColor = option.color;
                privateOption.btnCanClick = true;
            }
        }
    });
})();